// ESOC ARIZONA
// designed by Garja

int PlayerNum = 2;
int numPlayer = 3;

include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

void main(void) 
{ 

	// Text
	rmSetStatusText("",0.10);

	// Picks the map size
	//  int playerTiles=10000; old setting
	int playerTiles = 10300;
	int size=2.0*sqrt(PlayerNum*playerTiles);
	rmEchoInfo("Map size="+size+"m x "+size+"m");
	rmSetMapSize(size, size);
	
	// rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.5, 3.0);  // original
	rmSetMapElevationParameters(cElevTurbulence,  0.08, 4, 0.7, 4.0); // type, frequency, octaves, persistence, variation 
	rmSetMapElevationHeightBlend(1);

	// Picks a default water height
	rmSetSeaLevel(4.0);

    // Picks default terrain and water
	rmSetSeaType("Amazon River");

	//float terrainPicker = rmRandFloat(0.0, 1.0);
	//if (terrainPicker <= 0.5)
	//{
	rmSetBaseTerrainMix("painteddesert_groundmix_4"); //
	//}
	//else
	//{
	//	rmSetBaseTerrainMix("painteddesert_groundmix_4");
	//}

	rmTerrainInitialize("painteddesert\pd_ground_diffuse_i", 2.0); //painteddesert\pd_ground_diffuse_i
	rmSetMapType("texas");
	rmSetMapType("desert");
	rmSetMapType("land");
	rmSetLightingSet("texas");
	
	// Set up Natives
	int subCiv0 = -1;
	int subCiv1 = -1;
	subCiv0 = rmGetCivID("Navajo");
	subCiv1 = rmGetCivID("Apache");
	rmSetSubCiv(0, "Navajo");
	rmSetSubCiv(1, "Apache");

	// Choose mercs.
	chooseMercs();

	// Corner constraint.
	rmSetWorldCircleConstraint(true);
	
	//Define some classes. These are used later for constraints.
	int classPlayer = rmDefineClass("player");
	int classEmbellishment = rmDefineClass("Embellishment");
	rmDefineClass("starting settlement");
	rmDefineClass("startingUnit");
	int classForest = rmDefineClass("Forest");
	int importantItem = rmDefineClass("importantItem");
	int classNative = rmDefineClass("natives");
	int classCliff = rmDefineClass("Cliffs");
	int classGold = rmDefineClass("Gold");
	int classStartingResource = rmDefineClass("startingResource");

	
	// ************************************ CONSTRAINTS *****************************************
	
	
	// VP avoidance
	int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint(" avoid trade route", 10.0);
	int avoidTradeRouteShort = rmCreateTradeRouteDistanceConstraint("trade route short", 3.0);
	int avoidTradeRouteSocket = rmCreateTypeDistanceConstraint("avoid trade route socket", "socketTradeRoute", 10.0);
	int avoidTradeRouteSocketShort = rmCreateTypeDistanceConstraint("avoid trade route socket short", "socketTradeRoute", 4.0);
	int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 10.0);
	
	// Coordinates and directions constraints
	int stayNorthHalf = rmCreatePieConstraint("NorthHalfConstraint", 0.50, 0.50, 0.0, rmZFractionToMeters(0.50), rmDegreesToRadians(320), rmDegreesToRadians(130));
	int staySouthHalf = rmCreatePieConstraint("SouthHalfConstraint", 0.50, 0.50, 0.0, rmZFractionToMeters(0.50), rmDegreesToRadians(140), rmDegreesToRadians(310));
	int stayWestHalf = rmCreatePieConstraint("WestHalfConstraint", 0.50, 0.50, 0.0, rmZFractionToMeters(0.50), rmDegreesToRadians(240), rmDegreesToRadians(30));
	int stayEastHalf = rmCreatePieConstraint("EastHalfConstraint", 0.50, 0.50, 0.0, rmZFractionToMeters(0.50), rmDegreesToRadians(60), rmDegreesToRadians(210));
	
	int avoidCenter = rmCreatePieConstraint("Avoid Center", 0.50, 0.50, rmZFractionToMeters(0.35), rmZFractionToMeters(0.50), rmDegreesToRadians(0), rmDegreesToRadians(360));
	int avoidEdge = rmCreatePieConstraint("Avoid Edge", 0.50, 0.50, 0.0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
	
	// Resource avoidance
	int avoidForestFar=rmCreateClassDistanceConstraint("avoid forest far", rmClassID("Forest"), 42.0); //15.0
	int avoidForest=rmCreateClassDistanceConstraint("avoid forest", rmClassID("Forest"), 25.0); //15.0
	int avoidForestShort=rmCreateClassDistanceConstraint("avoid forest  short", rmClassID("Forest"), 15.0); //15.0
	int avoidForestVeryShort=rmCreateClassDistanceConstraint("avoid forest very short", rmClassID("Forest"), 10.0); //15.0
	int avoidForestMin=rmCreateClassDistanceConstraint("avoid forest min", rmClassID("Forest"), 4.0);
//	int cliffConstraint=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 35.0);
	int avoidCliff = rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 6.0);
//	int shortAvoidCliff=rmCreateClassDistanceConstraint("short stuff vs. cliff", rmClassID("classCliff"), 8.0);
	int avoidPronghornFar = rmCreateTypeDistanceConstraint("avoid food far", "pronghorn", 50.0);
	int avoidPronghorn = rmCreateTypeDistanceConstraint("avoid food", "pronghorn", 40.0);
	int avoidPronghornMed = rmCreateTypeDistanceConstraint("avoid food med", "pronghorn", 30.0);
	int avoidPronghornMin = rmCreateTypeDistanceConstraint("avoid food min", "pronghorn", 10.0);
	int avoidBisonFar = rmCreateTypeDistanceConstraint("avoid bison far", "bison", 50.0);
	int avoidBison = rmCreateTypeDistanceConstraint("avoid bison", "bison", 48.0);
	int avoidBisonMin = rmCreateTypeDistanceConstraint("avoid bison min", "bison", 10.0);
//	int avoidGoldMed = rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 30.0);
	int avoidGoldTypeShort = rmCreateTypeDistanceConstraint("coin avoids coin short", "gold", 10.0);
	int avoidGoldType = rmCreateTypeDistanceConstraint("coin avoids coin ", "gold", 25.0);
	int avoidGoldTypeFar = rmCreateTypeDistanceConstraint("coin avoids coin far ", "gold", 60.0);
	int avoidGoldMed = rmCreateClassDistanceConstraint ("gold avoid gold med", rmClassID("Gold"), 14.0);
	int avoidGoldFar = rmCreateClassDistanceConstraint ("gold avoid gold far", rmClassID("Gold"), 64.0);
	int avoidGoldShort = rmCreateClassDistanceConstraint ("gold avoid gold far", rmClassID("Gold"), 15.0);
	int avoidNuggetFar = rmCreateTypeDistanceConstraint("nugget avoid nugget Far", "AbstractNugget", 55.0);
	int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 40.0);
	int avoidTownCenter = rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 54.0);
	int avoidTownCenterShort=rmCreateTypeDistanceConstraint("avoid Town Center short", "townCenter", 25.0);
	int avoidTownCenterFar = rmCreateTypeDistanceConstraint("avoid Town Center Far", "townCenter", 56.0);
	int avoidNatives = rmCreateClassDistanceConstraint("avoid natives", rmClassID("natives"), 10.0);
	int avoidNativesShort = rmCreateClassDistanceConstraint("avoid natives short", rmClassID("natives"), 5.0);
	int avoidStartingResources  = rmCreateClassDistanceConstraint(" avoid starting resources", rmClassID("startingResource"), 8.0);
	int avoidStartingResourcesShort  = rmCreateClassDistanceConstraint("avoid starting resources short", rmClassID("startingResource"), 3.0);
	int avoidGoat = rmCreateTypeDistanceConstraint("goat avoid goat", "ypGoat", 60.0);
	int avoidEmbellishment = rmCreateClassDistanceConstraint("avoid embellishment", rmClassID("Embellishment"), 5.0);

	// Avoid impassable land
	int avoidImpassableLand = rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 5.0);
	int avoidImpassableLandLong=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 25.0);
	int avoidImpassableLandShort = rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 3.0);
	int mediumAvoidImpassableLand=rmCreateTerrainDistanceConstraint("medium avoid impassable land", "Land", false, 15.0);
	int mediumShortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("mediumshort avoid impassable land", "Land", false, 10.0);
	int buildMesaNorth = rmCreatePieConstraint("NorthMesaConstraint", 0.52, 0.52, 0.0, rmZFractionToMeters(0.50), rmDegreesToRadians(315), rmDegreesToRadians(135));
	int buildMesaSouth = rmCreatePieConstraint("SouthMesaConstraint", 0.48, 0.48, 0.0, rmZFractionToMeters(0.50), rmDegreesToRadians(135), rmDegreesToRadians(315));

	// *****************************************************************************************
	
	// Text
	rmSetStatusText("",0.20);

	// ************************************* PLACE PLAYERS *************************************

	int teamZeroCount = rmGetNumberPlayersOnTeam(0);
	int teamOneCount = rmGetNumberPlayersOnTeam(1);
	
	// 2 team and FFA support
	float OneVOnePlacement=rmRandFloat(0.0, 0.9);
	if (PlayerNum == 2)
	{

		if ( OneVOnePlacement < 0.5)
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.27, 0.27, 0.14, 0.30, 0, 0); // disregard line end

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.73, 0.73, 0.86, 0.70, 0, 0); // disregard line end
		}
		else
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.73, 0.73, 0.86, 0.70, 0, 0);

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.27, 0.27, 0.14, 0.30, 0, 0);
		}
		
	}
/*	// Team placement
	else if ( PlayerNum == 2 && teamZeroCount == teamOneCount)
	{

		rmSetPlacementTeam(0);
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersLine(0.2, 0.2, 0.5, 0.2, 0, 0.0);

		rmSetPlacementTeam(1);
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersLine(0.8, 0.8, 0.5, 0.8, 0, 0.0);
	
	}
	// FFA support
	else if (PlayerNum > 2)
	{
      bool southSide = true;

      float spacingIncrement = (0.35 / (PlayerNum / 2));
      float spacingSouth = 0;
      float spacingNorth = 0;
      
      float southStart = 0.45;
      float southEnd = 0.82;
      float northStart = 0.95;
      float northEnd = 0.32;

      for (i = 0; < PlayerNum)
      {
         rmEchoInfo("i = "+i);
         if (southSide == true)
         {
            rmSetPlacementTeam(i);
            rmSetPlacementSection((southStart + spacingSouth), southEnd);
	         rmSetTeamSpacingModifier(0.25);
	         rmPlacePlayersCircular(0.4, 0.4, 0);
            spacingSouth = spacingSouth + spacingIncrement;
         }
         else
         {
            rmSetPlacementTeam(i);
            rmSetPlacementSection((northStart + spacingNorth), northEnd);
	         rmSetTeamSpacingModifier(0.25);
	         rmPlacePlayersCircular(0.4, 0.4, 0);
            spacingNorth = spacingNorth + spacingIncrement;
         }
         if (southSide == true)
         {
            southSide = false;
         }
         else
         {
            southSide = true;
         }
      }
   }
   else 
   {
      if (teamZeroCount < teamOneCount)
      {
         rmSetPlacementTeam(0);
         rmSetPlacementSection(0.55, 0.75);
		   rmSetTeamSpacingModifier(0.35 / teamZeroCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);

		   rmSetPlacementTeam(1);
         rmSetPlacementSection(0.95, 0.32);
		   rmSetTeamSpacingModifier(0.35 / teamOneCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);
      }
      else 
      {
         rmSetPlacementTeam(0);
         rmSetPlacementSection(0.45, 0.82);
		   rmSetTeamSpacingModifier(0.35 / teamZeroCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);

		   rmSetPlacementTeam(1);
         rmSetPlacementSection(0.0, 0.2);
		   rmSetTeamSpacingModifier(0.35 / teamOneCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);
      }
   }
*/
	// *******************************************************************************************
   
	// Text
	rmSetStatusText("",0.30);
	
	// ************************************** TRADE ROUTE ****************************************
	
	int tradeRouteID = rmCreateTradeRoute();
	int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	rmSetObjectDefAllowOverlap(socketID, true);
	rmSetObjectDefMinDistance(socketID, 0.0);
	rmSetObjectDefMaxDistance(socketID, 6.0);
	
	rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.91, 0.08); //0.91, 0.08
//	rmAddTradeRouteWaypoint(tradeRouteID, 0.45, 0.11); 
//	rmAddTradeRouteWaypoint(tradeRouteID, 0.54, 0.20); 
//	rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.50);
//	rmAddTradeRouteWaypoint(tradeRouteID, 0.54, 0.76); 
//	rmAddTradeRouteWaypoint(tradeRouteID, 0.45, 0.89); 
	rmAddTradeRouteWaypoint(tradeRouteID, 0.08, 0.91); // 0.08, 0.91
	
	bool placedTradeRouteA = rmBuildTradeRoute(tradeRouteID, "dirt");
//	if(placedTradeRouteA == false)
//	rmEchoError("Failed to place trade route 1");
//	rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
	vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.12);
	rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.36);
	rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.64);
	rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.88);
	rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	
	// ****************************************************************************************
	
	// ************************************** MESAS *******************************************

	//1
	int mesaID = rmCreateArea("mesa");
	rmSetAreaSize(mesaID, rmAreaTilesToFraction(320), rmAreaTilesToFraction(320));  
	rmSetAreaWarnFailure(mesaID, false);
	rmSetAreaCliffType(mesaID, "painteddesert");
//	rmSetAreaCliffPainting(mesaID, false, true, true, , true); //  paintGround,  paintOutsideEdge,  paintSide,  minSideHeight,  paintInsideEdge
	rmSetAreaCliffHeight(mesaID, rmRandInt(6,6), 0.0, 1.0); 
	rmSetAreaLocation (mesaID, 0.53, 0.53);
	rmSetAreaCliffEdge(mesaID, 1, 1.0, 0.1, 1.0, 0);
	rmAddAreaConstraint (mesaID, buildMesaNorth);
	rmSetAreaCoherence(mesaID, 0.8);
	int avoidMesa = rmCreateAreaDistanceConstraint("avoid mesa", mesaID, 6.0);
	int avoidMesaFar = rmCreateAreaDistanceConstraint("avoid mesa far", mesaID, 22.0);
	rmBuildArea(mesaID);	
	
	//2
	int mesa2ID = rmCreateArea("mesa2");
	rmSetAreaSize(mesa2ID, rmAreaTilesToFraction(320), rmAreaTilesToFraction(320));  
	rmSetAreaWarnFailure(mesa2ID, false);
	rmSetAreaCliffType(mesa2ID, "Painteddesert");
	rmSetAreaCliffHeight(mesa2ID, rmRandInt(6,6), 0.0, 1.0);  
	rmSetAreaLocation (mesa2ID, 0.47, 0.47);
	rmSetAreaCliffEdge(mesa2ID, 1, 1.0, 0.1, 1.0, 0);
	rmAddAreaConstraint (mesa2ID, buildMesaSouth);
	rmSetAreaCoherence(mesa2ID, 0.8);
	int avoidMesa2 = rmCreateAreaDistanceConstraint("avoid mesa2", mesa2ID, 6.0);
	int avoidMesa2Far = rmCreateAreaDistanceConstraint("avoid mesa2 far", mesa2ID, 22.0);
	rmBuildArea(mesa2ID);
	
	// **************************************************************************************
	
		// Text
	rmSetStatusText("",0.40);
	
	// ************************************ NATIVES *****************************************

	int nativeID0 = -1;
    int nativeID1 = -1;
	int nativeID2 = -1;
    int nativeID3 = -1;
		
	nativeID0 = rmCreateGrouping("navajo village A", "native navajo village "+1);
    rmSetGroupingMinDistance(nativeID0, 0.0);
    rmSetGroupingMaxDistance(nativeID0, 0.00);
	rmAddGroupingToClass(nativeID0, rmClassID("natives"));
    rmAddGroupingToClass(nativeID0, rmClassID("importantItem"));
	rmPlaceGroupingAtLoc(nativeID0, 0, 0.12, 0.58);
	
	nativeID2 = rmCreateGrouping("navajo village B", "native navajo village "+4);
    rmSetGroupingMinDistance(nativeID2, 0.0);
    rmSetGroupingMaxDistance(nativeID2, 0.00);
	rmAddGroupingToClass(nativeID2, rmClassID("natives"));
    rmAddGroupingToClass(nativeID2, rmClassID("importantItem"));
	rmPlaceGroupingAtLoc(nativeID2, 0, 0.84, 0.40);
	
	nativeID1 = rmCreateGrouping("apache village A", "native apache village "+1);
    rmSetGroupingMinDistance(nativeID1, 0.0);
    rmSetGroupingMaxDistance(nativeID1, 0.00);
	rmAddGroupingToClass(nativeID1, rmClassID("natives"));
    rmAddGroupingToClass(nativeID1, rmClassID("importantItem"));
	rmPlaceGroupingAtLoc(nativeID1, 0, 0.40, 0.86); // 0.28, 0.25
	
	nativeID3 = rmCreateGrouping("apache village B", "native apache village "+5);
    rmSetGroupingMinDistance(nativeID3, 0.0);
    rmSetGroupingMaxDistance(nativeID3, 0.00);
	rmAddGroupingToClass(nativeID3, rmClassID("natives"));
    rmAddGroupingToClass(nativeID3, rmClassID("importantItem"));
	rmPlaceGroupingAtLoc(nativeID3, 0, 0.58, 0.14); // 0.28, 0.75
	
	// *************************************************************************************
	
	// Text
	rmSetStatusText("",0.50);

	// *************************** PLAYER STARTING RESOURCES *******************************

	// ***** Define *****
	
	// Town center & units
	int TCID = rmCreateObjectDef("player TC");
	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
	rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
	rmAddObjectDefToClass(TCID, classStartingResource);
	}
	rmSetObjectDefMinDistance(TCID, 0.0);
	rmSetObjectDefMaxDistance(TCID, 0.0);
	
	// Starting mines
	int playergoldID = rmCreateObjectDef("player mine");
	rmAddObjectDefItem(playergoldID, "MineCopper", 1, 0);
	rmSetObjectDefMinDistance(playergoldID, 13.0);
	rmSetObjectDefMaxDistance(playergoldID, 18.0);
	rmAddObjectDefToClass(playergoldID, classStartingResource);
	rmAddObjectDefToClass(playergoldID, classGold);
	rmAddObjectDefConstraint(playergoldID, avoidGoldType);
	rmAddObjectDefConstraint(playergoldID, avoidTradeRoute);
	rmAddObjectDefConstraint(playergoldID, avoidImpassableLand);
	rmAddObjectDefConstraint(playergoldID, avoidNatives);
	rmAddObjectDefConstraint(playergoldID, avoidStartingResources);
	
	// 3rd mine
	int playergold2ID = rmCreateObjectDef("player second mine");
	rmAddObjectDefItem(playergold2ID, "MineCopper", 1, 0);
	rmSetObjectDefMinDistance(playergold2ID, 68.0); //58
	rmSetObjectDefMaxDistance(playergold2ID, 70.0); //62
//	rmAddObjectDefToClass(playergold2ID, classStartingResource);
	rmAddObjectDefToClass(playergold2ID, classGold);
	rmAddObjectDefConstraint(playergold2ID, avoidGoldTypeFar);
	rmAddObjectDefConstraint(playergold2ID, avoidTradeRoute);
	rmAddObjectDefConstraint(playergold2ID, avoidImpassableLand);
	rmAddObjectDefConstraint(playergold2ID, avoidNatives);
	rmAddObjectDefConstraint(playergold2ID, avoidStartingResources);
	rmAddObjectDefConstraint(playergold2ID, avoidMesaFar);
	rmAddObjectDefConstraint(playergold2ID, avoidMesa2Far);
//	rmAddObjectDefConstraint(playergold2ID, avoidCenter);
	
/*	// Closest trees 
	int playercloseTreeID = rmCreateObjectDef("player close tree");
    rmAddObjectDefItem(playercloseTreeID, "TreePaintedDesert", rmRandInt(1,1), 1.0);
    rmSetObjectDefMinDistance(playercloseTreeID, 8);
    rmSetObjectDefMaxDistance(playercloseTreeID, 12);
//	rmAddObjectDefToClass(playercloseTreeID, classForest);
//	rmAddObjectDefConstraint(playercloseTreeID, avoidForest);
//	rmAddObjectDefToClass(playercloseTreeID, classStartingResource);
    rmAddObjectDefConstraint(playercloseTreeID, avoidImpassableLand);
//	rmAddObjectDefConstraint(playercloseTreeID, avoidStartingResources);
*/	
	// Starting berries
	int playerberriesID = rmCreateObjectDef("player berries");
	rmAddObjectDefItem(playerberriesID, "berrybush", 3, 3.0);
	rmSetObjectDefMinDistance(playerberriesID, 13.0);
	rmSetObjectDefMaxDistance(playerberriesID, 15.0);
	rmAddObjectDefToClass(playerberriesID, classStartingResource);
	rmAddObjectDefConstraint(playerberriesID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerberriesID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerberriesID, avoidNatives);
	rmAddObjectDefConstraint(playerberriesID, avoidStartingResources);
	
	// Starting herd
	int playerbisonID = rmCreateObjectDef("starting bisons");
	rmAddObjectDefItem(playerbisonID, "bison", 1, 5.0);
	rmSetObjectDefMinDistance(playerbisonID, 8.0);
	rmSetObjectDefMaxDistance(playerbisonID, 10.0);
	rmSetObjectDefCreateHerd(playerbisonID, false);
	rmAddObjectDefToClass(playerbisonID, classStartingResource);
	rmAddObjectDefConstraint(playerbisonID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerbisonID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerbisonID, avoidNatives);
	rmAddObjectDefConstraint(playerbisonID, avoidStartingResourcesShort);
	
	// Starting trees 
	int playerTreeID = rmCreateObjectDef("player trees");
    rmAddObjectDefItem(playerTreeID, "TreePaintedDesert", rmRandInt(2,2), 2.0);
    rmSetObjectDefMinDistance(playerTreeID, 12);
    rmSetObjectDefMaxDistance(playerTreeID, 18);
	rmAddObjectDefToClass(playerTreeID, classForest);
	rmAddObjectDefConstraint(playerTreeID, avoidForestVeryShort);
	rmAddObjectDefToClass(playerTreeID, classStartingResource);
	rmAddObjectDefConstraint(playerTreeID, avoidTradeRoute);
    rmAddObjectDefConstraint(playerTreeID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerTreeID, avoidStartingResources);
	
	// 2nd herd
	int playerPronghornID = rmCreateObjectDef("player pronghorn");
    rmAddObjectDefItem(playerPronghornID, "pronghorn", rmRandInt(9,9), 7.0);
    rmSetObjectDefMinDistance(playerPronghornID, 30);
    rmSetObjectDefMaxDistance(playerPronghornID, 34);
	rmAddObjectDefToClass(playerPronghornID, classStartingResource);
	rmSetObjectDefCreateHerd(playerPronghornID, true);
	rmAddObjectDefConstraint(playerPronghornID, avoidPronghorn); 
	rmAddObjectDefConstraint(playerPronghornID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerPronghornID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerPronghornID, avoidNatives);
	rmAddObjectDefConstraint(playerPronghornID, avoidStartingResources);
	rmAddObjectDefConstraint(playerPronghornID, avoidMesaFar);
	rmAddObjectDefConstraint(playerPronghornID, avoidMesa2Far);
	rmAddObjectDefConstraint(playerPronghornID, avoidCenter);
	
	// 3rd herd
	int playerPronghorn2ID = rmCreateObjectDef("player pronghorn2");
    rmAddObjectDefItem(playerPronghorn2ID, "pronghorn", rmRandInt(9,9), 7.0);
    rmSetObjectDefMinDistance(playerPronghorn2ID, 36);
    rmSetObjectDefMaxDistance(playerPronghorn2ID, 40);
	rmAddObjectDefToClass(playerPronghorn2ID, classStartingResource);
	rmSetObjectDefCreateHerd(playerPronghorn2ID, true);
	rmAddObjectDefConstraint(playerPronghorn2ID, avoidPronghornFar); 
	rmAddObjectDefConstraint(playerPronghorn2ID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerPronghorn2ID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerPronghorn2ID, avoidNatives);
	rmAddObjectDefConstraint(playerPronghorn2ID, avoidStartingResources);
	rmAddObjectDefConstraint(playerPronghorn2ID, avoidMesaFar);
	rmAddObjectDefConstraint(playerPronghorn2ID, avoidMesa2Far);
	
/*	// 4rd herd
	int playerPronghorn3ID = rmCreateObjectDef("player pronghorn3");
    rmAddObjectDefItem(playerPronghorn3ID, "pronghorn", rmRandInt(10,12), 7.0);
    rmSetObjectDefMinDistance(playerPronghorn3ID, 48);
    rmSetObjectDefMaxDistance(playerPronghorn3ID, 52);
	rmAddObjectDefToClass(playerPronghorn3ID, classStartingResource);
	rmSetObjectDefCreateHerd(playerPronghorn3ID, true);
	rmAddObjectDefConstraint(playerPronghorn3ID, avoidPronghorn); 
	rmAddObjectDefConstraint(playerPronghorn3ID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerPronghorn3ID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerPronghorn3ID, avoidNatives);
	rmAddObjectDefConstraint(playerPronghorn3ID, avoidStartingResources);
	rmAddObjectDefConstraint(playerPronghorn3ID, avoidMesaFar);
	rmAddObjectDefConstraint(playerPronghorn3ID, avoidMesa2Far);
*/	
	// Starting treasures
	int playerNuggetID = rmCreateObjectDef("player nugget"); 
	rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
	rmSetNuggetDifficulty(1, 1);
	rmSetObjectDefMinDistance(playerNuggetID, 22.0);
	rmSetObjectDefMaxDistance(playerNuggetID, 30.0);
	rmAddObjectDefToClass(playerNuggetID, classStartingResource);
	rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerNuggetID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerNuggetID, avoidNatives);
	rmAddObjectDefConstraint(playerNuggetID, avoidStartingResources);
	rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	int nugget0count = rmRandInt (2,2); //1,2
	
	// ***** Place *****
	
	for(i=1; <numPlayer)
	{
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));

		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
//		rmPlaceObjectDefAtLoc(playercloseTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergoldID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergoldID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerberriesID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerbisonID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerbisonID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerbisonID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerbisonID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergold2ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerNuggetID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		if (nugget0count == 2)
			rmPlaceObjectDefAtLoc(playerNuggetID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerPronghornID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerPronghorn2ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
//		rmPlaceObjectDefAtLoc(playerPronghorn3ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		
		if(ypIsAsian(i) && rmGetNomadStart() == false)
		rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i), i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

		vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
	}
	
	// **************************************************************************************
	
	// Text
	rmSetStatusText("",0.60);
	
	// ********************************* COMMON RESOURCES ***********************************
   
   
	// ******** Mines *********
		
	int halfgoldCount = rmRandInt(6,6);  // 3,3 
	
	//South mines
	for(i=0; < halfgoldCount)
	{
		int sidegoldID = rmCreateObjectDef("gold south half"+i);
		rmAddObjectDefItem(sidegoldID, "MineCopper", 1, 0.0);
		rmSetObjectDefMinDistance(sidegoldID, 0.0);
		rmSetObjectDefMaxDistance(sidegoldID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(sidegoldID, classGold);
		rmAddObjectDefConstraint(sidegoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(sidegoldID, avoidImpassableLand);
		rmAddObjectDefConstraint(sidegoldID, avoidNatives);
		rmAddObjectDefConstraint(sidegoldID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(sidegoldID, avoidGoldFar);
		rmAddObjectDefConstraint(sidegoldID, avoidTownCenterFar);
		rmAddObjectDefConstraint(sidegoldID, avoidMesaFar);
		rmAddObjectDefConstraint(sidegoldID, avoidMesa2Far);
		rmAddObjectDefConstraint(sidegoldID, avoidEdge);
		if (i < 2)
			rmAddObjectDefConstraint(sidegoldID, stayWestHalf);
		else if (i < 4)
			rmAddObjectDefConstraint(sidegoldID, stayEastHalf);
		if (i==0 || i==2)
			rmAddObjectDefConstraint(sidegoldID, staySouthHalf);	
		else if (i==1 || i==3)
			rmAddObjectDefConstraint(sidegoldID, stayNorthHalf);	
		else if (i==4)
			rmAddObjectDefConstraint(sidegoldID, staySouthHalf);
		else
			rmAddObjectDefConstraint(sidegoldID, stayNorthHalf);
		rmPlaceObjectDefAtLoc(sidegoldID, 0, 0.50, 0.50);
	}
/*
	//North mines
	for(i=0; < halfgoldCount)
	{
		int sidegold2ID = rmCreateObjectDef("gold north half"+i);
		rmAddObjectDefItem(sidegold2ID, "MineCopper", 1, 0.0);
		rmSetObjectDefMinDistance(sidegold2ID, 0.0);
		rmSetObjectDefMaxDistance(sidegold2ID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(sidegold2ID, classGold);
		rmAddObjectDefConstraint(sidegold2ID, avoidTradeRoute);
		rmAddObjectDefConstraint(sidegold2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(sidegold2ID, avoidNatives);
		rmAddObjectDefConstraint(sidegold2ID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(sidegold2ID, avoidGoldFar);
		rmAddObjectDefConstraint(sidegold2ID, stayNorthHalf);
		rmAddObjectDefConstraint(sidegold2ID, avoidTownCenterFar);
		rmAddObjectDefConstraint(sidegold2ID, avoidMesaFar);
		rmAddObjectDefConstraint(sidegold2ID, avoidEdge);
		if (i==0)
			rmAddObjectDefConstraint(sidegold2ID, stayWestHalf);
		else if (i==1)
			rmAddObjectDefConstraint(sidegold2ID, stayEastHalf);
		rmPlaceObjectDefAtLoc(sidegold2ID, 0, 0.50, 0.50);
	}
*/
	// ************************
	
	// Text
	rmSetStatusText("",0.70);
	
	// ******* Forests ********
	
	//South forest main
	for (i=0; < 12)
	{
		int forestsouthID = rmCreateArea("forest south"+i);
		rmSetAreaWarnFailure(forestsouthID, false);
		rmSetAreaSize(forestsouthID, rmAreaTilesToFraction(135), rmAreaTilesToFraction(145));
		rmSetAreaForestType(forestsouthID, "painteddesert forest");
//		rmSetAreaObeyWorldCircleConstraint(forestsouthID, false);
		rmSetAreaForestDensity(forestsouthID, 0.85);
		rmSetAreaForestClumpiness(forestsouthID, 0.30);
		rmSetAreaForestUnderbrush(forestsouthID, 0.5);
		rmSetAreaMinBlobs(forestsouthID, 1);
		rmSetAreaMaxBlobs(forestsouthID, 4);
		rmSetAreaMinBlobDistance(forestsouthID, 10.0);
		rmSetAreaMaxBlobDistance(forestsouthID, 28.0);
		rmSetAreaCoherence(forestsouthID, 1.0);
		rmSetAreaSmoothDistance(forestsouthID, 6);
		rmAddAreaToClass(forestsouthID, classForest);
		rmAddAreaConstraint(forestsouthID, avoidForest);
		rmAddAreaConstraint(forestsouthID, avoidTradeRouteShort);
		rmAddAreaConstraint(forestsouthID, avoidImpassableLand);
		rmAddAreaConstraint(forestsouthID, avoidNatives);
		rmAddAreaConstraint(forestsouthID, avoidTradeRouteSocket);
		rmAddAreaConstraint(forestsouthID, avoidGoldMed);
		rmAddAreaConstraint(forestsouthID, avoidTownCenterShort);
		rmAddAreaConstraint(forestsouthID, avoidMesa2Far);
		rmAddAreaConstraint(forestsouthID, avoidPronghornMin); 
		rmAddAreaConstraint(forestsouthID, avoidBisonMin); 
		rmAddAreaConstraint(forestsouthID, staySouthHalf);
		rmBuildArea(forestsouthID);
	}
	
	//North forest main
	for (i=0; < 12)
	{
		int forestnorthID = rmCreateArea("forest north"+i);
		rmSetAreaWarnFailure(forestnorthID, false);
		rmSetAreaSize(forestnorthID, rmAreaTilesToFraction(135), rmAreaTilesToFraction(145));
		rmSetAreaForestType(forestnorthID, "painteddesert forest");
//		rmSetAreaObeyWorldCircleConstraint(forestnorthID, false);
		rmSetAreaForestDensity(forestnorthID, 0.85);
		rmSetAreaForestClumpiness(forestnorthID, 0.30);
		rmSetAreaForestUnderbrush(forestnorthID, 0.5);
		rmSetAreaMinBlobs(forestnorthID, 1);
		rmSetAreaMaxBlobs(forestnorthID, 4);
		rmSetAreaMinBlobDistance(forestnorthID, 10.0);
		rmSetAreaMaxBlobDistance(forestnorthID, 28.0);
		rmSetAreaCoherence(forestnorthID, 1.0);
		rmSetAreaSmoothDistance(forestnorthID, 6);
		rmAddAreaToClass(forestnorthID, classForest);
		rmAddAreaConstraint(forestnorthID, avoidForest);
		rmAddAreaConstraint(forestnorthID, avoidTradeRouteShort);
		rmAddAreaConstraint(forestnorthID, avoidImpassableLand);
		rmAddAreaConstraint(forestnorthID, avoidNatives);
		rmAddAreaConstraint(forestnorthID, avoidTradeRouteSocket);
		rmAddAreaConstraint(forestnorthID, avoidGoldMed);
		rmAddAreaConstraint(forestnorthID, stayNorthHalf);
		rmAddAreaConstraint(forestnorthID, avoidTownCenterShort);
		rmAddAreaConstraint(forestnorthID, avoidMesaFar);
		rmAddAreaConstraint(forestnorthID, avoidPronghornMin); 
		rmAddAreaConstraint(forestnorthID, avoidBisonMin); 
		rmBuildArea(forestnorthID);
	}
/*	
	// South half trees small
	int southforestsmallID = rmCreateObjectDef("forest south small");
	rmAddObjectDefItem(southforestsmallID, "TreePaintedDesert", rmRandInt(5,6), 4.0);
	rmSetObjectDefMinDistance(southforestsmallID, 0);
	rmSetObjectDefMaxDistance(southforestsmallID, rmXFractionToMeters(0.5));
	rmAddObjectDefToClass(southforestsmallID, classForest);
	rmAddObjectDefConstraint(southforestsmallID, avoidForestShort);
	rmAddObjectDefConstraint(southforestsmallID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(southforestsmallID, avoidImpassableLand);
	rmAddObjectDefConstraint(southforestsmallID, avoidNatives);
	rmAddObjectDefConstraint(southforestsmallID, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(southforestsmallID, avoidGoldTypeShort);
	rmAddObjectDefConstraint(southforestsmallID, staySouthHalf);
	rmAddObjectDefConstraint(southforestsmallID, avoidTownCenterShort);
	rmAddObjectDefConstraint(southforestsmallID, avoidMesa2);
	rmAddObjectDefConstraint(southforestsmallID, avoidPronghornMin); 
	rmAddObjectDefConstraint(southforestsmallID, avoidBisonMin); 
		
	int forestsmallcount = rmRandInt(4,4); //6,8
		
	for (i=0; < forestsmallcount)
	{
		rmPlaceObjectDefAtLoc(southforestsmallID, 0, 0.50, 0.50);
	}
	
	// North half trees small
	int northforestsmallID = rmCreateObjectDef("forest north small");
    rmAddObjectDefItem(northforestsmallID, "TreePaintedDesert", rmRandInt(5,6), 4.0);
    rmSetObjectDefMinDistance(northforestsmallID, 0);
    rmSetObjectDefMaxDistance(northforestsmallID, rmXFractionToMeters(0.5));
	rmAddObjectDefToClass(northforestsmallID, classForest);
	rmAddObjectDefConstraint(northforestsmallID, avoidForestShort);
	rmAddObjectDefConstraint(northforestsmallID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(northforestsmallID, avoidImpassableLand);
	rmAddObjectDefConstraint(northforestsmallID, avoidNatives);
	rmAddObjectDefConstraint(northforestsmallID, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(northforestsmallID, avoidGoldTypeShort);
	rmAddObjectDefConstraint(northforestsmallID, stayNorthHalf);
	rmAddObjectDefConstraint(northforestsmallID, avoidTownCenterShort);
	rmAddObjectDefConstraint(northforestsmallID, avoidMesa);
	rmAddObjectDefConstraint(northforestsmallID, avoidPronghornMin); 
	rmAddObjectDefConstraint(northforestsmallID, avoidBisonMin); 
	
	for (i=0; < forestsmallcount)
	{
		rmPlaceObjectDefAtLoc(northforestsmallID, 0, 0.50, 0.50);
	}
*/	
	// ******** Herds *********
		
	int halfbisonCount = rmRandInt(1,1);  
	
	//South bisons
	for(i=0; < halfbisonCount)
	{
		int southbisonID = rmCreateObjectDef("south bisons"+i);
		rmAddObjectDefItem(southbisonID, "bison", rmRandInt(8,8), 8.0);
		rmSetObjectDefMinDistance(southbisonID, rmXFractionToMeters(0.13));
		rmSetObjectDefMaxDistance(southbisonID, rmXFractionToMeters(0.14));
		rmSetObjectDefCreateHerd(southbisonID, true);
//		rmAddObjectDefConstraint(southbisonID, avoidTradeRoute);
		rmAddObjectDefConstraint(southbisonID, avoidImpassableLand);
		rmAddObjectDefConstraint(southbisonID, avoidNatives);
		rmAddObjectDefConstraint(southbisonID, avoidTradeRouteSocketShort);
		rmAddObjectDefConstraint(southbisonID, avoidGoldShort);
		rmAddObjectDefConstraint(southbisonID, staySouthHalf);
		rmAddObjectDefConstraint(southbisonID, avoidTownCenterFar);
		rmAddObjectDefConstraint(southbisonID, avoidMesa2);
		rmAddObjectDefConstraint(southbisonID, avoidPronghorn); 
		rmAddObjectDefConstraint(southbisonID, avoidBisonFar); 
		rmPlaceObjectDefAtLoc(southbisonID, 0, 0.50, 0.50);
	}

	//North bisons
	for(i=0; < halfbisonCount)
	{
		int northbisonID = rmCreateObjectDef("north bisons"+i);
		rmAddObjectDefItem(northbisonID, "bison", rmRandInt(8,8), 8.0);
		rmSetObjectDefMinDistance(northbisonID, rmXFractionToMeters(0.12));
		rmSetObjectDefMaxDistance(northbisonID, rmXFractionToMeters(0.14));
		rmSetObjectDefCreateHerd(northbisonID, true);
//		rmAddObjectDefConstraint(northbisonID, avoidTradeRoute);
		rmAddObjectDefConstraint(northbisonID, avoidImpassableLand);
		rmAddObjectDefConstraint(northbisonID, avoidNatives);
		rmAddObjectDefConstraint(northbisonID, avoidTradeRouteSocketShort);
		rmAddObjectDefConstraint(northbisonID, avoidGoldShort);
		rmAddObjectDefConstraint(northbisonID, stayNorthHalf);
		rmAddObjectDefConstraint(northbisonID, avoidTownCenterFar);
		rmAddObjectDefConstraint(northbisonID, avoidMesa);
		rmAddObjectDefConstraint(northbisonID, avoidPronghorn); 
		rmAddObjectDefConstraint(northbisonID, avoidBisonFar); 
		rmPlaceObjectDefAtLoc(northbisonID, 0, 0.50, 0.50);
	}
	
	int pronghornCount = rmRandInt(6,6);  // 3,3 
	
	//South pronghorns
	for(i=0; < pronghornCount)
	{
		int southpronghornID = rmCreateObjectDef("pronghorn"+i);
		rmAddObjectDefItem(southpronghornID, "pronghorn", rmRandInt(9,9), 7.0);
		rmSetObjectDefMinDistance(southpronghornID, 0.0);
		rmSetObjectDefMaxDistance(southpronghornID, rmXFractionToMeters(0.5));
		rmSetObjectDefCreateHerd(southpronghornID, true);
//		rmAddObjectDefConstraint(southpronghornID, avoidTradeRoute);
		rmAddObjectDefConstraint(southpronghornID, avoidImpassableLand);
		rmAddObjectDefConstraint(southpronghornID, avoidNativesShort);
		rmAddObjectDefConstraint(southpronghornID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(southpronghornID, avoidGoldTypeShort);
		rmAddObjectDefConstraint(southpronghornID, avoidTownCenterFar);
		rmAddObjectDefConstraint(southpronghornID, avoidMesaFar);
		rmAddObjectDefConstraint(southpronghornID, avoidMesa2Far);
		rmAddObjectDefConstraint(southpronghornID, avoidPronghornFar); 
		rmAddObjectDefConstraint(southpronghornID, avoidBison); 
		rmAddObjectDefConstraint(southpronghornID, avoidForestMin); 
//		rmAddObjectDefConstraint(southpronghornID, avoidEdge);
		if (i < 2)
			rmAddObjectDefConstraint(southpronghornID, stayWestHalf);
		else if (i < 4)
			rmAddObjectDefConstraint(southpronghornID, stayEastHalf);
		if (i==0 || i==2)
			rmAddObjectDefConstraint(southpronghornID, staySouthHalf);	
		else if (i==1 || i==3)
			rmAddObjectDefConstraint(southpronghornID, stayNorthHalf);	
		else if (i==4)
			rmAddObjectDefConstraint(southpronghornID, staySouthHalf);
		else
			rmAddObjectDefConstraint(southpronghornID, stayNorthHalf);
		rmPlaceObjectDefAtLoc(southpronghornID, 0, 0.50, 0.50);
	}
/*
	//North pronghorns
	for(i=0; < halfpronghornCount)
	{
		int northpronghornID = rmCreateObjectDef("north pronghorn"+i);
		rmAddObjectDefItem(northpronghornID, "pronghorn", rmRandInt(9,9), 7.0);
		rmSetObjectDefMinDistance(northpronghornID, 0.0);
		rmSetObjectDefMaxDistance(northpronghornID, rmXFractionToMeters(0.5));
		rmSetObjectDefCreateHerd(northpronghornID, true);
		rmAddObjectDefConstraint(northpronghornID, avoidTradeRoute);
		rmAddObjectDefConstraint(northpronghornID, avoidImpassableLand);
		rmAddObjectDefConstraint(northpronghornID, avoidNatives);
		rmAddObjectDefConstraint(northpronghornID, avoidImportantItem);
		rmAddObjectDefConstraint(northpronghornID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(northpronghornID, avoidGoldMed);
		rmAddObjectDefConstraint(northpronghornID, stayNorthHalf);
		rmAddObjectDefConstraint(northpronghornID, avoidTownCenterFar);
		rmAddObjectDefConstraint(northpronghornID, avoidMesaFar);
		rmAddObjectDefConstraint(northpronghornID, avoidPronghornFar); 
		rmAddObjectDefConstraint(northpronghornID, avoidBison); 
		rmAddObjectDefConstraint(northpronghornID, avoidForestMin); 
//		rmAddObjectDefConstraint(northpronghornID, avoidEdge);
		if (i==0)
			rmAddObjectDefConstraint(northpronghornID, stayWestHalf);
		else if (i==1)
			rmAddObjectDefConstraint(northpronghornID, stayEastHalf);
		rmPlaceObjectDefAtLoc(northpronghornID, 0, 0.50, 0.50);
	}
*/	
	// *************************
	
	// Text
	rmSetStatusText("",0.90);
	
	// ****** Treasures *******
	
	// Treasures south	
	int NuggetsouthID = rmCreateObjectDef("South nugget"); 
	rmAddObjectDefItem(NuggetsouthID, "Nugget", 1, 0.0);
	rmSetNuggetDifficulty(2, 2);
	rmSetObjectDefMinDistance(NuggetsouthID, 0);
    rmSetObjectDefMaxDistance(NuggetsouthID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(NuggetsouthID, avoidTownCenterFar);
	rmAddObjectDefConstraint(NuggetsouthID, avoidNuggetFar);
	rmAddObjectDefConstraint(NuggetsouthID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(NuggetsouthID, avoidTradeRouteSocket);
    rmAddObjectDefConstraint(NuggetsouthID, avoidImportantItem);
	rmAddObjectDefConstraint(NuggetsouthID, avoidImpassableLand);
	rmAddObjectDefConstraint(NuggetsouthID, avoidGoldTypeShort);
	rmAddObjectDefConstraint(NuggetsouthID, avoidForestMin); 
	rmAddObjectDefConstraint(NuggetsouthID, staySouthHalf);
	rmAddObjectDefConstraint(NuggetsouthID, avoidMesa2);
	rmAddObjectDefConstraint(NuggetsouthID, avoidPronghornMin); 
	rmAddObjectDefConstraint(NuggetsouthID, avoidBisonMin); 
	rmAddObjectDefConstraint(NuggetsouthID, avoidEdge); 
	
	int	nugget2count = rmRandInt(4,4); //2,2
	
	for (i=0; < nugget2count)
	{
		rmPlaceObjectDefAtLoc(NuggetsouthID, 0, 0.5, 0.5);
	}
	
	// Treasures north
	int NuggetnorthID = rmCreateObjectDef("North nugget"); 
	rmAddObjectDefItem(NuggetnorthID, "Nugget", 1, 0.0);
	rmSetNuggetDifficulty(2, 2);
	rmSetObjectDefMinDistance(NuggetnorthID, 0);
    rmSetObjectDefMaxDistance(NuggetnorthID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(NuggetnorthID, avoidTownCenterFar);
	rmAddObjectDefConstraint(NuggetnorthID, avoidNuggetFar);
	rmAddObjectDefConstraint(NuggetnorthID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(NuggetnorthID, avoidTradeRouteSocket);
    rmAddObjectDefConstraint(NuggetnorthID, avoidImportantItem);
	rmAddObjectDefConstraint(NuggetnorthID, avoidImpassableLand);
	rmAddObjectDefConstraint(NuggetnorthID, avoidGoldTypeShort);
	rmAddObjectDefConstraint(NuggetnorthID, avoidForestMin); 
	rmAddObjectDefConstraint(NuggetnorthID, stayNorthHalf);
	rmAddObjectDefConstraint(NuggetnorthID, avoidMesa);
	rmAddObjectDefConstraint(NuggetnorthID, avoidPronghornMin); 
	rmAddObjectDefConstraint(NuggetnorthID, avoidBisonMin); 
	rmAddObjectDefConstraint(NuggetnorthID, avoidEdge); 
	
	for (i=0; < nugget2count)
	{
		rmPlaceObjectDefAtLoc(NuggetnorthID, 0, 0.5, 0.5);
	}
	
	// ***********************
	
	// **** Embellishments ***
	
	//Eagle
	int eaglespawn = rmRandInt (1,4);
		
	int EagleID = rmCreateObjectDef("eagle");
	rmAddObjectDefItem(EagleID, "PropEaglesRocks", 1, 1.0); 
	rmSetObjectDefMinDistance(EagleID, 0);
	rmSetObjectDefMaxDistance(EagleID, 2);
	rmAddObjectDefToClass(EagleID, rmClassID("Embellishment"));
	rmAddObjectDefConstraint(EagleID, avoidEmbellishment);
	if (eaglespawn == 1)
		rmPlaceObjectDefAtLoc(EagleID, 0, 0.52, 0.57);
	else if (eaglespawn == 2)
		rmPlaceObjectDefAtLoc(EagleID, 0, 0.57, 0.52);
	else if (eaglespawn == 3)
		rmPlaceObjectDefAtLoc(EagleID, 0, 0.42, 0.47);
	else if (eaglespawn == 4)
		rmPlaceObjectDefAtLoc(EagleID, 0, 0.47, 0.42);
	
	// ***********************
	
	// Text
	rmSetStatusText("",1.00);
	
} // END