// ESOC ARKANSAS
// designed by Garja

int PlayerNum=2;
int numPlayer=3;

include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

// Main entry point for random map script
void main(void)
{
		
	// Text
	// These status text lines are used to manually animate the map generation progress bar
	rmSetStatusText("",0.01); 
	
	// ************************************** GENERAL FEATURES *****************************************
	
	// Picks the map size
	int playerTiles=11000; //12000
	int size=2.0*sqrt(PlayerNum*playerTiles); //2.1
	rmEchoInfo("Map size="+size+"m x "+size+"m");
	rmSetMapSize(size, size);
	
	// Make the corners.
//	rmSetWorldCircleConstraint(false);
	

	
	// Picks a default water height
	rmSetSeaLevel(2.0);	// this is height of river surface compared to surrounding land. River depth is in the river XML.

	rmSetMapElevationParameters(cElevTurbulence, 0.05, 4, 0.5, 5.0); // type, frequency, octaves, persistence, variation 
//	rmSetMapElevationHeightBlend(1);
	
	// Picks default terrain and water
	rmSetSeaType("bayou");
//	rmEnableLocalWater(false);
	rmSetBaseTerrainMix("newengland_grass"); // nwt_forest
	rmTerrainInitialize("new_england\ground1_ne", 3.0); // NWterritory\ground_grass5_nwt
	rmSetMapType("newEngland"); 
	rmSetMapType("grass");
	rmSetMapType("land");
	rmSetLightingSet("carolina"); //

	

	
/*	// Make it rain
	rmSetGlobalRain( 1.0 );
	rmSetGlobalStormLength(1.0, 0.0);

	// Sets up the rain triggers - rain hard for 20 seconds, then lightly, then hard again, then medium, then off.
	rmCreateTrigger("ChangeRain1");
	rmSwitchToTrigger(rmTriggerID("ChangeRain1"));
	rmSetTriggerActive(true);
	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", 20);
	rmAddTriggerEffect("Render Rain");
	rmSetTriggerEffectParamFloat("Percent", 0.3);

	rmCreateTrigger("ChangeRain2");
	rmSwitchToTrigger(rmTriggerID("ChangeRain2"));
	rmSetTriggerActive(true);
	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", 40);
	rmAddTriggerEffect("Render Rain");
	rmSetTriggerEffectParamFloat("Percent", 1.0);

	rmCreateTrigger("ChangeRain3");
	rmSwitchToTrigger(rmTriggerID("ChangeRain3"));
	rmSetTriggerActive(true);
	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", 60);
	rmAddTriggerEffect("Render Rain");
	rmSetTriggerEffectParamFloat("Percent", 0.3);

	rmCreateTrigger("ChangeRain4");
	rmSwitchToTrigger(rmTriggerID("ChangeRain4"));
	rmSetTriggerActive(true);
	rmAddTriggerCondition("Timer");
	rmSetTriggerConditionParamInt("Param1", 75);
	rmAddTriggerEffect("Render Rain");
	rmSetTriggerEffectParamFloat("Percent", 0.0);
*/
	

	// Choose Mercs
	chooseMercs();
	
	// Text
	rmSetStatusText("",0.10);
	
	// Set up Natives
	int subCiv0 = -1;
	int subCiv1 = -1;
	subCiv0 = rmGetCivID("Cherokee");
	subCiv1 = rmGetCivID("Seminoles");
	rmSetSubCiv(0, "Cherokee");
	rmSetSubCiv(1, "Seminoles");
//	rmEchoInfo("subCiv0 is Cherokee "+subCiv0);
//	rmEchoInfo("subCiv1 is Seminoles "+subCiv1);
//	string nativeName0 = "native Cherokee village";
//	string nativeName1 = "native Seminoles village";
	

	//Define some classes. These are used later for constraints.
	int classPlayer = rmDefineClass("player");
	rmDefineClass("classHill");
	int classPatch = rmDefineClass("patch");
	int classPatch2 = rmDefineClass("patch2");
	int classWaterStone = rmDefineClass("stonewater");
	int classGrass = rmDefineClass("grass");
	rmDefineClass("starting settlement");
	rmDefineClass("startingUnit");
	int classForest = rmDefineClass("Forest");
	int importantItem = rmDefineClass("importantItem");
	int classNative = rmDefineClass("natives");
	int classCliff = rmDefineClass("Cliffs");
	int classGold = rmDefineClass("Gold");
	int classStartingResource = rmDefineClass("startingResource");
	
	// ******************************************************************************************
	
	// Text
	rmSetStatusText("",0.20);
	
	// ************************************* CONTRAINTS *****************************************
	// These are used to have objects and areas avoid each other
   
   
	// Cardinal Directions & Map placement
	int Southeastconstraint = rmCreatePieConstraint("southeastMapConstraint", 0.5, 0.5, 0.0, rmZFractionToMeters(0.50), rmDegreesToRadians(90), rmDegreesToRadians(180));
	int Northwestconstraint = rmCreatePieConstraint("northwestMapConstraint", 0.5, 0.5, 0.0, rmZFractionToMeters(0.50), rmDegreesToRadians(270), rmDegreesToRadians(360));
	int Southwestconstraint = rmCreatePieConstraint("southwestMapConstraint", 0.5, 0.5, 0.0, rmZFractionToMeters(0.50), rmDegreesToRadians(180), rmDegreesToRadians(270));
	int Northeastconstraint = rmCreatePieConstraint("northeastMapConstraint", 0.39, 0.39, 0.0, rmZFractionToMeters(0.50), rmDegreesToRadians(0), rmDegreesToRadians(90));
	int Southnarrowconstraint = rmCreatePieConstraint("SouthstripConstraint", 0.5, 0.5, rmZFractionToMeters(0.15), rmZFractionToMeters(0.50), rmDegreesToRadians(160), rmDegreesToRadians(195));
	int Northnarrowconstraint = rmCreatePieConstraint("NorthstripConstraint", 0.5, 0.5, rmZFractionToMeters(0.15), rmZFractionToMeters(0.50), rmDegreesToRadians(355), rmDegreesToRadians(20));
	
	int Southeastsideconstraint = rmCreatePieConstraint("southeastsideConstraint", 0.5, 0.5, rmXFractionToMeters(0.32), rmXFractionToMeters(0.50), rmDegreesToRadians(90), rmDegreesToRadians(180));
	int Northwestsideconstraint = rmCreatePieConstraint("northwestsideConstraint", 0.5, 0.5, rmXFractionToMeters(0.32), rmXFractionToMeters(0.50), rmDegreesToRadians(270), rmDegreesToRadians(360));
	int Southwestsideconstraint = rmCreatePieConstraint("southwestsideConstraint", 0.5, 0.5, rmXFractionToMeters(0.32), rmXFractionToMeters(0.50), rmDegreesToRadians(180), rmDegreesToRadians(270));
	int Northeastsideconstraint = rmCreatePieConstraint("northeastsideConstraint", 0.5, 0.5, rmXFractionToMeters(0.32), rmXFractionToMeters(0.50), rmDegreesToRadians(0), rmDegreesToRadians(90));
	
	int avoidEdge = rmCreatePieConstraint("Avoid Edge",0.5,0.5, rmXFractionToMeters(0.0),rmXFractionToMeters(0.47), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int avoidEdgeMore = rmCreatePieConstraint("Avoid Edge More",0.5,0.5, rmXFractionToMeters(0.0),rmXFractionToMeters(0.45), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int avoidCenter = rmCreatePieConstraint("Avoid Center",0.4,0.4,rmXFractionToMeters(0.24), rmXFractionToMeters(0.5), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int stayCenter = rmCreatePieConstraint("Stay Center",0.4,0.4,rmXFractionToMeters(0.0), rmXFractionToMeters(0.14), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int stayEastclose = rmCreatePieConstraint("Stay East Close", 0.5, 0.5, rmZFractionToMeters(0.38), rmZFractionToMeters(0.50), rmDegreesToRadians(45), rmDegreesToRadians(135));
	int stayEastveryclose = rmCreatePieConstraint("Stay East Closer", 0.9, 0.5, 0.0, rmZFractionToMeters(0.12), rmDegreesToRadians(180), rmDegreesToRadians(360));
	int stayEdge = rmCreatePieConstraint("Stay Edge",0.5,0.5,rmXFractionToMeters(0.42), rmXFractionToMeters(0.5), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int northEdge = rmCreatePieConstraint("North Edge",0.70,0.70,rmXFractionToMeters(0.2), rmXFractionToMeters(0.30), rmDegreesToRadians(0),rmDegreesToRadians(90)); 
//	int avoidWesthalf = rmCreateAreaDistanceConstraint("avoid west", WestID, 185.0); 
	int staySouthHalf = rmCreatePieConstraint("SouthHalfConstraint", 0.59, 0.59, 0.0, rmZFractionToMeters(0.60), rmDegreesToRadians(135), rmDegreesToRadians(315));
	int stayNorthHalf = rmCreatePieConstraint("NorthHalfConstraint", 0.61, 0.61, 0.0, rmZFractionToMeters(0.60), rmDegreesToRadians(315), rmDegreesToRadians(135));
	int staySouthWest = rmCreatePieConstraint("SouthWestConstraint", 0.37, 0.37, 0.0, rmZFractionToMeters(0.60), rmDegreesToRadians(235), rmDegreesToRadians(30));
	int staySouthEast = rmCreatePieConstraint("SouthEastConstraint", 0.37, 0.37, 0.0, rmZFractionToMeters(0.60), rmDegreesToRadians(60), rmDegreesToRadians(215));
	int stayNorthWest = rmCreatePieConstraint("NorthWestConstraint", 0.50, 0.50, 0.0, rmZFractionToMeters(0.60), rmDegreesToRadians(315), rmDegreesToRadians(0));
	int stayNorthEast = rmCreatePieConstraint("NorthEastConstraint", 0.50, 0.50, 0.0, rmZFractionToMeters(0.60), rmDegreesToRadians(90), rmDegreesToRadians(135));
	int stayNorthMiddle = rmCreatePieConstraint("NorthMiddleConstraint", 0.50, 0.50, 0.0, rmZFractionToMeters(0.60), rmDegreesToRadians(22), rmDegreesToRadians(68));
	
	
	// Resource avoidance
	int avoidForestFar=rmCreateClassDistanceConstraint("avoid forest far", rmClassID("Forest"), 40.0); //15.0
	int avoidForest=rmCreateClassDistanceConstraint("avoid forest", rmClassID("Forest"), 28.0); //15.0
	int avoidForestShort=rmCreateClassDistanceConstraint("avoid forest short", rmClassID("Forest"), 20.0); //15.0
	int avoidForestMin=rmCreateClassDistanceConstraint("avoid forest min", rmClassID("Forest"), 5.0);
	int avoidTurkey = rmCreateTypeDistanceConstraint("food avoids food", "turkey", 28.0);
	int avoidTurketShort = rmCreateTypeDistanceConstraint("food avoids food short", "turkey", 24.0);
	int avoidBerries = rmCreateTypeDistanceConstraint("avoid berries ", "berrybush", 80.0);
	int avoidBerriesMin = rmCreateTypeDistanceConstraint("avoid berries min ", "berrybush", 10.0);
	int avoidDeerFar = rmCreateTypeDistanceConstraint("avoid deer far", "deer", 54.0);
	int avoidDeer = rmCreateTypeDistanceConstraint("avoid  deer", "deer", 48.0);
	int avoidDeerShort = rmCreateTypeDistanceConstraint("avoid  deer short", "deer", 40.0);
	int avoidDeerMin = rmCreateTypeDistanceConstraint("avoid deer min", "deer", 10.0);
	int avoidElk = rmCreateTypeDistanceConstraint("elk avoids elk", "elk", 65.0);
	int avoidElkShort = rmCreateTypeDistanceConstraint("elk avoids elk short", "elk", 28.0);
	int avoidElkMin = rmCreateTypeDistanceConstraint("elk avoids elk min", "elk", 10.0);
	int avoidGoldMed = rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 20.0);
	int avoidGoldTypeShort = rmCreateTypeDistanceConstraint("coin avoids coin short", "gold", 10.0);
	int avoidGoldType = rmCreateTypeDistanceConstraint("coin avoids coin ", "gold", 15.0);
	int avoidGoldTypeFar = rmCreateTypeDistanceConstraint("coin avoids coin far ", "gold", 36.0);
	int avoidGoldMin=rmCreateClassDistanceConstraint("min distance vs gold", rmClassID("classGold"), 16.0);
	int avoidGold = rmCreateClassDistanceConstraint ("gold avoid gold med", rmClassID("Gold"), 30.0);
	int avoidGoldFar = rmCreateClassDistanceConstraint ("gold avoid gold far", rmClassID("Gold"), 68.0); //70
	int avoidGoldVeryFar = rmCreateClassDistanceConstraint ("gold avoid gold very ", rmClassID("Gold"), 74.0);
	int avoidNuggetMin = rmCreateTypeDistanceConstraint("nugget avoid nugget min", "AbstractNugget", 4.0);
	int avoidNuggetShort = rmCreateTypeDistanceConstraint("nugget avoid nugget short", "AbstractNugget", 30.0);
	int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 40.0);
	int avoidNuggetFar = rmCreateTypeDistanceConstraint("nugget avoid nugget Far", "AbstractNugget", 52.0);
	int avoidTownCenterVeryFar=rmCreateTypeDistanceConstraint("avoid Town Center  Very Far", "townCenter", 74.0);
	int avoidTownCenterFar=rmCreateTypeDistanceConstraint("avoid Town Center Far", "townCenter", 50.0);
	int avoidTownCenter=rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 49.0);
	//	int avoidTownCenterMed=rmCreateTypeDistanceConstraint("resources avoid Town Center med", "townCenter", 40.0);
	int avoidTownCenterShort=rmCreateTypeDistanceConstraint("resources avoid Town Center short", "townCenter", 24.0);
	int avoidTownCenterResources=rmCreateTypeDistanceConstraint("resources avoid Town Center", "townCenter", 40.0);
	int avoidNativesShort = rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 4.0);
	int avoidNatives = rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 8.0);
	int avoidNativesFar = rmCreateClassDistanceConstraint("stuff avoids natives far", rmClassID("natives"), 12.0);
	int avoidStartingResources  = rmCreateClassDistanceConstraint("avoid start resources", rmClassID("startingResource"), 8.0);
	int avoidStartingResourcesShort = rmCreateClassDistanceConstraint("avoid start resources short", rmClassID("startingResource"), 5.0);
	int avoidGoat = rmCreateTypeDistanceConstraint("goat avoid goat", "ypGoat", 60.0);
	

	// Avoid impassable land
	int avoidImpassableLand = rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
	int avoidImpassableLandLong=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 25.0);
	int avoidImpassableLandShort = rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 3.0);
	int avoidImpassableLandMed=rmCreateTerrainDistanceConstraint("medium avoid impassable land", "Land", false, 15.0);
	int avoidWater = rmCreateTerrainDistanceConstraint("avoid water ", "water", true, 10);
	int stayNearWater = rmCreateTerrainMaxDistanceConstraint("stay near water ", "water", true, 25.0);
	int stayInWater = rmCreateTerrainMaxDistanceConstraint("stay in water ", "water", true, 0.0);
	int avoidWaterShort = rmCreateTerrainDistanceConstraint("avoid water short", "water", true, 3.0);
	int avoidPatch = rmCreateClassDistanceConstraint("patch avoid patch", rmClassID("patch"), 5.0);
	int avoidPatch2 = rmCreateClassDistanceConstraint("patch avoid patch", rmClassID("patch2"), 5.0);
	int avoidStone = rmCreateClassDistanceConstraint("stone avoid stone", rmClassID("stonewater"), 5.0);
	int avoidGrass = rmCreateClassDistanceConstraint("grass avoid grass", rmClassID("grass"), 5.0);
	

	// Unit avoidance
	int avoidStartingUnits = rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 35.0);
		
	
	// VP avoidance
	int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
	int avoidTradeRouteShort = rmCreateTradeRouteDistanceConstraint("trade route short", 5.0);
	int avoidTradeRouteSocket = rmCreateTypeDistanceConstraint("avoid trade route socket", "socketTradeRoute", 8.0);
	int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 10.0);
   
	
	
	
	// ***********************************************************************************************
	
	// **************************************** PLACE PLAYERS ****************************************

	int teamZeroCount = rmGetNumberPlayersOnTeam(0);
	int teamOneCount = rmGetNumberPlayersOnTeam(1);
	
	// 2 team and FFA support
	float OneVOnePlacement=rmRandFloat(0.0, 0.9);
	if (PlayerNum == 2)
	{

		if ( OneVOnePlacement < 0.5)
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.67, 0.21, 0.4, 0.20, 0, 0.0); // disregard line end

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.21, 0.67, 0.4, 0.8, 0, 0.0); // disregard line end
		}
		else
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.21, 0.67, 0.4, 0.8, 0, 0.0);

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.67, 0.21, 0.4, 0.20, 0, 0.0);
		}
		
	}
	
/*	// Team placement
	else if ( PlayerNum == 2 && teamZeroCount == teamOneCount)
	{

		rmSetPlacementTeam(0);
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersLine(0.2, 0.2, 0.5, 0.2, 0, 0.0);

		rmSetPlacementTeam(1);
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersLine(0.8, 0.8, 0.5, 0.8, 0, 0.0);
	
	}
	// FFA support
	else if (PlayerNum > 2)
	{
      bool southSide = true;

      float spacingIncrement = (0.35 / (PlayerNum / 2));
      float spacingSouth = 0;
      float spacingNorth = 0;
      
      float southStart = 0.45;
      float southEnd = 0.82;
      float northStart = 0.95;
      float northEnd = 0.32;

      for (i = 0; < PlayerNum)
      {
         rmEchoInfo("i = "+i);
         if (southSide == true)
         {
            rmSetPlacementTeam(i);
            rmSetPlacementSection((southStart + spacingSouth), southEnd);
	         rmSetTeamSpacingModifier(0.25);
	         rmPlacePlayersCircular(0.4, 0.4, 0);
            spacingSouth = spacingSouth + spacingIncrement;
         }
         else
         {
            rmSetPlacementTeam(i);
            rmSetPlacementSection((northStart + spacingNorth), northEnd);
	         rmSetTeamSpacingModifier(0.25);
	         rmPlacePlayersCircular(0.4, 0.4, 0);
            spacingNorth = spacingNorth + spacingIncrement;
         }
         if (southSide == true)
         {
            southSide = false;
         }
         else
         {
            southSide = true;
         }
      }
   }
   else 
   {
      if (teamZeroCount < teamOneCount)
      {
         rmSetPlacementTeam(0);
         rmSetPlacementSection(0.55, 0.75);
		   rmSetTeamSpacingModifier(0.35 / teamZeroCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);

		   rmSetPlacementTeam(1);
         rmSetPlacementSection(0.95, 0.32);
		   rmSetTeamSpacingModifier(0.35 / teamOneCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);
      }
      else 
      {
         rmSetPlacementTeam(0);
         rmSetPlacementSection(0.45, 0.82);
		   rmSetTeamSpacingModifier(0.35 / teamZeroCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);

		   rmSetPlacementTeam(1);
         rmSetPlacementSection(0.0, 0.2);
		   rmSetTeamSpacingModifier(0.35 / teamOneCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);
      }
   }
*/
	// **************************************************************************************************
   
	// Text
	rmSetStatusText("",0.30);
	
	// ****************************************** TRADE ROUTE **********************************************
	
	int tradeRouteID = rmCreateTradeRoute();
	int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	rmSetObjectDefAllowOverlap(socketID, true);
	rmSetObjectDefMinDistance(socketID, 0.0);
	rmSetObjectDefMaxDistance(socketID, 6.0);

	
	rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.48, 0.00); //0.70, 0.03
//	rmAddTradeRouteWaypoint(tradeRouteID, 0.45, 0.11); // , 0.12
//	rmAddTradeRouteWaypoint(tradeRouteID, 0.54, 0.20); //0.50, 0.25
	rmAddTradeRouteWaypoint(tradeRouteID, 0.24, 0.24);
//	rmAddTradeRouteWaypoint(tradeRouteID, 0.54, 0.76); //0.50, 0.75
//	rmAddTradeRouteWaypoint(tradeRouteID, 0.45, 0.89); // , 0.87
	rmAddTradeRouteWaypoint(tradeRouteID, 0.00, 0.48); // 0.70, 0.97
	
	bool placedTradeRouteA = rmBuildTradeRoute(tradeRouteID, "dirt");
//	if(placedTradeRouteA == false)
//	rmEchoError("Failed to place trade route 1");
//	rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
	vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.04);
	rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.50);
	rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.96);
	rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	
	// *************************************************************************************************************
	
	// Text
	rmSetStatusText("",0.40);
	
	// ******************************************** NATURE DESIGN **************************************************
	
	//River
	int riverID = rmRiverCreate(-1, "new england lake", 14, 14, 5, 5); //  (-1, "new england lake", 18, 14, 5, 5)
	rmRiverAddWaypoint(riverID, 0.20, 1.00); 
	rmRiverAddWaypoint(riverID, 0.60, 0.60); 
	rmRiverAddWaypoint(riverID, 1.00, 0.20);
	rmRiverSetBankNoiseParams(riverID, 0.00, 0, 0.0, 0.0, 0.0, 0.0);
	rmRiverSetShallowRadius(riverID, 250);
	rmRiverAddShallow(riverID, 0.5);
	rmRiverBuild(riverID);
	
	// Cliff
	int cliffID = rmCreateArea("cliff");
//	rmSetAreaSize(cliffID, 0.13, 0.13); // rmAreaTilesToFraction(5000), rmAreaTilesToFraction(5000));  
	rmSetAreaSize(cliffID, 0.6, 0.6);
	rmSetAreaWarnFailure(cliffID, false);
	rmSetAreaObeyWorldCircleConstraint(cliffID, false);
	rmSetAreaCliffType(cliffID, "new england inland grass"); // new england inland grass
	rmSetAreaCliffPainting(cliffID, true, true, true, 0.5 , false); //  paintGround,  paintOutsideEdge,  paintSide,  minSideHeight,  paintInsideEdge
	rmSetAreaCliffHeight(cliffID, 6, 0.0, 1.0); 
	rmSetAreaCliffEdge(cliffID, 4, 0.11, 0.0, 0.30, 1); //0.30
//	rmSetAreaCliffEdge(cliffID, 1, 0.50, 0.0, 0.50, 2);
	rmSetAreaCoherence(cliffID, 1.0);
	rmAddAreaToClass(cliffID, rmClassID("Cliffs"));
	rmAddAreaConstraint(cliffID, avoidWaterShort);
//	rmAddAreaConstraint(cliffID, stayNearWater);
	rmSetAreaLocation(cliffID, 0.70, 0.70);
//	rmSetAreaBaseHeight(cliffID, 6);
	rmSetAreaHeightBlend(cliffID, 2.0);
	int avoidCliffShort = rmCreateAreaDistanceConstraint("avoid cliff short", cliffID, 10.0);
	int avoidRamp = rmCreateCliffRampDistanceConstraint("avoid ramp", cliffID, 18.0);
	int avoidRampShort = rmCreateCliffRampDistanceConstraint("avoid ramp short", cliffID, 10.0);

	rmBuildArea(cliffID);
	
	// Plateau
	int plateauID = rmCreateArea("plateau");
	rmSetAreaSize(plateauID, 0.60, 0.60); // rmAreaTilesToFraction(5000), rmAreaTilesToFraction(5000));  
	rmSetAreaWarnFailure(plateauID, false);
	rmSetAreaObeyWorldCircleConstraint(plateauID, false);
	rmSetAreaCoherence(plateauID, 1.0);
	rmSetAreaLocation (plateauID, 0.75, 0.75);
	rmSetAreaBaseHeight(plateauID, 6.0);
	rmSetAreaElevationType(plateauID, cElevTurbulence);
	rmSetAreaElevationVariation(plateauID, 5.0);
	rmSetAreaElevationMinFrequency(plateauID, 0.05);
	rmSetAreaElevationOctaves(plateauID, 4);
	rmSetAreaElevationPersistence(plateauID, 0.8);
	rmSetAreaHeightBlend(plateauID, 2.0);
	rmAddAreaConstraint (plateauID, avoidWater);
	rmBuildArea(plateauID);

	// Terrain patch1
	for (i=0; < 100)
    {
        int patchID = rmCreateArea("patch grass light "+i);
        rmSetAreaWarnFailure(patchID, false);
        rmSetAreaSize(patchID, rmAreaTilesToFraction(60), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(patchID, "new_england\ground2_cliff_ne");
		rmPaintAreaTerrain(patchID);
//		rmAddAreaTerrainLayer(patchID, "carolinas\grass3", 0, 1);
        rmAddAreaToClass(patchID, rmClassID("patch"));
        rmSetAreaMinBlobs(patchID, 1);
        rmSetAreaMaxBlobs(patchID, 5);
        rmSetAreaMinBlobDistance(patchID, 16.0);
        rmSetAreaMaxBlobDistance(patchID, 40.0);
        rmSetAreaCoherence(patchID, 0.0);
		rmAddAreaConstraint(patchID, avoidImpassableLandShort);
		rmAddAreaConstraint(patchID, avoidPatch);
        rmBuildArea(patchID); 
    }
	
	// Water stones
	for (i=0; < 25)
	{
		int StoneID = rmCreateObjectDef("water stone"+i);
		rmAddObjectDefItem(StoneID, "RiverPropsNWTerritory", rmRandInt(2,4), 4.0); 
		rmSetObjectDefMinDistance(StoneID, 0);
		rmSetObjectDefMaxDistance(StoneID, rmXFractionToMeters(0.35));
		rmAddObjectDefToClass(StoneID, rmClassID("stonewater"));
		rmAddObjectDefConstraint(StoneID, avoidStone);
		rmAddObjectDefConstraint(StoneID, stayInWater);
		rmPlaceObjectDefAtLoc(StoneID, 0, 0.60, 0.60);
	}
    
	// Grass
	for (i=0; < 300)
	{
		int GrassID = rmCreateObjectDef("grass short"+i);
		rmAddObjectDefItem(GrassID, "PropGrassShort", rmRandInt(3,5), 4.0); 
		rmSetObjectDefMinDistance(GrassID, 0);
		rmSetObjectDefMaxDistance(GrassID, rmXFractionToMeters(0.6));
		rmAddObjectDefToClass(GrassID, rmClassID("grass"));
		rmAddObjectDefConstraint(GrassID, avoidGrass);
		rmAddObjectDefConstraint(GrassID, avoidImpassableLandShort);
		rmPlaceObjectDefAtLoc(GrassID, 0, 0.50, 0.50);
	}
	

	// ******************************************************************************************************
	
	// Text
	rmSetStatusText("",0.45);
	
	// ******************************************** NATIVES *************************************************

	int nativeID0 = -1;
    int nativeID1 = -1;
	int nativeID2 = -1;
    int nativeID3 = -1;
		
	nativeID0 = rmCreateGrouping("Cherokee village", "native Cherokee village "+5);
    rmSetGroupingMinDistance(nativeID0, 0.00);
    rmSetGroupingMaxDistance(nativeID0, 0.00);
//	rmAddGroupingConstraint(nativeID0, avoidImpassableLand);
	rmAddGroupingToClass(nativeID0, rmClassID("natives"));
//  rmAddGroupingToClass(nativeID0, rmClassID("importantItem"));
//	rmAddGroupingConstraint(nativeID0, avoidNatives);
	rmPlaceGroupingAtLoc(nativeID0, 0, 0.62, 0.86);
	
	nativeID2 = rmCreateGrouping("Cherokee village", "native Cherokee village "+2);
    rmSetGroupingMinDistance(nativeID2, 0.00);
    rmSetGroupingMaxDistance(nativeID2, 0.00);
//	rmAddGroupingConstraint(nativeID2, avoidImpassableLand);
	rmAddGroupingToClass(nativeID2, rmClassID("natives"));
//  rmAddGroupingToClass(nativeID2, rmClassID("importantItem"));
//	rmAddGroupingConstraint(nativeID2, avoidNatives);
	rmPlaceGroupingAtLoc(nativeID2, 0, 0.86, 0.62);
	
	nativeID1 = rmCreateGrouping("Seminole village 4", "native seminole village "+4);
    rmSetGroupingMinDistance(nativeID1, 0.00);
    rmSetGroupingMaxDistance(nativeID1, 0.00);
//  rmAddGroupingConstraint(nativeID1, avoidImpassableLand);
	rmAddGroupingToClass(nativeID1, rmClassID("natives"));
//  rmAddGroupingToClass(nativeID1, rmClassID("importantItem"));
//	rmAddGroupingConstraint(nativeID1, avoidNatives);
	rmPlaceGroupingAtLoc(nativeID1, 0, 0.24, 0.44); // 0.28, 0.25
	
	nativeID3 = rmCreateGrouping("Seminole village", "native seminole village "+1);
    rmSetGroupingMinDistance(nativeID3, 0.00);
    rmSetGroupingMaxDistance(nativeID3, 0.00);
//  rmAddGroupingConstraint(nativeID3, avoidImpassableLand);
	rmAddGroupingToClass(nativeID3, rmClassID("natives"));
//  rmAddGroupingToClass(nativeID3, rmClassID("importantItem"));
//	rmAddGroupingConstraint(nativeID3, avoidNatives);
	rmPlaceGroupingAtLoc(nativeID3, 0, 0.44, 0.24); // 0.28, 0.75
	
	// ******************************************************************************************************
	
	// Text
	rmSetStatusText("",0.50);
	
	// ************************************ PLAYER STARTING RESOURCES ***************************************

	// ******** Define ********

	// Town center & units
	int TCID = rmCreateObjectDef("player TC");
	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
	rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
	rmAddObjectDefToClass(TCID, classStartingResource);
	}
	rmSetObjectDefMinDistance(TCID, 0.0);
	rmSetObjectDefMaxDistance(TCID, 0.0);
	
	// Starting mines
	int playergoldID = rmCreateObjectDef("player mine");
	rmAddObjectDefItem(playergoldID, "mine", 1, 0);
	rmSetObjectDefMinDistance(playergoldID, 12.0);
	rmSetObjectDefMaxDistance(playergoldID, 14.0);
	rmAddObjectDefToClass(playergoldID, classStartingResource);
	rmAddObjectDefToClass(playergoldID, classGold);
	rmAddObjectDefConstraint(playergoldID, avoidGoldType);
	rmAddObjectDefConstraint(playergoldID, avoidTradeRoute);
	rmAddObjectDefConstraint(playergoldID, avoidImpassableLand);
	rmAddObjectDefConstraint(playergoldID, avoidNatives);
	rmAddObjectDefConstraint(playergoldID, avoidStartingResources);
	
	// 2nd mine
	int playergold2ID = rmCreateObjectDef("player second mine");
	rmAddObjectDefItem(playergold2ID, "mine", 1, 0);
	rmSetObjectDefMinDistance(playergold2ID, 28.0); //58
	rmSetObjectDefMaxDistance(playergold2ID, 32.0); //62
//	rmAddObjectDefToClass(playergold2ID, classStartingResource);
	rmAddObjectDefToClass(playergold2ID, classGold);
	rmAddObjectDefConstraint(playergold2ID, avoidTradeRoute);
	rmAddObjectDefConstraint(playergold2ID, avoidImpassableLand);
	rmAddObjectDefConstraint(playergold2ID, avoidNatives);
	rmAddObjectDefConstraint(playergold2ID, avoidGoldTypeFar);
	rmAddObjectDefConstraint(playergold2ID, avoidStartingResources);
	rmAddObjectDefConstraint(playergold2ID, avoidCenter);
	
	// Starting berries
	int playerberriesID = rmCreateObjectDef("player berries");
	rmAddObjectDefItem(playerberriesID, "berrybush", 3, 3.0);
	rmSetObjectDefMinDistance(playerberriesID, 12.0);
	rmSetObjectDefMaxDistance(playerberriesID, 14.0);
	rmAddObjectDefToClass(playerberriesID, classStartingResource);
	rmAddObjectDefConstraint(playerberriesID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerberriesID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerberriesID, avoidNatives);
	rmAddObjectDefConstraint(playerberriesID, avoidStartingResources);
	
	// Starting trees1
	int playerTreeID = rmCreateObjectDef("player trees");
//  rmAddObjectDefItem(playerTreeID, "TreeNorthwestTerritory", rmRandInt(1,2), 4.0);
	rmAddObjectDefItem(playerTreeID, "TreeSaguenay", rmRandInt(8,8), 7.0); //6,6 5.0
    rmSetObjectDefMinDistance(playerTreeID, 12);
    rmSetObjectDefMaxDistance(playerTreeID, 16);
	rmAddObjectDefToClass(playerTreeID, classStartingResource);
	rmAddObjectDefToClass(playerTreeID, classForest);
	rmAddObjectDefConstraint(playerTreeID, avoidForestShort);
	rmAddObjectDefConstraint(playerTreeID, avoidTradeRoute);
    rmAddObjectDefConstraint(playerTreeID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerTreeID, avoidStartingResources);
	
	// Starting trees2
	int playerTree2ID = rmCreateObjectDef("player trees 2");
//  rmAddObjectDefItem(playerTree2ID, "TreeNorthwestTerritory", rmRandInt(1,2), 4.0);
	rmAddObjectDefItem(playerTree2ID, "TreeSaguenay", rmRandInt(4,4), 4.0); //6,6 5.0
    rmSetObjectDefMinDistance(playerTree2ID, 12);
    rmSetObjectDefMaxDistance(playerTree2ID, 14);
	rmAddObjectDefToClass(playerTree2ID, classStartingResource);
	rmAddObjectDefToClass(playerTree2ID, classForest);
	rmAddObjectDefConstraint(playerTree2ID, avoidForestShort);
	rmAddObjectDefConstraint(playerTree2ID, avoidTradeRoute);
    rmAddObjectDefConstraint(playerTree2ID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerTree2ID, avoidStartingResources);
	
	// Starting herd
	int playerturkeyID = rmCreateObjectDef("starting turkey");
	rmAddObjectDefItem(playerturkeyID, "turkey", rmRandInt(6,6), 5.0);
	rmSetObjectDefMinDistance(playerturkeyID, 14.0);
	rmSetObjectDefMaxDistance(playerturkeyID, 16.0);
	rmSetObjectDefCreateHerd(playerturkeyID, true);
	rmAddObjectDefToClass(playerturkeyID, classStartingResource);
	rmAddObjectDefConstraint(playerturkeyID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerturkeyID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerturkeyID, avoidNatives);
	rmAddObjectDefConstraint(playerturkeyID, avoidStartingResources);
		
	// 2nd herd
	int playerDeerID = rmCreateObjectDef("player deer");
    rmAddObjectDefItem(playerDeerID, "deer", rmRandInt(9,9), 7.0);
    rmSetObjectDefMinDistance(playerDeerID, 26);
    rmSetObjectDefMaxDistance(playerDeerID, 30);
	rmAddObjectDefToClass(playerDeerID, classStartingResource);
	rmSetObjectDefCreateHerd(playerDeerID, true);
	rmAddObjectDefConstraint(playerDeerID, avoidTurkey); //Short
	rmAddObjectDefConstraint(playerDeerID, avoidTradeRoute);
//	rmAddObjectDefConstraint(playerDeerID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerDeerID, avoidNatives);
	rmAddObjectDefConstraint(playerDeerID, avoidStartingResources);
	
/*	// 3rd herd
	int playerDeer2ID = rmCreateObjectDef("player deer2");
    rmAddObjectDefItem(playerDeer2ID, "deer", rmRandInt(8,8), 6.0);
    rmSetObjectDefMinDistance(playerDeer2ID, 28);
    rmSetObjectDefMaxDistance(playerDeer2ID, 34);
	rmAddObjectDefToClass(playerDeer2ID, classStartingResource);
	rmSetObjectDefCreateHerd(playerDeer2ID, true);
	rmAddObjectDefConstraint(playerDeer2ID, avoidTurkey); //Short
	rmAddObjectDefConstraint(playerDeer2ID, avoidDeerShort);
	rmAddObjectDefConstraint(playerDeer2ID, avoidCliffShort);
	rmAddObjectDefConstraint(playerDeer2ID, avoidTradeRouteShort);
//	rmAddObjectDefConstraint(playerDeer2ID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerDeer2ID, avoidNatives);
	rmAddObjectDefConstraint(playerDeer2ID, avoidStartingResources);
	rmAddObjectDefConstraint(playerDeer2ID, avoidEdge);
*/
	
	// Starting treasures
	int playerNuggetID = rmCreateObjectDef("player nugget"); 
	rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
	rmSetNuggetDifficulty(1, 1);
	rmSetObjectDefMinDistance(playerNuggetID, 20.0);
	rmSetObjectDefMaxDistance(playerNuggetID, 28.0);
//	rmAddObjectDefToClass(playerNuggetID, classStartingResource);
	rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerNuggetID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerNuggetID, avoidNatives);
	rmAddObjectDefConstraint(playerNuggetID, avoidStartingResources);
	rmAddObjectDefConstraint(playerNuggetID, avoidNuggetShort);
	rmAddObjectDefConstraint(playerNuggetID, avoidEdge);
	int nugget0count = rmRandInt (1,2);
		
	// ******** Place ********
	
	for(i=1; <numPlayer)
	{
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));

		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergoldID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergold2ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerberriesID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTree2ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerturkeyID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerDeerID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
//		rmPlaceObjectDefAtLoc(playerDeer2ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerNuggetID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		if (nugget0count == 2)
			rmPlaceObjectDefAtLoc(playerNuggetID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
				
		if(ypIsAsian(i) && rmGetNomadStart() == false)
		rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i), i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
	}

	// ************************************************************************************************
	
	// Text
	rmSetStatusText("",0.60);
	
	// ************************************** COMMON RESOURCES ****************************************
  
   
	// ********** Mines ***********
	
		int southgoldCount = rmRandInt(3,3);  // 3,3 
		int northgoldCount = rmRandInt(3,3);  // 3,3 
	
	//South mines
	for(i=0; < southgoldCount)
	{
		int southgoldID = rmCreateObjectDef("gold south half"+i);
		rmAddObjectDefItem(southgoldID, "Mine", 1, 0.0);
		rmSetObjectDefMinDistance(southgoldID, rmXFractionToMeters(0.1));
		rmSetObjectDefMaxDistance(southgoldID, rmXFractionToMeters(0.7));
		rmAddObjectDefToClass(southgoldID, classGold);
		rmAddObjectDefConstraint(southgoldID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(southgoldID, avoidImpassableLand);
		rmAddObjectDefConstraint(southgoldID, avoidNatives);
		rmAddObjectDefConstraint(southgoldID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(southgoldID, avoidGoldVeryFar);
		rmAddObjectDefConstraint(southgoldID, staySouthHalf);
		rmAddObjectDefConstraint(southgoldID, avoidTownCenterVeryFar);
		rmAddObjectDefConstraint(southgoldID, avoidEdge);
		if (i == 0)
			rmAddObjectDefConstraint(southgoldID, staySouthWest);
		else if (i == 1)
			rmAddObjectDefConstraint(southgoldID, staySouthEast);
		rmPlaceObjectDefAtLoc(southgoldID, 0, 0.20, 0.20);
	}
	
	//North mines
	for(i=0; < northgoldCount)
	{
		int northgoldID = rmCreateObjectDef("gold north half"+i);
		rmAddObjectDefItem(northgoldID, "Mine", 1, 0.0);
		rmSetObjectDefMinDistance(northgoldID, rmXFractionToMeters(0.14));
		rmSetObjectDefMaxDistance(northgoldID, rmXFractionToMeters(0.7));
		rmAddObjectDefToClass(northgoldID, classGold);
		rmAddObjectDefConstraint(northgoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(northgoldID, avoidImpassableLand);
		rmAddObjectDefConstraint(northgoldID, avoidNativesFar);
		rmAddObjectDefConstraint(northgoldID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(northgoldID, avoidGoldFar);
		rmAddObjectDefConstraint(northgoldID, avoidWater);
//		rmAddObjectDefConstraint(northgoldID, avoidTownCenterFar);
		rmAddObjectDefConstraint(northgoldID, avoidRamp);
		rmAddObjectDefConstraint(northgoldID, avoidEdge);
		rmAddObjectDefConstraint(northgoldID, stayNorthHalf);
		if (i == 0)
			rmAddObjectDefConstraint(northgoldID, stayNorthWest);
		else if (i == 1)
			rmAddObjectDefConstraint(northgoldID, stayNorthEast);
		else
			rmAddObjectDefConstraint(northgoldID, stayNorthMiddle);
		rmPlaceObjectDefAtLoc(northgoldID, 0, 0.66, 0.66);
	}
		
	// ****************************
	
	// Text
	rmSetStatusText("",0.70);
	
		// ********** Forest **********
	
	// South forest
	int southforestcount = 16; //7,7
	int stayInSouthForest = -1;
	
	for (i=0; < southforestcount)
	{
		int southforestID = rmCreateArea("south forest"+i);
		rmSetAreaWarnFailure(southforestID, false);
//		rmSetAreaObeyWorldCircleConstraint(southforestID, false);
		rmSetAreaSize(southforestID, rmAreaTilesToFraction(120), rmAreaTilesToFraction(130));
//		rmSetAreaTerrainType(southforestID, "pampas\groundforest_pam");
		rmSetAreaMinBlobs(southforestID, 2);
		rmSetAreaMaxBlobs(southforestID, 5);
		rmSetAreaMinBlobDistance(southforestID, 14.0);
		rmSetAreaMaxBlobDistance(southforestID, 30.0);
		rmSetAreaCoherence(southforestID, 0.1);
		rmSetAreaSmoothDistance(southforestID, 5);
//		rmAddAreaToClass(southforestID, classForest);
		rmAddAreaConstraint(southforestID, avoidForest);
		rmAddAreaConstraint(southforestID, avoidTradeRouteShort);
		rmAddAreaConstraint(southforestID, avoidImpassableLandShort);
		rmAddAreaConstraint(southforestID, avoidNatives);
		rmAddAreaConstraint(southforestID, avoidTradeRouteSocket);
		rmAddAreaConstraint(southforestID, avoidGoldTypeShort);
		rmAddAreaConstraint(southforestID, staySouthHalf);
//		rmAddAreaConstraint(southforestID, avoidEdge);
		rmAddAreaConstraint(southforestID, avoidTownCenterShort);
		rmAddAreaConstraint(southforestID, avoidStartingResourcesShort);
		rmAddAreaConstraint(southforestID, avoidDeerMin); 
		rmAddAreaConstraint(southforestID, avoidNuggetMin);
		rmBuildArea(southforestID);
	
		stayInSouthForest = rmCreateAreaMaxDistanceConstraint("stay in south forest"+i, southforestID, 0);
	
		for (j=0; < rmRandInt(24,26))
		{
			int southtreeID = rmCreateObjectDef("south tree"+i+j);
			rmAddObjectDefItem(southtreeID, "TreeSaguenay", rmRandInt(1,2), 1.0); // cluster distance 9.0
			rmSetObjectDefMinDistance(southtreeID, 0);
			rmSetObjectDefMaxDistance(southtreeID, rmXFractionToMeters(0.5));
			rmAddObjectDefToClass(southtreeID, classForest);
			rmAddObjectDefConstraint(southtreeID, stayInSouthForest);	
			rmAddObjectDefConstraint(southtreeID, avoidImpassableLandShort);	
			rmPlaceObjectDefAtLoc(southtreeID, 0, 0.40, 0.40);
		}
		
	}
	
	// North forest
	int northforestcount = 6; //7,7
	int stayInNorthForest = -1;
	
	for (i=0; < northforestcount)
	{
		int northforestID = rmCreateArea("north forest"+i);
		rmSetAreaWarnFailure(northforestID, false);
//		rmSetAreaObeyWorldCircleConstraint(northforestID, false);
		rmSetAreaSize(northforestID, rmAreaTilesToFraction(90), rmAreaTilesToFraction(100));
//		rmSetAreaTerrainType(northforestID, "pampas\groundforest_pam");
		rmSetAreaMinBlobs(northforestID, 2);
		rmSetAreaMaxBlobs(northforestID, 5);
		rmSetAreaMinBlobDistance(northforestID, 14.0);
		rmSetAreaMaxBlobDistance(northforestID, 30.0);
		rmSetAreaCoherence(northforestID, 0.1);
		rmSetAreaSmoothDistance(northforestID, 5);
//		rmAddAreaToClass(northforestID, classForest);
		rmAddAreaConstraint(northforestID, avoidForest);
		rmAddAreaConstraint(northforestID, avoidTradeRouteShort);
		rmAddAreaConstraint(northforestID, avoidImpassableLandShort);
		rmAddAreaConstraint(northforestID, avoidNatives);
		rmAddAreaConstraint(northforestID, avoidTradeRouteSocket);
		rmAddAreaConstraint(northforestID, avoidGoldTypeShort);
		rmAddAreaConstraint(northforestID, stayNorthHalf);
		rmAddAreaConstraint(northforestID, avoidRamp); 
//		rmAddAreaConstraint(northforestID, avoidEdge);
		rmAddAreaConstraint(northforestID, avoidTownCenterShort);
		rmAddAreaConstraint(northforestID, avoidStartingResources);
		rmAddAreaConstraint(northforestID, avoidDeerMin); 
		rmBuildArea(northforestID);
	
		stayInNorthForest = rmCreateAreaMaxDistanceConstraint("stay in north forest"+i, northforestID, 0);
	
		for (j=0; < rmRandInt(22,24))
		{
			int northtreeID = rmCreateObjectDef("north tree"+i+j);
			rmAddObjectDefItem(northtreeID, "TreeSaguenay", rmRandInt(1,2), 1.0); // cluster distance 9.0
			rmSetObjectDefMinDistance(northtreeID, 0);
			rmSetObjectDefMaxDistance(northtreeID, rmXFractionToMeters(0.5));
			rmAddObjectDefToClass(northtreeID, classForest);
			rmAddObjectDefConstraint(northtreeID, stayInNorthForest);	
			rmAddObjectDefConstraint(northtreeID, avoidImpassableLandShort);	
			rmPlaceObjectDefAtLoc(northtreeID, 0, 0.40, 0.40);
		}
		
	}
		
	// ********************************
	
	// Text
	rmSetStatusText("",0.80);
	
	// *********** Berries ************	
	
	//North berries
	int northberriescount = 2;
	
	for(i=0; < northberriescount)
	{
		int northberryID = rmCreateObjectDef("north berry"+i);
		rmAddObjectDefItem(northberryID, "berrybush", rmRandInt(4,4), 4.0);
		rmSetObjectDefMinDistance(northberryID, rmXFractionToMeters(0.18));
		rmSetObjectDefMaxDistance(northberryID, rmXFractionToMeters(0.7));
		rmAddObjectDefConstraint(northberryID, avoidImpassableLand);
		rmAddObjectDefConstraint(northberryID, avoidNatives);
		rmAddObjectDefConstraint(northberryID, avoidGoldType);
		rmAddObjectDefConstraint(northberryID, stayNorthHalf);
		rmAddObjectDefConstraint(northberryID, avoidForestMin);
//		rmAddObjectDefConstraint(northberryID, avoidElkMin); 
		rmAddObjectDefConstraint(northberryID, avoidBerries);
		rmAddObjectDefConstraint(northberryID, avoidRamp);
		rmAddObjectDefConstraint(northberryID, avoidEdge);
		rmPlaceObjectDefAtLoc(northberryID, 0, 0.75, 0.75);
	}	
	
	// ********************************
		
	// Text
	rmSetStatusText("",0.90);
	
	// ********** Random trees to fill **********
	
	// Random trees
	int randomforestcount = rmRandInt(14,14); 
	
	for (i=0; < randomforestcount)
	{	
		int RandomtreeID = rmCreateObjectDef("random trees"+i);
		rmAddObjectDefItem(RandomtreeID, "TreeSaguenay", rmRandInt(8,9), 4.0); // 4,5
		rmSetObjectDefMinDistance(RandomtreeID, 0);
		rmSetObjectDefMaxDistance(RandomtreeID, rmXFractionToMeters(0.6));
		rmAddObjectDefToClass(RandomtreeID, classForest);
		rmAddObjectDefConstraint(RandomtreeID, avoidNatives);
		rmAddObjectDefConstraint(RandomtreeID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(RandomtreeID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(RandomtreeID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(RandomtreeID, avoidRamp);
		rmAddObjectDefConstraint(RandomtreeID, avoidTownCenterResources);
		rmAddObjectDefConstraint(RandomtreeID, avoidStartingResources);
		rmAddObjectDefConstraint(RandomtreeID, avoidDeerMin); 
		rmAddObjectDefConstraint(RandomtreeID, avoidGoldTypeShort);
		rmAddObjectDefConstraint(RandomtreeID, avoidElkMin);
		rmAddObjectDefConstraint(RandomtreeID, avoidBerriesMin);
		rmAddObjectDefConstraint(RandomtreeID, avoidForest);	
		rmAddObjectDefConstraint(RandomtreeID, avoidEdge);
		rmPlaceObjectDefAtLoc(RandomtreeID, 0, 0.5, 0.5);
	}
	
	// ********************************

	// ********** Herds ***********
/*			
	//Southwest deers
	int southwestdeerID = rmCreateObjectDef("southwest deer"+i);
	rmAddObjectDefItem(southwestdeerID, "deer", rmRandInt(9,9), 7.0);
	rmSetObjectDefMinDistance(southwestdeerID, 0.0);
	rmSetObjectDefMaxDistance(southwestdeerID, rmXFractionToMeters(0.5));
	rmSetObjectDefCreateHerd(southwestdeerID, true);
//	rmAddObjectDefConstraint(southwestdeerID, avoidImpassableLandShort);
	rmAddObjectDefConstraint(southwestdeerID, avoidNativesShort);
	rmAddObjectDefConstraint(southwestdeerID, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(southwestdeerID, avoidGoldMed);
	rmAddObjectDefConstraint(southwestdeerID, staySouthHalf);
	rmAddObjectDefConstraint(southwestdeerID, staySouthWest);
	rmAddObjectDefConstraint(southwestdeerID, avoidCliffShort);
	rmAddObjectDefConstraint(southwestdeerID, avoidRampShort);
	rmAddObjectDefConstraint(southwestdeerID, avoidTownCenter);
	rmAddObjectDefConstraint(southwestdeerID, avoidForestMin);
	rmAddObjectDefConstraint(southwestdeerID, avoidDeer); 
	rmAddObjectDefConstraint(southwestdeerID, avoidEdgeMore);
	
	//Southeast deers
	int southeastdeerID = rmCreateObjectDef("southeast deer"+i);
	rmAddObjectDefItem(southeastdeerID, "deer", rmRandInt(9,9), 7.0);
	rmSetObjectDefMinDistance(southeastdeerID, 0.0);
	rmSetObjectDefMaxDistance(southeastdeerID, rmXFractionToMeters(0.5));
	rmSetObjectDefCreateHerd(southeastdeerID, true);
//	rmAddObjectDefConstraint(southeastdeerID, avoidImpassableLandShort);
	rmAddObjectDefConstraint(southeastdeerID, avoidNativesShort);
	rmAddObjectDefConstraint(southeastdeerID, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(southeastdeerID, avoidGoldMed);
	rmAddObjectDefConstraint(southwestdeerID, staySouthHalf);
	rmAddObjectDefConstraint(southeastdeerID, staySouthEast);
	rmAddObjectDefConstraint(southeastdeerID, avoidCliffShort);
	rmAddObjectDefConstraint(southeastdeerID, avoidTownCenter);
	rmAddObjectDefConstraint(southeastdeerID, avoidForestMin);
	rmAddObjectDefConstraint(southeastdeerID, avoidDeer); 
	rmAddObjectDefConstraint(southeastdeerID, avoidEdgeMore);
	
	int southdeercount =8;	
	for(i=0; < southdeercount/2)
	{
	rmPlaceObjectDefAtLoc(southwestdeerID, 0, 0.20, 0.40);
	rmPlaceObjectDefAtLoc(southeastdeerID, 0, 0.40, 0.20);
	}
*/
	//South deers
	int southdeerID = rmCreateObjectDef("south deer");
	rmAddObjectDefItem(southdeerID, "deer", rmRandInt(9,9), 7.0);
	rmSetObjectDefMinDistance(southdeerID, 0.0);
	rmSetObjectDefMaxDistance(southdeerID, rmXFractionToMeters(0.5));
	rmSetObjectDefCreateHerd(southdeerID, true);
//	rmAddObjectDefConstraint(southdeerID, avoidImpassableLandShort);
	rmAddObjectDefConstraint(southdeerID, avoidNativesShort);
	rmAddObjectDefConstraint(southdeerID, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(southdeerID, avoidGoldMed);
	rmAddObjectDefConstraint(southdeerID, staySouthHalf);
	rmAddObjectDefConstraint(southdeerID, avoidCliffShort);
	rmAddObjectDefConstraint(southdeerID, avoidRampShort);
	rmAddObjectDefConstraint(southdeerID, avoidTownCenter);
	rmAddObjectDefConstraint(southdeerID, avoidForestMin);
	rmAddObjectDefConstraint(southdeerID, avoidDeer); 
	rmAddObjectDefConstraint(southdeerID, avoidEdgeMore);
	
	int southdeercount =8;	
	for(i=0; < southdeercount)
	{
	rmPlaceObjectDefAtLoc(southdeerID, 0, 0.40, 0.40);
	}
	
	//North elks
	int northelkcount = 3;
	
	for(i=0; < northelkcount)
	{
		int northelkID = rmCreateObjectDef("north elk"+i);
		rmAddObjectDefItem(northelkID, "elk", rmRandInt(8,8), 7.0);
		rmSetObjectDefMinDistance(northelkID, rmXFractionToMeters(0.0));
		rmSetObjectDefMaxDistance(northelkID, rmXFractionToMeters(0.7));
		rmSetObjectDefCreateHerd(northelkID, true);
		rmAddObjectDefConstraint(northelkID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(northelkID, avoidNativesFar);
		rmAddObjectDefConstraint(northelkID, avoidGoldTypeShort);
		rmAddObjectDefConstraint(northelkID, avoidTownCenterFar);
		rmAddObjectDefConstraint(northelkID, avoidForestMin);
		rmAddObjectDefConstraint(northelkID, avoidDeerShort); 
		rmAddObjectDefConstraint(northelkID, avoidElk); 
		rmAddObjectDefConstraint(northelkID, avoidEdge);
		rmAddObjectDefConstraint(northelkID, avoidRampShort);
		rmAddObjectDefConstraint(northelkID, stayNorthHalf);
		if (i == 0)
			rmAddObjectDefConstraint(northelkID, stayNorthWest);
		else if (i == 1)
			rmAddObjectDefConstraint(northelkID, stayNorthEast);
		rmPlaceObjectDefAtLoc(northelkID, 0, 0.85, 0.85);
	}	
	
	// ********************************
	
	// Text
	rmSetStatusText("",0.95);
	
	// ********** Treasures ***********
	
	// Treasures south	
	int NuggetsouthID = rmCreateObjectDef("South nugget"); 
	rmAddObjectDefItem(NuggetsouthID, "Nugget", 1, 0.0);
	rmSetObjectDefMinDistance(NuggetsouthID, 0);
    rmSetObjectDefMaxDistance(NuggetsouthID, rmXFractionToMeters(0.6));
	rmAddObjectDefConstraint(NuggetsouthID, avoidNuggetFar);
	rmAddObjectDefConstraint(NuggetsouthID, avoidNatives);
	rmAddObjectDefConstraint(NuggetsouthID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(NuggetsouthID, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(NuggetsouthID, avoidImpassableLand);
	rmAddObjectDefConstraint(NuggetsouthID, avoidGoldTypeShort);
	rmAddObjectDefConstraint(NuggetsouthID, staySouthHalf);
	rmAddObjectDefConstraint(NuggetsouthID, avoidTownCenter);
	rmAddObjectDefConstraint(NuggetsouthID, avoidDeerMin); 
	rmAddObjectDefConstraint(NuggetsouthID, avoidBerriesMin);
	rmAddObjectDefConstraint(NuggetsouthID, avoidForestMin);	
	rmAddObjectDefConstraint(NuggetsouthID, avoidEdge); 
	
	int nugget1count = -1;
	int	nugget2count = -1;
	
	if	(nugget0count == 1)
	nugget2count = rmRandInt(4,5);
	else
	nugget2count = 4;
	
	if (nugget2count == 4)
	nugget1count = rmRandInt(2,3); //2,2
	else
	nugget1count = 2;
	
	for (i=0; < nugget2count)
	{
		rmSetNuggetDifficulty(2,2);
		rmPlaceObjectDefAtLoc(NuggetsouthID, 0, 0.45, 0.45);
	}
	
	for (i=0; < nugget1count)
	{
		rmSetNuggetDifficulty(1,1);
		rmPlaceObjectDefAtLoc(NuggetsouthID, 0, 0.45, 0.45);
	}
	
	// Treasures north	
	int NuggetnorthID = rmCreateObjectDef("North nugget"); 
	rmAddObjectDefItem(NuggetnorthID, "Nugget", 1, 0.0);
	rmSetObjectDefMinDistance(NuggetnorthID, 0);
    rmSetObjectDefMaxDistance(NuggetnorthID, rmXFractionToMeters(0.6));
	rmAddObjectDefConstraint(NuggetnorthID, avoidNuggetFar);
	rmAddObjectDefConstraint(NuggetnorthID, avoidNatives);
	rmAddObjectDefConstraint(NuggetnorthID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(NuggetnorthID, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(NuggetnorthID, avoidImpassableLand);
	rmAddObjectDefConstraint(NuggetnorthID, avoidGoldTypeShort);
	rmAddObjectDefConstraint(NuggetnorthID, stayNorthHalf);
	rmAddObjectDefConstraint(NuggetnorthID, avoidTownCenter);
	rmAddObjectDefConstraint(NuggetnorthID, avoidElkMin); 
	rmAddObjectDefConstraint(NuggetnorthID, avoidBerriesMin);
	rmAddObjectDefConstraint(NuggetnorthID, avoidForestMin);	
	rmAddObjectDefConstraint(NuggetnorthID, avoidRamp);
	rmAddObjectDefConstraint(NuggetnorthID, avoidEdge);

	int nugget3count = -1;
	nugget3count = rmRandInt(3,4);
	
	for (i=0; < nugget3count)
	{
		rmSetNuggetDifficulty(2,2);
		rmPlaceObjectDefAtLoc(NuggetnorthID, 0, 0.65, 0.65);
	}
	
	
	// ********************************

	// Text
	rmSetStatusText("",1.00);
	
} //END
	
	