// ESOC BENGAL
// designed by Garja

int PlayerNum=2;
int numPlayer=3;

include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";

// Main entry point for random map script
void main(void)
{
		
	// Text
	// These status text lines are used to manually animate the map generation progress bar
	rmSetStatusText("",0.01); 
	
	// ************************************** GENERAL FEATURES *****************************************
	
	// Picks the map size
	int playerTiles=10500; //11000
	int size=2.0*sqrt(PlayerNum*playerTiles); //2.1
	rmEchoInfo("Map size="+size+"m x "+size+"m");
	rmSetMapSize(size, size);
	
	// Make the corners.
	rmSetWorldCircleConstraint(false);
	
	// Picks a default water height
	rmSetSeaLevel(1.0);	// this is height of river surface compared to surrounding land. River depth is in the river XML.

//	rmSetMapElevationParameters(cElevTurbulence, 0.05, 2, 0.5, 4.5); // type, frequency, octaves, persistence, variation 
//	rmSetMapElevationHeightBlend(1);
	
	
	// Picks default terrain and water
	rmSetSeaType("bayou");
	rmSetBaseTerrainMix("deccan_grass_b"); // 
	rmTerrainInitialize("water", 0.0); // 
	rmSetMapType("deccan"); 
	rmSetMapType("grass");
	rmSetMapType("water");
	rmSetLightingSet("deccan");

	// Choose Mercs
	chooseMercs();
	
	// Make it rain
	rmSetGlobalRain(0.9);
  
	// Text
	rmSetStatusText("",0.10);
	
	// Set up Natives
	int subCiv0 = -1;
	int subCiv1 = -1;
	int subCiv2 = -1;
	subCiv0 = rmGetCivID("Udasi");
	subCiv1 = rmGetCivID("Sufi");
	subCiv2 = rmGetCivID("Bhakti");
	rmSetSubCiv(0, "Udasi");
	rmSetSubCiv(1, "Sufi");
	rmSetSubCiv(2, "Bhakti");
	

	//Define some classes. These are used later for constraints.
	int classPlayer = rmDefineClass("player");
	int classPatch = rmDefineClass("patch");
	int classPatch2 = rmDefineClass("patch2");
	int classPatch3 = rmDefineClass("patch3");
	int classPond = rmDefineClass("pond");
	int classRocks = rmDefineClass("rocks");
	int classGrass = rmDefineClass("grass");
	rmDefineClass("starting settlement");
	rmDefineClass("startingUnit");
	int classForest = rmDefineClass("Forest");
	int importantItem = rmDefineClass("importantItem");
	int classNative = rmDefineClass("natives");
	int classCliff = rmDefineClass("Cliffs");
	int classGold = rmDefineClass("Gold");
	int classStartingResource = rmDefineClass("startingResource");
	int classIsland=rmDefineClass("island");
	
	// ******************************************************************************************
	
	// Text
	rmSetStatusText("",0.20);
	
	// ************************************* CONTRAINTS *****************************************
	// These are used to have objects and areas avoid each other
   
	// Cardinal Directions & Map placement
	int avoidEdge = rmCreatePieConstraint("Avoid Edge",0.5,0.5, rmXFractionToMeters(0.0),rmXFractionToMeters(0.47), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int avoidEdgeMore = rmCreatePieConstraint("Avoid Edge More",0.5,0.5, rmXFractionToMeters(0.0),rmXFractionToMeters(0.38), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int avoidCenter = rmCreatePieConstraint("Avoid Center",0.5,0.5,rmXFractionToMeters(0.28), rmXFractionToMeters(0.5), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int stayCenter = rmCreatePieConstraint("Stay Center", 0.50, 0.50, rmXFractionToMeters(0.0), rmXFractionToMeters(0.28), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int stayCenterMore = rmCreatePieConstraint("Stay Center more",0.45,0.45,rmXFractionToMeters(0.0), rmXFractionToMeters(0.26), rmDegreesToRadians(0),rmDegreesToRadians(360));

	int staySouthPart = rmCreatePieConstraint("Stay south part", 0.55, 0.55,rmXFractionToMeters(0.0), rmXFractionToMeters(0.60), rmDegreesToRadians(135),rmDegreesToRadians(315));
	int stayNorthHalf = rmCreatePieConstraint("Stay north half", 0.50, 0.50,rmXFractionToMeters(0.0), rmXFractionToMeters(0.50), rmDegreesToRadians(360),rmDegreesToRadians(180));
		
	// Resource avoidance
	int avoidForest=rmCreateClassDistanceConstraint("avoid forest", rmClassID("Forest"), 26.0); //15.0
	int avoidForestShort=rmCreateClassDistanceConstraint("avoid forest short", rmClassID("Forest"), 15.0); //15.0
	int avoidForestMin=rmCreateClassDistanceConstraint("avoid forest min", rmClassID("Forest"), 4.0);
	int avoidNilgauFar = rmCreateTypeDistanceConstraint("avoid Nilgau far", "ypNilgai", 48.0);
	int avoidNilgau = rmCreateTypeDistanceConstraint("avoid Nilgau", "ypNilgai", 45.0);
	int avoidNilgauShort = rmCreateTypeDistanceConstraint("avoid Nilgau short", "ypNilgai", 25.0);
	int avoidNilgauMin = rmCreateTypeDistanceConstraint("avoid Nilgau min", "ypNilgai", 4.0);
	int avoidEleFar = rmCreateTypeDistanceConstraint("avoid Ele far", "ypWildElephant", 45.0);
	int avoidEle = rmCreateTypeDistanceConstraint("avoid Ele", "ypWildElephant", 40.0);
	int avoidEleShort = rmCreateTypeDistanceConstraint("avoid  Ele short", "ypWildElephant", 35.0);
	int avoidEleMin = rmCreateTypeDistanceConstraint("avoid Ele min", "ypWildElephant", 5.0);
	int avoidMuskdeerFar = rmCreateTypeDistanceConstraint("avoid muskdeer far", "ypmuskdeer", 56.0);
	int avoidMuskdeer = rmCreateTypeDistanceConstraint("avoid muskdeer ", "ypmuskdeer", 45.0);
	int avoidMuskdeerMin = rmCreateTypeDistanceConstraint("avoid muskdeer min ", "ypmuskdeer", 4.0);
	int avoidGoldMed = rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 25.0);
	int avoidGoldTypeShort = rmCreateTypeDistanceConstraint("coin avoids coin short", "gold", 8.0);
	int avoidGoldType = rmCreateTypeDistanceConstraint("coin avoids coin ", "gold", 45.0);
	int avoidGoldTypeFar = rmCreateTypeDistanceConstraint("coin avoids coin far ", "gold", 52.0);
	int avoidGoldMin=rmCreateClassDistanceConstraint("min distance vs gold", rmClassID("Gold"), 8.0);
	int avoidGoldShort = rmCreateClassDistanceConstraint ("gold avoid gold short", rmClassID("Gold"), 15.0);
	int avoidGold = rmCreateClassDistanceConstraint ("gold avoid gold med", rmClassID("Gold"), 30.0);
	int avoidGoldFar = rmCreateClassDistanceConstraint ("gold avoid gold far", rmClassID("Gold"), 52.0);
	int avoidGoldVeryFar = rmCreateClassDistanceConstraint ("gold avoid gold very far", rmClassID("Gold"), 66.0);
	int avoidNuggetMin = rmCreateTypeDistanceConstraint("nugget avoid nugget min", "AbstractNugget", 10.0);
	int avoidNuggetShort = rmCreateTypeDistanceConstraint("nugget avoid nugget short", "AbstractNugget", 40.0);
	int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 50.0);
	int avoidNuggetFar = rmCreateTypeDistanceConstraint("nugget avoid nugget Far", "AbstractNugget", 50.0);
	int avoidTownCenterVeryFar = rmCreateTypeDistanceConstraint("avoid Town Center Very Far", "townCenter", 85.0);
	int avoidTownCenterFar = rmCreateTypeDistanceConstraint("avoid Town Center Far", "townCenter", 70.0);
	int avoidTownCenter = rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 46.0);
//	int avoidTownCenterMed = rmCreateTypeDistanceConstraint("avoid Town Center med", "townCenter", 40.0);
	int avoidTownCenterShort = rmCreateTypeDistanceConstraint("avoid Town Center short", "townCenter", 20.0);
	int avoidTownCenterMin = rmCreateTypeDistanceConstraint("avoid Town Center min", "townCenter", 18.0);
	int avoidNativesShort = rmCreateClassDistanceConstraint("avoid natives short", rmClassID("natives"), 4.0);
	int avoidNatives = rmCreateClassDistanceConstraint("avoid natives", rmClassID("natives"), 10.0);
	int avoidNativesFar = rmCreateClassDistanceConstraint("avoid natives far", rmClassID("natives"), 15.0);
	int avoidStartingResources = rmCreateClassDistanceConstraint("avoid starting resources", rmClassID("startingResource"), 8.0);
	int avoidStartingResourcesShort = rmCreateClassDistanceConstraint("avoid starting resources short", rmClassID("startingResource"), 4.0);
	int avoidWhale=rmCreateTypeDistanceConstraint("avoid whale", "fish", 52.0);
	int avoidFish=rmCreateTypeDistanceConstraint("avoid fish", "fish", 24.0);
	int avoidYak=rmCreateTypeDistanceConstraint("avoid yak", "ypyak", 60.0);
	int avoidColonyShip = rmCreateTypeDistanceConstraint("avoid colony ship", "HomeCityWaterSpawnFlag", 30.0);
	int avoidColonyShipShort = rmCreateTypeDistanceConstraint("avoid colony ship short", "HomeCityWaterSpawnFlag", 15.0);

	// Avoid impassable land
	int avoidImpassableLandMin = rmCreateTerrainDistanceConstraint("avoid impassable land min", "Land", false, 1.0);
	int avoidImpassableLandShort = rmCreateTerrainDistanceConstraint("avoid impassable land short", "Land", false, 6.0);
	int avoidImpassableLand = rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 8.0);
	int avoidImpassableLandMed=rmCreateTerrainDistanceConstraint("avoid impassable land medium", "Land", false, 12.0);
	int avoidImpassableLandFar = rmCreateTerrainDistanceConstraint("avoid impassable land far", "Land", false, 20.0);
	int stayNearLand = rmCreateTerrainMaxDistanceConstraint("stay near land ", "Land", true, 5.0);
	int avoidLand = rmCreateTerrainDistanceConstraint("avoid land ", "Land", true, 8.0);
	int avoidLandFar = rmCreateTerrainDistanceConstraint("avoid land far ", "Land", true, 15.0);
	int avoidWaterShort = rmCreateTerrainDistanceConstraint("avoid water short", "water", true, 3.0);
	int avoidWater = rmCreateTerrainDistanceConstraint("avoid water ", "water", true, 10);
	int avoidWaterFar = rmCreateTerrainDistanceConstraint("avoid water far", "water", true, 30.0);
	int stayNearWater = rmCreateTerrainMaxDistanceConstraint("stay near water ", "water", true, 20.0);
	int stayInWater = rmCreateTerrainMaxDistanceConstraint("stay in water ", "water", true, 0.0);
	int avoidPatch = rmCreateClassDistanceConstraint("avoid patch", rmClassID("patch"), 5.0);
	int avoidPatch2 = rmCreateClassDistanceConstraint("avoid patch2", rmClassID("patch2"), 20.0);
	int avoidPatch3 = rmCreateClassDistanceConstraint("avoid patch3", rmClassID("patch3"), 5.0);
	int avoidIslandMin=rmCreateClassDistanceConstraint("avoid island min", classIsland, 8.0);
	int avoidIslandShort=rmCreateClassDistanceConstraint("avoid island short", classIsland, 12.0);
	int avoidIsland=rmCreateClassDistanceConstraint("avoid island", classIsland, 16.0);
	int avoidIslandFar=rmCreateClassDistanceConstraint("avoid island far", classIsland, 32.0);
	int avoidCliffShort = rmCreateClassDistanceConstraint("avoid cliff short", classCliff, 3.0);
	int avoidCliff = rmCreateClassDistanceConstraint("avoid cliff", classCliff, 7.0);
	
	// Unit avoidance
	int avoidStartingUnits = rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 35.0);	
	
	// VP avoidance
	int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 8.0);
	int avoidTradeRouteShort = rmCreateTradeRouteDistanceConstraint("trade route short", 4.0);
	int avoidTradeRouteSocket = rmCreateTypeDistanceConstraint("avoid trade route socket", "socketTradeRoute", 8.0);
	int avoidTradeRouteSocketShort = rmCreateTypeDistanceConstraint("avoid trade route socket short", "socketTradeRoute", 3.0);
	int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 10.0);
   
	
	// ***********************************************************************************************
	
	// **************************************** PLACE PLAYERS ****************************************

	int teamZeroCount = rmGetNumberPlayersOnTeam(0);
	int teamOneCount = rmGetNumberPlayersOnTeam(1);
	
	// 2 team and FFA support
	float OneVOnePlacement=rmRandFloat(0, 1);
	if (PlayerNum == 2)
	{

		if ( OneVOnePlacement < 0.5)
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.46, 0.88, 0.4, 0.20, 0, 0.0); // disregard line end

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.88, 0.45, 0.4, 0.8, 0, 0.0); // disregard line end
		}
		else
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.88, 0.45, 0.4, 0.8, 0, 0.0);

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.45, 0.88, 0.4, 0.20, 0, 0.0);
		}
		
	}
	
/*	// Team placement
	else if ( PlayerNum == 2 && teamZeroCount == teamOneCount)
	{

		rmSetPlacementTeam(0);
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersLine(0.2, 0.2, 0.5, 0.2, 0, 0.0);

		rmSetPlacementTeam(1);
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersLine(0.8, 0.8, 0.5, 0.8, 0, 0.0);
	
	}
	// FFA support
	else if (PlayerNum > 2)
	{
      bool southSide = true;

      float spacingIncrement = (0.35 / (PlayerNum / 2));
      float spacingSouth = 0;
      float spacingNorth = 0;
      
      float southStart = 0.45;
      float southEnd = 0.82;
      float northStart = 0.95;
      float northEnd = 0.32;

      for (i = 0; < PlayerNum)
      {
         rmEchoInfo("i = "+i);
         if (southSide == true)
         {
            rmSetPlacementTeam(i);
            rmSetPlacementSection((southStart + spacingSouth), southEnd);
	         rmSetTeamSpacingModifier(0.25);
	         rmPlacePlayersCircular(0.4, 0.4, 0);
            spacingSouth = spacingSouth + spacingIncrement;
         }
         else
         {
            rmSetPlacementTeam(i);
            rmSetPlacementSection((northStart + spacingNorth), northEnd);
	         rmSetTeamSpacingModifier(0.25);
	         rmPlacePlayersCircular(0.4, 0.4, 0);
            spacingNorth = spacingNorth + spacingIncrement;
         }
         if (southSide == true)
         {
            southSide = false;
         }
         else
         {
            southSide = true;
         }
      }
   }
   else 
   {
      if (teamZeroCount < teamOneCount)
      {
         rmSetPlacementTeam(0);
         rmSetPlacementSection(0.55, 0.75);
		   rmSetTeamSpacingModifier(0.35 / teamZeroCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);

		   rmSetPlacementTeam(1);
         rmSetPlacementSection(0.95, 0.32);
		   rmSetTeamSpacingModifier(0.35 / teamOneCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);
      }
      else 
      {
         rmSetPlacementTeam(0);
         rmSetPlacementSection(0.45, 0.82);
		   rmSetTeamSpacingModifier(0.35 / teamZeroCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);

		   rmSetPlacementTeam(1);
         rmSetPlacementSection(0.0, 0.2);
		   rmSetTeamSpacingModifier(0.35 / teamOneCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);
      }
   }
*/
	// **************************************************************************************************
   
	// Text
	rmSetStatusText("",0.30);
	
	// ******************************************** MAP LAYOUT **************************************************
	
	
	//Cliff
	for (i=0; <2)
	{
		int hillID = rmCreateArea("hill"+i);
		if (i < 1)
		{
			rmSetAreaSize(hillID, 0.065, 0.065);
//			rmSetAreaMix(hillID, "deccan_grass_b");	
			rmSetAreaMix(hillID, "yellow_river_b");
			rmAddAreaTerrainLayer(hillID, "yellow_river\grass2_yellow_riv", 0, 2);
//			rmAddAreaTerrainLayer(hillID, "yellow_river\forest_yellow_riv", 0, 1);
			rmAddAreaInfluenceSegment(hillID, 0.85, 1.00, 0.56, 0.58);
			rmAddAreaInfluenceSegment(hillID, 1.00, 0.85, 0.58, 0.56);
			rmAddAreaInfluenceSegment(hillID, 1.00, 1.00, 0.57, 0.57);
			rmSetAreaElevationType(hillID, cElevTurbulence);
			rmSetAreaElevationVariation(hillID, 2.5);
			rmSetAreaBaseHeight(hillID, 3.0);
			rmSetAreaElevationMinFrequency(hillID, 0.09);
			rmSetAreaElevationOctaves(hillID, 3);
			rmSetAreaElevationPersistence(hillID, 0.4);
			rmSetAreaCoherence(hillID, 0.65);
			rmSetAreaSmoothDistance(hillID, 10);
		} 
		else
		{
			rmSetAreaSize(hillID, 0.024, 0.024);
			rmAddAreaInfluenceSegment(hillID, 1.00, 1.00, 0.60, 0.60);
			rmSetAreaCliffHeight(hillID, 8, 0.0, 0.8); 
			rmSetAreaCliffEdge(hillID, 1, 1.0, 0.0, 0.0, 1); 
//			rmSetAreaCliffType(hillID, "deccan plateau"); 
			rmSetAreaCliffType(hillID, "yellow river"); 
			rmSetAreaCliffPainting(hillID, false, true, true, 0.5 , true); //  paintGround,  paintOutsideEdge,  paintSide,  minSideHeight,  paintInsideEdge
			rmAddAreaConstraint(hillID, avoidWaterShort);
			rmSetAreaCoherence(hillID, 0.75);
			rmSetAreaSmoothDistance(hillID, 6);
			rmAddAreaToClass(hillID, classCliff);
		}
		rmSetAreaWarnFailure(hillID, false);
		rmSetAreaObeyWorldCircleConstraint(hillID, false);
		rmAddAreaToClass(hillID, classIsland);
		rmSetAreaLocation(hillID, 1.0, 1.0);
		rmBuildArea(hillID);
	}
	
	
	//Player islands
	for(i=1; <3)
    {
		int playerislandID=rmCreateArea("player island"+i);
		rmSetAreaSize(playerislandID, 0.15, 0.15);
		if (i < 2)
			rmSetAreaLocation(playerislandID, 0.36, 1.00);
		else 
			rmSetAreaLocation(playerislandID, 1.00, 0.36);
//		rmSetAreaMix(playerislandID, "deccan_grass_b");
			rmSetAreaMix(playerislandID, "yellow_river_b");
		rmAddAreaTerrainLayer(playerislandID, "yellow_river\grass2_yellow_riv", 0, 5); 
//		rmAddAreaTerrainLayer(playerislandID, "yellow_river\forest_yellow_riv", 0, 2); 
		rmSetAreaWarnFailure(playerislandID, false);
		rmAddAreaToClass(playerislandID, classIsland);
		rmSetAreaCoherence(playerislandID, 0.45);
		rmSetAreaSmoothDistance(playerislandID, 10);
		rmSetAreaElevationType(playerislandID, cElevTurbulence);
		rmSetAreaElevationVariation(playerislandID, 2.5);
		rmSetAreaBaseHeight(playerislandID, 3.0);
		rmSetAreaElevationMinFrequency(playerislandID, 0.09);
		rmSetAreaElevationOctaves(playerislandID, 3);
		rmSetAreaElevationPersistence(playerislandID, 0.4);      
	// 	rmAddConnectionArea(shallowsID, playerislandID);
		rmSetAreaObeyWorldCircleConstraint(playerislandID, false);
		rmAddAreaConstraint(playerislandID, avoidIslandShort);
		rmBuildArea(playerislandID);
		rmCreateAreaDistanceConstraint("avoid player island "+i, playerislandID, 5.0);
		rmCreateAreaMaxDistanceConstraint("stay in player island "+i, playerislandID, 0.0);
	}
	
	int avoidPlayerIsland1 = rmConstraintID("avoid player island 1");
	int avoidPlayerIsland2 = rmConstraintID("avoid player island 2");
	int stayInPlayerIsland1 = rmConstraintID("stay in player island 1");
	int stayInPlayerIsland2 = rmConstraintID("stay in player island 2");  


/*	//TP islands
	
	for (i=0; <3)
	{
		int TPislandID=rmCreateArea("TP island"+i);
		rmSetAreaSize(TPislandID, 0.025, 0.025);
		if (i < 1)
			rmSetAreaLocation(TPislandID, 0.18, 0.72);
		else if (i < 2)
			rmSetAreaLocation(TPislandID, 0.46, 0.46);
		else
			rmSetAreaLocation(TPislandID, 0.72, 0.18);	
		rmSetAreaMix(TPislandID, "yellow_river_forest");
//		rmAddAreaTerrainLayer(TPislandID, "yellow_river\grass2_yellow_riv", 2, 5);
//		rmAddAreaTerrainLayer(TPislandID, "yellow_river\forest_yellow_riv", 0, 2);
		rmSetAreaWarnFailure(TPislandID, false);
		rmAddAreaToClass(TPislandID, classIsland);
		rmSetAreaCoherence(TPislandID, 0.30);
		rmSetAreaSmoothDistance(TPislandID, 10);
		rmSetAreaElevationType(TPislandID, cElevTurbulence);
		rmSetAreaElevationVariation(TPislandID, 2.0);
		rmSetAreaBaseHeight(TPislandID, 4.0);
		rmSetAreaElevationMinFrequency(TPislandID, 0.09);
		rmSetAreaElevationOctaves(TPislandID, 3);
		rmSetAreaElevationPersistence(TPislandID, 0.2);      
	// 	rmAddConnectionArea(shallowsID, TPislandID);
		rmSetAreaObeyWorldCircleConstraint(TPislandID, false);
//		rmAddAreaConstraint(TPislandID, avoidIslandMin);
		rmBuildArea(TPislandID);
	
	}
*/
	//Big islands
	for (i=0; <12)
	{
		int BigislandID=rmCreateArea("Big island"+i);
		rmSetAreaSize(BigislandID, 0.019, 0.021);
		rmSetAreaMix(BigislandID, "yellow_river_forest");
		rmAddAreaTerrainLayer(BigislandID, "yellow_river\grass2_yellow_riv", 0, 1);
//		rmAddAreaTerrainLayer(BigislandID, "yellow_river\forest_yellow_riv", 0, 2);
		rmSetAreaWarnFailure(BigislandID, false);
		rmAddAreaToClass(BigislandID, classIsland);
		rmSetAreaCoherence(BigislandID, 0.25);
		rmSetAreaSmoothDistance(BigislandID, 6);
		rmSetAreaElevationType(BigislandID, cElevTurbulence);
		rmSetAreaElevationVariation(BigislandID, 2.0);
		rmSetAreaBaseHeight(BigislandID, 3.0);
		rmSetAreaElevationMinFrequency(BigislandID, 0.09);
		rmSetAreaElevationOctaves(BigislandID, 3);
		rmSetAreaElevationPersistence(BigislandID, 0.4);      
	// 	rmAddConnectionArea(shallowsID, BigislandID);
		rmSetAreaObeyWorldCircleConstraint(BigislandID, false);
		rmAddAreaConstraint(BigislandID, avoidIslandShort);
		rmBuildArea(BigislandID);
	
	}
	

	// Players area
	for (i=1; < numPlayer)
	{
	int playerareaID = rmCreateArea("playerarea"+i);
	rmSetPlayerArea(i, playerareaID);
	rmSetAreaSize(playerareaID, 0.05, 0.05);
	rmSetAreaCoherence(playerareaID, 1.0);
	rmSetAreaWarnFailure(playerareaID, false);
//	rmSetAreaTerrainType(playerareaID, "new_england\ground2_cliff_ne"); // for testing
	rmSetAreaLocPlayer(playerareaID, i);
	rmSetAreaObeyWorldCircleConstraint(playerareaID, false);
	rmBuildArea(playerareaID);
	rmCreateAreaDistanceConstraint("avoid player area "+i, playerareaID, 3.0);
	rmCreateAreaMaxDistanceConstraint("stay in player area "+i, playerareaID, 0.0);
	}
	
	int avoidPlayerArea1 = rmConstraintID("avoid player area 1");
	int avoidPlayerArea2 = rmConstraintID("avoid player area 2");
	int stayInPlayerArea1 = rmConstraintID("stay in player area 1");
	int stayInPlayerArea2 = rmConstraintID("stay in player area 2");

	// *********************************************************************************************************
	
	// Text
	rmSetStatusText("",0.40);
	
/*		// ****************************************** TRADE ROUTE **********************************************
		
	int tradeRouteID = rmCreateTradeRoute();
	int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	rmSetObjectDefAllowOverlap(socketID, true);
	rmSetObjectDefMinDistance(socketID, 0.0);
	rmSetObjectDefMaxDistance(socketID, 6.0);

	rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.00, 0.90); 
	rmAddTradeRouteWaypoint(tradeRouteID, 0.44, 0.44);
	rmAddTradeRouteWaypoint(tradeRouteID, 0.90, 0.00);
		
	bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "water");
	if(placedTradeRoute == false)
	rmEchoError("Failed to place trade route");
		
	rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
	vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.18);
	rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.50);
	rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.82);
	rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);	
	
	
*/	// *************************************************************************************************************
		
	// Text
	rmSetStatusText("",0.45);
	
	// ******************************************** NATIVES *************************************************
	
	
	float Natsvariation = -1;
//	Natsvariation = rmRandFloat(0.0,1.0); // > 0.66 udasi, > 0.33 bhatki, else sufi
	Natsvariation = 0.5; // <--- TEST
	
	int nativeID0 = -1;
	int nativeID1 = -1;
  
	
	if (Natsvariation > 0.66)
	{
		nativeID0 = rmCreateGrouping("Udasi village A", "native udasi village "+1);
		nativeID1 = rmCreateGrouping("Udasi village B", "native udasi village "+2);
	}
	else if (Natsvariation > 0.33)
	{
		nativeID0 = rmCreateGrouping("Bhatki village A", "native bhakti village "+1);
		nativeID1 = rmCreateGrouping("Bhatki village B", "native bhakti village "+2);
	}	
	else
	{
		nativeID0 = rmCreateGrouping("Sufi mosque A", "native sufi mosque deccan "+1);
		nativeID1 = rmCreateGrouping("Sufi mosque B", "native sufi mosque deccan "+2);
	}
//	rmSetGroupingMinDistance(nativeID0, 0.00);
//	rmSetGroupingMaxDistance(nativeID0, 0.00);
//	rmSetGroupingMinDistance(nativeID1, 0.00);
//	rmSetGroupingMaxDistance(nativeID1, 0.00);
	rmAddGroupingToClass(nativeID0, rmClassID("natives"));
	rmAddGroupingToClass(nativeID1, rmClassID("natives"));
	rmPlaceGroupingAtLoc(nativeID0, 0, 0.30, 0.80);
	rmPlaceGroupingAtLoc(nativeID1, 0, 0.80, 0.30);
	
		
	
	
	// ******************************************************************************************************
	
	// Text
	rmSetStatusText("",0.50);
	
	// ************************************ PLAYER STARTING RESOURCES ***************************************

	// ******** Define ********

	// Town center & units
	int TCID = rmCreateObjectDef("player TC");
	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
	rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
	rmAddObjectDefToClass(TCID, classStartingResource);
	}
	rmSetObjectDefMinDistance(TCID, 0.0);
	rmSetObjectDefMaxDistance(TCID, 0.0);
	
	// Starting mines
	int playergoldID = rmCreateObjectDef("player mine");
	rmAddObjectDefItem(playergoldID, "mine", 1, 0);
	rmSetObjectDefMinDistance(playergoldID, 16.0);
	rmSetObjectDefMaxDistance(playergoldID, 18.0);
	rmAddObjectDefToClass(playergoldID, classStartingResource);
	rmAddObjectDefToClass(playergoldID, classGold);
	rmAddObjectDefConstraint(playergoldID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(playergoldID, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(playergoldID, avoidImpassableLandShort);
	rmAddObjectDefConstraint(playergoldID, avoidNatives);
	rmAddObjectDefConstraint(playergoldID, avoidStartingResources);
//	rmAddObjectDefConstraint(playergoldID, avoidEdge);
	
	// 2nd mine
	int playergold2ID = rmCreateObjectDef("player second mine");
	rmAddObjectDefItem(playergold2ID, "mine", 1, 0);
	rmSetObjectDefMinDistance(playergold2ID, 46.0); //58
	rmSetObjectDefMaxDistance(playergold2ID, 60.0); //62
	rmAddObjectDefToClass(playergold2ID, classStartingResource);
	rmAddObjectDefToClass(playergold2ID, classGold);
//	rmAddObjectDefConstraint(playergold2ID, avoidTradeRouteShort);
//	rmAddObjectDefConstraint(playergold2ID, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(playergold2ID, avoidImpassableLandShort);
	rmAddObjectDefConstraint(playergold2ID, avoidNatives);
	rmAddObjectDefConstraint(playergold2ID, avoidGoldType);
	rmAddObjectDefConstraint(playergold2ID, avoidStartingResources);
//	rmAddObjectDefConstraint(playergold2ID, avoidCenter);
	rmAddObjectDefConstraint(playergold2ID, avoidEdge);
	
	// 3rd mine
	int playergold3ID = rmCreateObjectDef("player third mine");
	rmAddObjectDefItem(playergold3ID, "mine", 1, 0);
	rmSetObjectDefMinDistance(playergold3ID, 46.0); //58
	rmSetObjectDefMaxDistance(playergold3ID, 60.0); //62
	rmAddObjectDefToClass(playergold3ID, classStartingResource);
	rmAddObjectDefToClass(playergold3ID, classGold);
//	rmAddObjectDefConstraint(playergold3ID, avoidTradeRouteShort);
//	rmAddObjectDefConstraint(playergold3ID, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(playergold3ID, avoidImpassableLandShort);
	rmAddObjectDefConstraint(playergold3ID, avoidNatives);
	rmAddObjectDefConstraint(playergold3ID, avoidGoldType);
	rmAddObjectDefConstraint(playergold3ID, avoidStartingResources);
//	rmAddObjectDefConstraint(playergold3ID, avoidCenter);
	rmAddObjectDefConstraint(playergold3ID, avoidEdge);
	
	
	// Starting trees
	int playerTreeID = rmCreateObjectDef("player trees");
	rmAddObjectDefItem(playerTreeID, "treeyucatan", rmRandInt(5,5), 5.0);
    rmSetObjectDefMinDistance(playerTreeID, 12);
    rmSetObjectDefMaxDistance(playerTreeID, 16);
	rmAddObjectDefToClass(playerTreeID, classStartingResource);
	rmAddObjectDefToClass(playerTreeID, classForest);
	rmAddObjectDefConstraint(playerTreeID, avoidForestShort);
//	rmAddObjectDefConstraint(playerTreeID, avoidTradeRoute);
    rmAddObjectDefConstraint(playerTreeID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerTreeID, avoidStartingResources);
	
	// Starting berries
	int playerberriesID = rmCreateObjectDef("player berries");
	rmAddObjectDefItem(playerberriesID, "berrybush", 2, 3.0);
	rmSetObjectDefMinDistance(playerberriesID, 12.0);
	rmSetObjectDefMaxDistance(playerberriesID, 14.0);
	rmAddObjectDefToClass(playerberriesID, classStartingResource);
	rmAddObjectDefConstraint(playerberriesID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerberriesID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerberriesID, avoidNatives);
	rmAddObjectDefConstraint(playerberriesID, avoidStartingResources);
	
	// Starting herd
	int playeherdID = rmCreateObjectDef("starting herd");
	rmAddObjectDefItem(playeherdID, "ypWildElephant", rmRandInt(2,2), 4.0);
	rmSetObjectDefMinDistance(playeherdID, 14.0);
	rmSetObjectDefMaxDistance(playeherdID, 16.0);
	rmSetObjectDefCreateHerd(playeherdID, true);
	rmAddObjectDefToClass(playeherdID, classStartingResource);
//	rmAddObjectDefConstraint(playeherdID, avoidTradeRoute);
//	rmAddObjectDefConstraint(playeherdID, avoidImpassableLand);
	rmAddObjectDefConstraint(playeherdID, avoidNatives);
	rmAddObjectDefConstraint(playeherdID, avoidStartingResources);
		
	// 2nd herd
	int player2ndherdID = rmCreateObjectDef("player 2nd herd");
	rmAddObjectDefItem(player2ndherdID, "ypNilgai", rmRandInt(8,8), 6.0);
    rmSetObjectDefMinDistance(player2ndherdID, 32);
    rmSetObjectDefMaxDistance(player2ndherdID, 34);
	rmAddObjectDefToClass(player2ndherdID, classStartingResource);
	rmSetObjectDefCreateHerd(player2ndherdID, true);
	rmAddObjectDefConstraint(player2ndherdID, avoidStartingResources);
	rmAddObjectDefConstraint(player2ndherdID, avoidEleShort); 
//	rmAddObjectDefConstraint(player2ndherdID, avoidTradeRouteShort);
//	rmAddObjectDefConstraint(player2ndherdID, avoidTradeRouteSocket);
//	rmAddObjectDefConstraint(player2ndherdID, avoidImpassableLand);
	rmAddObjectDefConstraint(player2ndherdID, avoidEdge);
	rmAddObjectDefConstraint(player2ndherdID, avoidNativesShort);
		

	// Starting treasures
	int playerNuggetID = rmCreateObjectDef("player nugget"); 
	rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
	rmSetNuggetDifficulty(1, 1);
	rmSetObjectDefMinDistance(playerNuggetID, 18.0);
	rmSetObjectDefMaxDistance(playerNuggetID, 28.0);
	rmAddObjectDefToClass(playerNuggetID, classStartingResource);
//	rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerNuggetID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerNuggetID, avoidNatives);
	rmAddObjectDefConstraint(playerNuggetID, avoidStartingResources);
	rmAddObjectDefConstraint(playerNuggetID, avoidNugget); //Short
	rmAddObjectDefConstraint(playerNuggetID, avoidEdge);
	int nugget0count = rmRandInt (1,2); // 1,2
	
		
	// ******** Place ********
	
	for(i=1; <numPlayer)
	{
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));

		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergoldID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergold2ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergold3ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerberriesID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playeherdID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(player2ndherdID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerNuggetID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
//		if (nugget0count == 2)
//			rmPlaceObjectDefAtLoc(playerNuggetID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
				
		if(ypIsAsian(i) && rmGetNomadStart() == false)
			rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i), i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
	}

	// ************************************************************************************************
	
	// Text
	rmSetStatusText("",0.60);
	
	// ************************************** COMMON RESOURCES ****************************************
  
   
	// ************* Mines **************
	
	int goldcount = 6;  
	
	// Common mines
	for(i=0; < goldcount)
	{
		int commongoldID = rmCreateObjectDef("common mines"+i);
		rmAddObjectDefItem(commongoldID, "Mine", 1, 0.0);
		rmSetObjectDefMinDistance(commongoldID, rmXFractionToMeters(0.0));
		rmSetObjectDefMaxDistance(commongoldID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(commongoldID, classGold);
//		rmAddObjectDefConstraint(commongoldID, avoidTradeRoute);
//		rmAddObjectDefConstraint(commongoldID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(commongoldID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(commongoldID, avoidNatives);
		rmAddObjectDefConstraint(commongoldID, avoidGoldFar);
		rmAddObjectDefConstraint(commongoldID, avoidTownCenterFar);
		rmAddObjectDefConstraint(commongoldID, avoidEdge);
		rmAddObjectDefConstraint(commongoldID, avoidCliff);
		rmAddObjectDefConstraint(commongoldID, staySouthPart);
		rmAddObjectDefConstraint(commongoldID, avoidPlayerIsland1);
		rmAddObjectDefConstraint(commongoldID, avoidPlayerIsland2);
		rmPlaceObjectDefAtLoc(commongoldID, 0, 0.50, 0.50);
	}
		
	// *********************************
	
	// Text
	rmSetStatusText("",0.70);
	
	// ************ Forest *************


	// Inland forest
	int forestinlandcount = 20;
	int stayInForestInlandPatch = -1;
	
	for (i=0; < forestinlandcount)
	{
		int forestinlandID = rmCreateArea("forest inland "+i);
		rmSetAreaWarnFailure(forestinlandID, false);
		rmSetAreaSize(forestinlandID, rmAreaTilesToFraction(110), rmAreaTilesToFraction(140));
//		rmSetAreaMix(forestinlandID, "yellow_river_forest");
		rmSetAreaObeyWorldCircleConstraint(forestinlandID, false);
//		rmSetAreaForestDensity(forestinlandID, 0.8);
//		rmSetAreaForestClumpiness(forestinlandID, 0.15);
//		rmSetAreaForestUnderbrush(forestinlandID, 0.2);
		rmSetAreaMinBlobs(forestinlandID, 2);
		rmSetAreaMaxBlobs(forestinlandID, 4);
		rmSetAreaMinBlobDistance(forestinlandID, 12.0);
		rmSetAreaMaxBlobDistance(forestinlandID, 30.0);
		rmSetAreaCoherence(forestinlandID, 0.55);
		rmSetAreaSmoothDistance(forestinlandID, 6);
		rmAddAreaToClass(forestinlandID, classForest);
		rmAddAreaConstraint(forestinlandID, avoidForest);
		rmAddAreaConstraint(forestinlandID, avoidGoldMin);
		rmAddAreaConstraint(forestinlandID, avoidEleMin); 
		rmAddAreaConstraint(forestinlandID, avoidNilgauMin); 
		rmAddAreaConstraint(forestinlandID, avoidTownCenterShort); 
		rmAddAreaConstraint(forestinlandID, avoidNativesShort);
//		rmAddAreaConstraint(forestinlandID, avoidTradeRouteShort);
//		rmAddAreaConstraint(forestinlandID, avoidTradeRouteSocket);
		rmAddAreaConstraint(forestinlandID, avoidImpassableLandMin);
//		if (i <  4)
//			rmAddAreaConstraint(forestinlandID, stayInPlayerArea1);
//		else
//			rmAddAreaConstraint(forestinlandID, stayInPlayerArea2);
		rmAddAreaConstraint(forestinlandID, avoidCliffShort);
//		rmAddAreaConstraint(forestinlandID, avoidEdge);
		rmBuildArea(forestinlandID);
		
		stayInForestInlandPatch = rmCreateAreaMaxDistanceConstraint("stay in forest inland patch"+i, forestinlandID, 0.0);
		
		for (j=0; < rmRandInt(8,10))
		{
			int forestinlandtreeID = rmCreateObjectDef("forest inland trees"+i+j);
			rmAddObjectDefItem(forestinlandtreeID, "treeyucatan", rmRandInt(1,2), 2.0);
			rmSetObjectDefMinDistance(forestinlandtreeID,  rmXFractionToMeters(0.0));
			rmSetObjectDefMaxDistance(forestinlandtreeID,  rmXFractionToMeters(0.5));
		//	rmAddObjectDefToClass(forestinlandtreeID, classForest);
		//	rmAddObjectDefConstraint(forestinlandtreeID, avoidForestShort);
		//	rmAddObjectDefConstraint(forestinlandtreeID, avoidImpassableLandShort);
			rmAddObjectDefConstraint(forestinlandtreeID, stayInForestInlandPatch);	
			rmPlaceObjectDefAtLoc(forestinlandtreeID, 0, 0.50, 0.50);
		}
	}
	

	// Marsh forest
	int forestimarshcount = 20;
	int stayInForestMarshPatch = -1;
	
	for (i=0; < forestimarshcount)
	{
		int forestmarshID = rmCreateArea("forest marsh "+i);
		rmSetAreaWarnFailure(forestmarshID, false);
		rmSetAreaSize(forestmarshID, rmAreaTilesToFraction(110), rmAreaTilesToFraction(140));
//		rmSetAreaMix(forestmarshID, "yellow_river_forest");
		rmSetAreaObeyWorldCircleConstraint(forestmarshID, false);
//		rmSetAreaForestDensity(forestmarshID, 0.8);
//		rmSetAreaForestClumpiness(forestmarshID, 0.15);
//		rmSetAreaForestUnderbrush(forestmarshID, 0.2);
		rmSetAreaMinBlobs(forestmarshID, 2);
		rmSetAreaMaxBlobs(forestmarshID, 4);
		rmSetAreaMinBlobDistance(forestmarshID, 12.0);
		rmSetAreaMaxBlobDistance(forestmarshID, 30.0);
		rmSetAreaCoherence(forestmarshID, 0.55);
		rmSetAreaSmoothDistance(forestmarshID, 6);
		rmAddAreaToClass(forestmarshID, classForest);
		rmAddAreaConstraint(forestmarshID, avoidForestShort);
		rmAddAreaConstraint(forestmarshID, avoidGoldMin);
		rmAddAreaConstraint(forestmarshID, avoidEleMin); 
		rmAddAreaConstraint(forestmarshID, avoidNilgauMin); 
		rmAddAreaConstraint(forestmarshID, avoidTownCenterShort); 
		rmAddAreaConstraint(forestmarshID, avoidNativesShort);
//		rmAddAreaConstraint(forestmarshID, avoidTradeRouteShort);
//		rmAddAreaConstraint(forestmarshID, avoidTradeRouteSocket);
//		rmAddAreaConstraint(forestmarshID, avoidImpassableLandMin);
//		if (i <  4)
//			rmAddAreaConstraint(forestmarshID, stayInPlayerArea1);
//		else
//			rmAddAreaConstraint(forestmarshID, stayInPlayerArea2);
		rmAddAreaConstraint(forestmarshID, avoidCliffShort);
//		rmAddAreaConstraint(forestmarshID, avoidEdge);
		rmBuildArea(forestmarshID);
		
		stayInForestMarshPatch = rmCreateAreaMaxDistanceConstraint("stay in forest marsh patch"+i, forestmarshID, 0.0);
		
		for (j=0; < rmRandInt(8,10))
		{
			int forestmarshtreeID = rmCreateObjectDef("forest marsh trees"+i+j);
			rmAddObjectDefItem(forestmarshtreeID, "treeyucatan", rmRandInt(1,2), 2.0);
			rmSetObjectDefMinDistance(forestmarshtreeID,  rmXFractionToMeters(0.0));
			rmSetObjectDefMaxDistance(forestmarshtreeID,  rmXFractionToMeters(0.5));
		//	rmAddObjectDefToClass(forestmarshtreeID, classForest);
		//	rmAddObjectDefConstraint(forestmarshtreeID, avoidForestShort);
//			rmAddObjectDefConstraint(forestmarshtreeID, avoidImpassableLandShort);
			rmAddObjectDefConstraint(forestmarshtreeID, stayInForestMarshPatch);	
			rmPlaceObjectDefAtLoc(forestmarshtreeID, 0, 0.50, 0.50);
		}
	}
	
	
/*	// Random trees 
	for (i=0; < 8)
	{
		int randomhightreeID = rmCreateObjectDef("random trees highground "+i);
		rmAddObjectDefItem(randomhightreeID, "ypTreeSaxaul", rmRandInt(2,4), 5.0);
		rmSetObjectDefMinDistance(randomhightreeID,  rmXFractionToMeters(0.0));
		rmSetObjectDefMaxDistance(randomhightreeID,  rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(randomhightreeID, classForest);
		rmAddObjectDefConstraint(randomhightreeID, avoidForestShort);
		rmAddObjectDefConstraint(randomhightreeID, avoidGoldMin);
		rmAddObjectDefConstraint(randomhightreeID, avoidSerowMin); 
		rmAddObjectDefConstraint(randomhightreeID, avoidSheepMin); 
		rmAddObjectDefConstraint(randomhightreeID, avoidTownCenterShort); 
		rmAddObjectDefConstraint(randomhightreeID, avoidNatives);
		rmAddObjectDefConstraint(randomhightreeID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(randomhightreeID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(randomhightreeID, avoidImpassableLand);
		rmAddObjectDefConstraint(randomhightreeID, avoidLowground);
		rmAddObjectDefConstraint(randomhightreeID, avoidHill);
		rmAddObjectDefConstraint(randomhightreeID, avoidStartingResources);
		rmPlaceObjectDefAtLoc(randomhightreeID, 0, 0.50, 0.50);
	}
*/	
	// ********************************
	
	// Text
	rmSetStatusText("",0.80);
	
	// ************ Herds *************
	
	int nilgaiherdcount = 15;
	
	
		
	//Nilgai herds
	for (i=0; < nilgaiherdcount)
	{
		int lowgroundherdID = rmCreateObjectDef("lowground herd"+i);
		rmAddObjectDefItem(lowgroundherdID, "ypNilgai", rmRandInt(6,6), 6.0);
		rmSetObjectDefMinDistance(lowgroundherdID, 0.0);
		rmSetObjectDefMaxDistance(lowgroundherdID, rmXFractionToMeters(0.6));
		rmSetObjectDefCreateHerd(lowgroundherdID, true);
		rmAddObjectDefConstraint(lowgroundherdID, avoidForestMin);
		rmAddObjectDefConstraint(lowgroundherdID, avoidGoldShort);
		rmAddObjectDefConstraint(lowgroundherdID, avoidNilgauFar); 
		rmAddObjectDefConstraint(lowgroundherdID, avoidEleFar); 
		rmAddObjectDefConstraint(lowgroundherdID, avoidTownCenter); 
		rmAddObjectDefConstraint(lowgroundherdID, avoidNatives);
//		rmAddObjectDefConstraint(lowgroundherdID, avoidTradeRouteShort);
//		rmAddObjectDefConstraint(lowgroundherdID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(lowgroundherdID, avoidCliff);
		rmAddObjectDefConstraint(lowgroundherdID, avoidEdge);
//		if (i < 2)
//			rmAddObjectDefConstraint(lowgroundherdID, staySW);
//		else if (i < 4)
//			rmAddObjectDefConstraint(lowgroundherdID, stayNE);
		rmPlaceObjectDefAtLoc(lowgroundherdID, 0, 0.50, 0.50);	
	}
	

	// ************************************
	
	// Text
	rmSetStatusText("",0.90);
		
	// ************** Treasures ***************
	
	int treasure1count = 8;
	int treasure2count = 6;
		
	// Treasures lvl2	
	for (i=0; < treasure2count)
	{
		int Nugget2ID = rmCreateObjectDef("nugget lvl2 "+i); 
		rmAddObjectDefItem(Nugget2ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(Nugget2ID, 0);
		rmSetObjectDefMaxDistance(Nugget2ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(2,2);
		rmAddObjectDefConstraint(Nugget2ID, avoidNugget);
		rmAddObjectDefConstraint(Nugget2ID, avoidNatives);
//		rmAddObjectDefConstraint(Nugget2ID, avoidTradeRouteShort);
//		rmAddObjectDefConstraint(Nugget2ID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(Nugget2ID, avoidImpassableLandMin);
		rmAddObjectDefConstraint(Nugget2ID, avoidGoldMin);
		rmAddObjectDefConstraint(Nugget2ID, avoidTownCenter);
		rmAddObjectDefConstraint(Nugget2ID, avoidNilgauMin); 
		rmAddObjectDefConstraint(Nugget2ID, avoidForestMin);	
		rmAddObjectDefConstraint(Nugget2ID, avoidEdge); 
		rmAddObjectDefConstraint(Nugget2ID, avoidCliff);
//		if (i < 2)
//			rmAddObjectDefConstraint(Nugget2ID, staySouthHalf); 
//		else if (i < 4)
//			rmAddObjectDefConstraint(Nugget2ID, stayNorthHalf); 
		rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.50, 0.50);
	}
	
	// Treasures lvl1
	for (i=0; < treasure1count)
	{
		int Nugget1ID = rmCreateObjectDef("nugget lvl1 "+i); 
		rmAddObjectDefItem(Nugget1ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(Nugget1ID, 0);
		rmSetObjectDefMaxDistance(Nugget1ID, rmXFractionToMeters(0.5));
		rmSetNuggetDifficulty(1,1);
		rmAddObjectDefConstraint(Nugget1ID, avoidNugget);
		rmAddObjectDefConstraint(Nugget1ID, avoidNatives);
//		rmAddObjectDefConstraint(Nugget1ID, avoidTradeRouteShort);
//		rmAddObjectDefConstraint(Nugget1ID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(Nugget1ID, avoidImpassableLandMin);
		rmAddObjectDefConstraint(Nugget1ID, avoidGoldMin);
		rmAddObjectDefConstraint(Nugget1ID, avoidTownCenter);
		rmAddObjectDefConstraint(Nugget1ID, avoidNilgauMin); 
		rmAddObjectDefConstraint(Nugget1ID, avoidForestMin);	
		rmAddObjectDefConstraint(Nugget1ID, avoidEdge); 
		rmAddObjectDefConstraint(Nugget1ID, avoidCliff);
		rmPlaceObjectDefAtLoc(Nugget1ID, 0, 0.50, 0.50);
	}
	
	// ****************************************

	// Text
	rmSetStatusText("",1.00);
	
} //END
	
	