// ESOC HUDSON BAY
// designed by Garja

int PlayerNum=2;
int numPlayer=3;

include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";



// Main entry point for random map script
void main(void)
{
		
	// Text
	// These status text lines are used to manually animate the map generation progress bar
	rmSetStatusText("",0.01); 
	
	// ************************************** GENERAL FEATURES *****************************************
	
	// Picks the map size
	int playerTiles=11000; //11000
	int size=2.0*sqrt(PlayerNum*playerTiles); //2.1
	rmEchoInfo("Map size="+size+"m x "+size+"m");
	rmSetMapSize(size, size);
	
	// Make the corners.
	rmSetWorldCircleConstraint(true);
	
	// Picks a default water height
	rmSetSeaLevel(5.0);	// this is height of river surface compared to surrounding land. River depth is in the river XML.

	rmSetMapElevationParameters(cElevTurbulence, 0.05, 2, 0.5, 4.5); // type, frequency, octaves, persistence, variation 
//	rmSetMapElevationHeightBlend(1);
	
	//Choose the map variation
	float randomfrozen = -1;
	randomfrozen = rmRandFloat(0.1,1.0); // 0.1-0.5 frozen
//	randomfrozen = 0.55; //<----- TEST
	
	// Picks default terrain and water
	rmSetSeaType("hudson bay");
	if (randomfrozen >= 0.5)
	{
	rmSetBaseTerrainMix("saguenay tundra"); // 
	rmTerrainInitialize("saguenay\ground6_sag", 5.0); // 
	rmSetMapType("saguenay"); 
	}
	else
	{
	rmSetBaseTerrainMix("yukon snow"); // 
	rmTerrainInitialize("yukon\ground1_yuk", 5.0); // 
	rmSetMapType("yukon"); 
	}	
	rmSetMapType("snow");
	rmSetMapType("water");
	if (randomfrozen >= 0.5)
	rmSetLightingSet("carolina");
	else
	rmSetLightingSet("Great Lakes Winter"); // rockies

	// Choose Mercs
	chooseMercs();
	
	// Text
	rmSetStatusText("",0.10);
	
	// Set up Natives
	int subCiv0 = -1;
	int subCiv1 = -1;
	subCiv0 = rmGetCivID("Cree");
	subCiv1 = rmGetCivID("Huron");
	rmSetSubCiv(0, "Cree");
	rmSetSubCiv(1, "Huron");
//	rmEchoInfo("subCiv0 is Cree "+subCiv0);
//	rmEchoInfo("subCiv1 is Huron "+subCiv1);
//	string nativeName0 = "native Cree village";
//	string nativeName1 = "native Huron village";
	

	//Define some classes. These are used later for constraints.
	int classPlayer = rmDefineClass("player");
	rmDefineClass("classHill");
	int classPatch = rmDefineClass("patch");
	int classPatch2 = rmDefineClass("patch2");
	int classPatch3 = rmDefineClass("patch3");
	int classPond = rmDefineClass("pond");
	int classRocks = rmDefineClass("rocks");
	int classGrass = rmDefineClass("grass");
	rmDefineClass("starting settlement");
	rmDefineClass("startingUnit");
	int classForest = rmDefineClass("Forest");
	int importantItem = rmDefineClass("importantItem");
	int classNative = rmDefineClass("natives");
	int classCliff = rmDefineClass("Cliffs");
	int classGold = rmDefineClass("Gold");
	int classStartingResource = rmDefineClass("startingResource");
	
	// ******************************************************************************************
	
	// Text
	rmSetStatusText("",0.20);
	
	// ************************************* CONTRAINTS *****************************************
	// These are used to have objects and areas avoid each other
   
	// Cardinal Directions & Map placement
	int avoidEdge = rmCreatePieConstraint("Avoid Edge",0.5,0.5, rmXFractionToMeters(0.0),rmXFractionToMeters(0.47), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int avoidEdgeMore = rmCreatePieConstraint("Avoid Edge More",0.5,0.5, rmXFractionToMeters(0.0),rmXFractionToMeters(0.38), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int avoidCenter = rmCreatePieConstraint("Avoid Center",0.4,0.4,rmXFractionToMeters(0.26), rmXFractionToMeters(0.5), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int stayCenter = rmCreatePieConstraint("Stay Center",0.46,0.46,rmXFractionToMeters(0.0), rmXFractionToMeters(0.28), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int stayCenterMore = rmCreatePieConstraint("Stay Center more",0.45,0.45,rmXFractionToMeters(0.0), rmXFractionToMeters(0.26), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int staySouth = rmCreatePieConstraint("Stay South",0.30,0.30,rmXFractionToMeters(0.0), rmXFractionToMeters(0.50), rmDegreesToRadians(135),rmDegreesToRadians(315));
		
	// Resource avoidance
	int avoidForest=rmCreateClassDistanceConstraint("avoid forest", rmClassID("Forest"), 28.0); //15.0
	int avoidForestShort=rmCreateClassDistanceConstraint("avoid forest short", rmClassID("Forest"), 24.0); //15.0
	int avoidForestMin=rmCreateClassDistanceConstraint("avoid forest min", rmClassID("Forest"), 4.0);
	int avoidMooseFar = rmCreateTypeDistanceConstraint("avoid moose far", "moose", 52.0);
	int avoidMoose = rmCreateTypeDistanceConstraint("avoid moose", "moose", 44.0);
	int avoidMooseShort = rmCreateTypeDistanceConstraint("avoid moose short", "moose", 25.0);
	int avoidMooseMin = rmCreateTypeDistanceConstraint("avoid moose min", "moose", 5.0);
	int avoidCaribouFar = rmCreateTypeDistanceConstraint("avoid caribou far", "caribou", 54.0);
	int avoidCaribou = rmCreateTypeDistanceConstraint("avoid  caribou", "caribou", 45.0);
	int avoidCaribouShort = rmCreateTypeDistanceConstraint("avoid  caribou short", "caribou", 30.0);
	int avoidCaribouMin = rmCreateTypeDistanceConstraint("avoid caribou min", "caribou", 5.0);
	int avoidElk = rmCreateTypeDistanceConstraint("elk avoids elk", "elk", 44.0);
	int avoidElkShort = rmCreateTypeDistanceConstraint("elk avoids elk short", "elk", 28.0);
	int avoidElkMin = rmCreateTypeDistanceConstraint("elk avoids elk min", "elk", 5.0);
	int avoidMuskOxFar = rmCreateTypeDistanceConstraint("avoid muskox far", "muskOx", 56.0);
	int avoidMuskOx = rmCreateTypeDistanceConstraint("avoid muskox ", "muskOx", 45.0);
	int avoidMuskOxMin = rmCreateTypeDistanceConstraint("avoid muskox min ", "muskOx", 5.0);
	int avoidGoldMed = rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 25.0);
	int avoidGoldTypeShort = rmCreateTypeDistanceConstraint("coin avoids coin short", "gold", 8.0);
	int avoidGoldType = rmCreateTypeDistanceConstraint("coin avoids coin ", "gold", 12.0);
	int avoidGoldTypeFar = rmCreateTypeDistanceConstraint("coin avoids coin far ", "gold", 50.0);
	int avoidGoldMin = rmCreateClassDistanceConstraint("min distance vs gold", rmClassID("Gold"), 4.0);
	int avoidGold = rmCreateClassDistanceConstraint ("gold avoid gold med", rmClassID("Gold"), 30.0);
	int avoidGoldFar = rmCreateClassDistanceConstraint ("gold avoid gold far", rmClassID("Gold"), 62.0);
//	int avoidGoldVeryFar = rmCreateClassDistanceConstraint ("gold avoid gold very ", rmClassID("Gold"), 74.0);
	int avoidNuggetMin = rmCreateTypeDistanceConstraint("nugget avoid nugget min", "AbstractNugget", 10.0);
	int avoidNuggetShort = rmCreateTypeDistanceConstraint("nugget avoid nugget short", "AbstractNugget", 30.0);
	int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 38.0);
	int avoidNuggetFar = rmCreateTypeDistanceConstraint("nugget avoid nugget Far", "AbstractNugget", 48.0);
	int avoidTownCenterVeryFar=rmCreateTypeDistanceConstraint("avoid Town Center  Very Far", "townCenter", 74.0);
	int avoidTownCenterFar=rmCreateTypeDistanceConstraint("avoid Town Center Far", "townCenter", 62.0);
	int avoidTownCenter=rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 31.0);
//	int avoidTownCenterMed=rmCreateTypeDistanceConstraint("avoid Town Center med", "townCenter", 40.0);
	int avoidTownCenterShort=rmCreateTypeDistanceConstraint("avoid Town Center short", "townCenter", 25.0);
	int avoidTownCenterMin=rmCreateTypeDistanceConstraint("avoid Town Center min", "townCenter", 18.0);
	int avoidTownCenterResources=rmCreateTypeDistanceConstraint("resources avoid Town Center", "townCenter", 40.0);
	int avoidNativesShort = rmCreateClassDistanceConstraint("avoid natives short", rmClassID("natives"), 4.0);
	int avoidNatives = rmCreateClassDistanceConstraint("avoid natives", rmClassID("natives"), 10.0);
	int avoidNativesFar = rmCreateClassDistanceConstraint("avoid natives far", rmClassID("natives"), 15.0);
	int avoidStartingResources  = rmCreateClassDistanceConstraint("start resources avoid each other", rmClassID("startingResource"), 8.0);
	int avoidWhale=rmCreateTypeDistanceConstraint("avoid whale", "fish", 28.0);
	int avoidFish=rmCreateTypeDistanceConstraint("avoid fish", "fish", 18.0);
	int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 61.0);
	int avoidColonyShip = rmCreateTypeDistanceConstraint("avoid colony ship", "HomeCityWaterSpawnFlag", 30.0);
	int avoidColonyShipShort = rmCreateTypeDistanceConstraint("avoid colony ship short", "HomeCityWaterSpawnFlag", 15.0);

	// Avoid impassable land
	int avoidImpassableLand = rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 8.0);
	int avoidImpassableLandFar=rmCreateTerrainDistanceConstraint("avoid impassable land far", "Land", false, 22.0);
	int avoidImpassableLandShort = rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 4.0);
	int avoidImpassableLandMed=rmCreateTerrainDistanceConstraint("medium avoid impassable land", "Land", false, 15.0);
	int stayNearLand = rmCreateTerrainMaxDistanceConstraint("stay near land ", "Land", true, 5.0);
	int avoidLand = rmCreateTerrainDistanceConstraint("avoid land ", "Land", true, 8.0);
	int avoidLandFar = rmCreateTerrainDistanceConstraint("avoid land far ", "Land", true, 12.0);
	int avoidWater = rmCreateTerrainDistanceConstraint("avoid water ", "water", true, 10);
	int stayNearWater = rmCreateTerrainMaxDistanceConstraint("stay near water ", "water", true, 2.0);
	int stayInWater = rmCreateTerrainMaxDistanceConstraint("stay in water ", "water", true, 0.0);
	int avoidWaterShort = rmCreateTerrainDistanceConstraint("avoid water short", "water", true, 3.0);
	int avoidPatch = rmCreateClassDistanceConstraint("avoid patch", rmClassID("patch"), 22.0);
	int avoidPatch2 = rmCreateClassDistanceConstraint("avoid patch2", rmClassID("patch2"), 10.0);
	int avoidPatch3 = rmCreateClassDistanceConstraint("avoid patch3", rmClassID("patch3"), 5.0);
	int avoidPond = rmCreateClassDistanceConstraint("avoid pond", rmClassID("pond"), 40.0);
	int avoidRock = rmCreateClassDistanceConstraint("rock avoids rock", rmClassID("rocks"), 10.0);
	int avoidRockFar = rmCreateClassDistanceConstraint("rock avoids rock far", rmClassID("rocks"), 25.0);
	int avoidGrass = rmCreateClassDistanceConstraint("grass avoid grass", rmClassID("grass"), 15.0);
	int rockVsLand = rmCreateTerrainDistanceConstraint("rock v. land", "land", true, 2.0);
	int rockVsWater=rmCreateTerrainMaxDistanceConstraint("rock v. water", "land", true, 5.0);
	
	// Unit avoidance
	int avoidStartingUnits = rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 35.0);	
	
	// VP avoidance
	int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
	int avoidTradeRouteShort = rmCreateTradeRouteDistanceConstraint("trade route short", 6.0);
	int avoidTradeRouteSocket = rmCreateTypeDistanceConstraint("avoid trade route socket", "socketTradeRoute", 8.0);
	int avoidTradeRouteSocketShort = rmCreateTypeDistanceConstraint("avoid trade route socket short", "socketTradeRoute", 3.0);
	int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 10.0);
   
	
	// ***********************************************************************************************
	
	// **************************************** PLACE PLAYERS ****************************************

	int teamZeroCount = rmGetNumberPlayersOnTeam(0);
	int teamOneCount = rmGetNumberPlayersOnTeam(1);
	
	// 2 team and FFA support
	float OneVOnePlacement=rmRandFloat(0, 1);
	if (PlayerNum == 2)
	{

		if ( OneVOnePlacement < 0.5)
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.21, 0.72, 0.4, 0.20, 0, 0.0); // disregard line end

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.71, 0.22, 0.4, 0.8, 0, 0.0); // disregard line end
		}
		else
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.71, 0.22, 0.4, 0.8, 0, 0.0);

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.21, 0.72, 0.4, 0.20, 0, 0.0);
		}
		
	}
	
/*	// Team placement
	else if ( PlayerNum == 2 && teamZeroCount == teamOneCount)
	{

		rmSetPlacementTeam(0);
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersLine(0.2, 0.2, 0.5, 0.2, 0, 0.0);

		rmSetPlacementTeam(1);
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersLine(0.8, 0.8, 0.5, 0.8, 0, 0.0);
	
	}
	// FFA support
	else if (PlayerNum > 2)
	{
      bool southSide = true;

      float spacingIncrement = (0.35 / (PlayerNum / 2));
      float spacingSouth = 0;
      float spacingNorth = 0;
      
      float southStart = 0.45;
      float southEnd = 0.82;
      float northStart = 0.95;
      float northEnd = 0.32;

      for (i = 0; < PlayerNum)
      {
         rmEchoInfo("i = "+i);
         if (southSide == true)
         {
            rmSetPlacementTeam(i);
            rmSetPlacementSection((southStart + spacingSouth), southEnd);
	         rmSetTeamSpacingModifier(0.25);
	         rmPlacePlayersCircular(0.4, 0.4, 0);
            spacingSouth = spacingSouth + spacingIncrement;
         }
         else
         {
            rmSetPlacementTeam(i);
            rmSetPlacementSection((northStart + spacingNorth), northEnd);
	         rmSetTeamSpacingModifier(0.25);
	         rmPlacePlayersCircular(0.4, 0.4, 0);
            spacingNorth = spacingNorth + spacingIncrement;
         }
         if (southSide == true)
         {
            southSide = false;
         }
         else
         {
            southSide = true;
         }
      }
   }
   else 
   {
      if (teamZeroCount < teamOneCount)
      {
         rmSetPlacementTeam(0);
         rmSetPlacementSection(0.55, 0.75);
		   rmSetTeamSpacingModifier(0.35 / teamZeroCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);

		   rmSetPlacementTeam(1);
         rmSetPlacementSection(0.95, 0.32);
		   rmSetTeamSpacingModifier(0.35 / teamOneCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);
      }
      else 
      {
         rmSetPlacementTeam(0);
         rmSetPlacementSection(0.45, 0.82);
		   rmSetTeamSpacingModifier(0.35 / teamZeroCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);

		   rmSetPlacementTeam(1);
         rmSetPlacementSection(0.0, 0.2);
		   rmSetTeamSpacingModifier(0.35 / teamOneCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);
      }
   }
*/
	// **************************************************************************************************
   
	// Text
	rmSetStatusText("",0.30);
	
	// ******************************************** MAP LAYOUT **************************************************
	
	//Bay
	if (randomfrozen >= 0.5)
	{
		int HudsonBayWaterID = rmCreateArea("Hudson Bay Water");
		rmSetAreaSize(HudsonBayWaterID, 0.22, 0.22);
		rmSetAreaLocation(HudsonBayWaterID, 0.9, 0.9);
		rmAddAreaInfluenceSegment(HudsonBayWaterID, 0.65, 1.0, 0.58, 0.69); // 0.62, 0.62
		rmAddAreaInfluenceSegment(HudsonBayWaterID, 1.0, 0.65, 0.69, 0.58);
		rmAddAreaInfluenceSegment(HudsonBayWaterID, 1.0, 1.0, 0.625, 0.625);
		rmSetAreaWaterType(HudsonBayWaterID, "Hudson Bay"); //yukon river
	//  rmSetAreaBaseHeight(HudsonBayWaterID, 3.0); 
		rmSetAreaMinBlobs(HudsonBayWaterID, 8);
		rmSetAreaMaxBlobs(HudsonBayWaterID, 10);
		rmSetAreaMinBlobDistance(HudsonBayWaterID, 10);
		rmSetAreaMaxBlobDistance(HudsonBayWaterID, 20);
		rmSetAreaSmoothDistance(HudsonBayWaterID, 26);
		rmSetAreaCoherence(HudsonBayWaterID, 0.6);
		rmSetAreaHeightBlend(HudsonBayWaterID, 1.8);
		rmSetAreaObeyWorldCircleConstraint(HudsonBayWaterID, false);
		rmBuildArea(HudsonBayWaterID);
		
		int stayNearBayWater = rmCreateAreaMaxDistanceConstraint("stay near bay water", HudsonBayWaterID, 6);
		int stayCloseToBayWater = rmCreateAreaMaxDistanceConstraint("stay close to bay water", HudsonBayWaterID, 28);
		int avoidBayWater = rmCreateAreaDistanceConstraint("avoid bay water", HudsonBayWaterID, 2.01);
		int avoidBayWaterFar = rmCreateAreaDistanceConstraint("avoid bay water far", HudsonBayWaterID, 32);
	}
	else
	{
		int HudsonBayWaterIceID = rmCreateArea("Hudson Bay Water Ice");
		rmSetAreaSize(HudsonBayWaterIceID, 0.16, 0.16);
		rmSetAreaLocation(HudsonBayWaterIceID, 0.9, 0.9);
		rmAddAreaInfluenceSegment(HudsonBayWaterIceID, 0.68, 1.0, 0.62, 0.72); // 0.62, 0.62
		rmAddAreaInfluenceSegment(HudsonBayWaterIceID, 1.0, 0.68, 0.72, 0.62);
		rmAddAreaInfluenceSegment(HudsonBayWaterIceID, 1.0, 1.0, 0.66, 0.66);
		rmSetAreaWaterType(HudsonBayWaterIceID, "great lakes ice"); //yukon river
	//  rmSetAreaBaseHeight(HudsonBayWaterIceID, 3.0); 
		rmSetAreaMinBlobs(HudsonBayWaterIceID, 8);
		rmSetAreaMaxBlobs(HudsonBayWaterIceID, 10);
		rmSetAreaMinBlobDistance(HudsonBayWaterIceID, 10);
		rmSetAreaMaxBlobDistance(HudsonBayWaterIceID, 20);
		rmSetAreaSmoothDistance(HudsonBayWaterIceID, 26);
		rmSetAreaCoherence(HudsonBayWaterIceID, 0.50);
		rmSetAreaHeightBlend(HudsonBayWaterIceID, 1.8);
		rmSetAreaObeyWorldCircleConstraint(HudsonBayWaterIceID, false);
		rmBuildArea(HudsonBayWaterIceID);
		
		int stayNearBayWaterIce = rmCreateAreaMaxDistanceConstraint("stay near bay water ice", HudsonBayWaterIceID, 22);
		int avoidBayWaterIce = rmCreateAreaDistanceConstraint("avoid bay water ice", HudsonBayWaterIceID, 2.01);
		int avoidBayWaterIceFar = rmCreateAreaDistanceConstraint("avoid bay water ice far", HudsonBayWaterIceID, 32);
		
	}
	
	// Coast
	if (randomfrozen >= 0.5)
	{
		int CoastareaID = rmCreateArea("Coast area");
		rmSetAreaSize(CoastareaID, 0.10, 0.10);
//		rmSetAreaTerrainType(CoastareaID, "saguenay\shoreline3_sag");
		rmSetAreaCoherence(CoastareaID, 0.2); 
		rmSetAreaSmoothDistance(CoastareaID, 2);
		rmAddAreaConstraint(CoastareaID, avoidBayWater);
		rmAddAreaConstraint(CoastareaID, stayNearBayWater);
		rmSetAreaObeyWorldCircleConstraint(CoastareaID, false);
		rmBuildArea(CoastareaID); 
		
	int stayInCoastArea = rmCreateAreaMaxDistanceConstraint("stay in coast area", CoastareaID, 0);
	}
	else
	{
		int IceareaID = rmCreateArea("ice area");
		rmSetAreaSize(IceareaID, 0.22, 0.22);
		rmSetAreaMix(IceareaID, "great_lakes_ice");
		rmSetAreaBaseHeight(IceareaID, 1.5); 
//		rmSetAreaTerrainType(IceareaID, "great_lakes\ground_ice1_gl");
		rmSetAreaCoherence(IceareaID, 0.5); 
		rmSetAreaSmoothDistance(IceareaID, 2);
		rmAddAreaConstraint(IceareaID, avoidBayWaterIce);
		rmAddAreaConstraint(IceareaID, stayNearBayWaterIce);
		rmSetAreaObeyWorldCircleConstraint(IceareaID, false);
		rmBuildArea(IceareaID); 
		
		int avoidIceArea = rmCreateAreaDistanceConstraint("avoid ice area", IceareaID, 3.0);
		int avoidIceAreaFar = rmCreateAreaDistanceConstraint("avoid ice area far", IceareaID, 6);
		int avoidIceAreaVeryFar = rmCreateAreaDistanceConstraint("avoid ice area very far", IceareaID, 11);
		int stayNearIceArea = rmCreateAreaMaxDistanceConstraint("stay near ice area", IceareaID, 15);
	}
	
	
	// Terrain patches
	if (randomfrozen >= 0.5)
	{
		for (i=0; < 40)
		{
			int patch2ID = rmCreateArea("patch orange grass"+i);
			rmSetAreaWarnFailure(patch2ID, false);
			rmSetAreaSize(patch2ID, rmAreaTilesToFraction(30), rmAreaTilesToFraction(60));
			rmSetAreaTerrainType(patch2ID, "saguenay\ground6_sag");
			rmPaintAreaTerrain(patch2ID);
			rmAddAreaToClass(patch2ID, rmClassID("patch2"));
			rmSetAreaMinBlobs(patch2ID, 1);
			rmSetAreaMaxBlobs(patch2ID, 5);
			rmSetAreaMinBlobDistance(patch2ID, 16.0);
			rmSetAreaMaxBlobDistance(patch2ID, 40.0);
			rmSetAreaCoherence(patch2ID, 0.0);
			rmAddAreaConstraint(patch2ID, avoidImpassableLand);
			rmAddAreaConstraint(patch2ID, avoidPatch2);
			rmBuildArea(patch2ID); 
		}
	}
	else
	{
		for (i=0; < 15)
		{
			int patchID = rmCreateArea("patch snowgrass"+i);
			rmSetAreaWarnFailure(patchID, false);
			rmSetAreaSize(patchID, rmAreaTilesToFraction(100), rmAreaTilesToFraction(200));
			rmSetAreaMix(patchID, "yukon grass"); //ground6_yuk
			rmPaintAreaTerrain(patchID);
			rmAddAreaToClass(patchID, rmClassID("patch"));
			rmSetAreaMinBlobs(patchID, 1);
			rmSetAreaMaxBlobs(patchID, 5);
			rmSetAreaMinBlobDistance(patchID, 20.0);
			rmSetAreaMaxBlobDistance(patchID, 40.0);
			rmSetAreaCoherence(patchID, 0.0);
			rmSetAreaSmoothDistance(patchID, 1);
			rmAddAreaConstraint(patchID, avoidImpassableLand);
			rmAddAreaConstraint(patchID, avoidIceArea);
			rmAddAreaConstraint(patchID, avoidPatch);
			rmBuildArea(patchID); 
		}
	}
	
	//Islands
	if (randomfrozen >= 0.5)
	{
		int IslandgrassID = rmCreateArea("grass island 1");
		rmSetAreaSize(IslandgrassID, rmAreaTilesToFraction(200), rmAreaTilesToFraction(250));
		rmSetAreaLocation(IslandgrassID, rmRandFloat(0.62,0.66), rmRandFloat(0.82, 0.88));
		rmSetAreaMix(IslandgrassID, "saguenay tundra");
		rmSetAreaBaseHeight(IslandgrassID, 2.5);
		rmSetAreaElevationType(IslandgrassID, cElevTurbulence);
		rmSetAreaElevationVariation(IslandgrassID, 3.0);
		rmSetAreaMinBlobs(IslandgrassID, 3);
		rmSetAreaMaxBlobs(IslandgrassID, 5);
		rmSetAreaMinBlobDistance(IslandgrassID, 4);
		rmSetAreaMaxBlobDistance(IslandgrassID, 7);
		rmSetAreaSmoothDistance(IslandgrassID, 5);
		rmSetAreaCoherence(IslandgrassID, 0.45);
		rmBuildArea(IslandgrassID); 
		int stayInIsland1 = rmCreateAreaMaxDistanceConstraint("stay in island 1", IslandgrassID, 0);
		int stayNearIsland1 = rmCreateAreaMaxDistanceConstraint("stay near island 1", IslandgrassID, 5);
		int avoidIsland1 = rmCreateAreaDistanceConstraint("avoid island 1", IslandgrassID, 2);
		
		int Islandgrass2ID = rmCreateArea("grass island 2");
		rmSetAreaSize(Islandgrass2ID, rmAreaTilesToFraction(200), rmAreaTilesToFraction(250));
		rmSetAreaLocation(Islandgrass2ID, rmRandFloat(0.82,0.88), rmRandFloat(0.62, 0.66));
		rmSetAreaMix(Islandgrass2ID, "saguenay tundra");
		rmSetAreaBaseHeight(Islandgrass2ID, 3.0);
		rmSetAreaElevationType(Islandgrass2ID, cElevTurbulence);
		rmSetAreaElevationVariation(Islandgrass2ID, 2.5);
		rmSetAreaMinBlobs(Islandgrass2ID, 3);
		rmSetAreaMaxBlobs(Islandgrass2ID, 5);
		rmSetAreaMinBlobDistance(Islandgrass2ID, 4);
		rmSetAreaMaxBlobDistance(Islandgrass2ID, 7);
		rmSetAreaSmoothDistance(Islandgrass2ID, 5);
		rmSetAreaCoherence(Islandgrass2ID, 0.45);
		rmBuildArea(Islandgrass2ID); 
		int stayInIsland2 = rmCreateAreaMaxDistanceConstraint("stay in island 2", Islandgrass2ID, 0);
		int stayNearIsland2 = rmCreateAreaMaxDistanceConstraint("stay near island 2", Islandgrass2ID, 5);
		int avoidIsland2 = rmCreateAreaDistanceConstraint("avoid island 2", Islandgrass2ID, 2);
	}
	else
	{
	/*
		int IslandSnowID = rmCreateArea("snow island 1");
		rmSetAreaSize(IslandSnowID, rmAreaTilesToFraction(210), rmAreaTilesToFraction(250));
		rmSetAreaLocation(IslandSnowID, rmRandFloat(0.70,0.88), rmRandFloat(0.70, 0.88));
		rmSetAreaBaseHeight(IslandSnowID, 0.0);
		rmSetAreaMix(IslandSnowID, "great_lakes_ice");
//		rmSetAreaTerrainType(IslandSnowID, "great_lakes\ground_snow2_gl");
//		rmSetAreaElevationType(IslandSnowID, cElevTurbulence);
//		rmSetAreaElevationVariation(IslandSnowID, 2.5);
		rmSetAreaMinBlobs(IslandSnowID, 3);
		rmSetAreaMaxBlobs(IslandSnowID, 5);
		rmSetAreaMinBlobDistance(IslandSnowID, 4);
		rmSetAreaMaxBlobDistance(IslandSnowID, 7);
		rmSetAreaSmoothDistance(IslandSnowID, 5);
		rmSetAreaCoherence(IslandSnowID, 0.4);
		rmBuildArea(IslandSnowID); 
	*/
	}
	
	// Players area
	for (i=1; < numPlayer)
	{
	int playerareaID = rmCreateArea("playerarea"+i);
	rmSetPlayerArea(i, playerareaID);
	rmSetAreaSize(playerareaID, 0.1, 0.1);
	rmSetAreaCoherence(playerareaID, 1.0);
	rmSetAreaWarnFailure(playerareaID, false);
//	rmSetAreaTerrainType(playerareaID, "new_england\ground2_cliff_ne"); // for testing
	rmSetAreaLocPlayer(playerareaID, i);
	rmSetAreaObeyWorldCircleConstraint(playerareaID, false);
	rmBuildArea(playerareaID);
	int avoidPlayerArea = rmCreateAreaDistanceConstraint("avoid player area "+i, playerareaID, 3.0);
	int stayPlayerArea = rmCreateAreaMaxDistanceConstraint("stay in player area "+i, playerareaID, 0.0);
	}
	
	int avoidPlayerArea1 = rmConstraintID("avoid player area 1");
	int avoidPlayerArea2 = rmConstraintID("avoid player area 2");
	int stayInPlayerArea1 = rmConstraintID("stay in player area 1");
	int stayInPlayerArea2 = rmConstraintID("stay in player area 2");

	// *********************************************************************************************************
	
	// Text
	rmSetStatusText("",0.40);
	
		// ****************************************** TRADE ROUTE **********************************************
	float TPvariation = -1;
	TPvariation = rmRandFloat(0.1,1.0);
//	TPvariation = 0.6; // <--- TEST
	
	if (TPvariation > 0.5)
	{
		int tradeRouteID = rmCreateTradeRoute();
		int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
		rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
		rmSetObjectDefAllowOverlap(socketID, true);
		rmSetObjectDefMinDistance(socketID, 0.0);
		rmSetObjectDefMaxDistance(socketID, 8.0);

		
		rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
		rmAddTradeRouteWaypoint(tradeRouteID, rmRandFloat(0.51,0.54), 0.01); 
		rmAddTradeRouteWaypoint(tradeRouteID, rmRandFloat(0.52,0.58), rmRandFloat(0.08,0.12)); 
		rmAddTradeRouteWaypoint(tradeRouteID, 0.50, 0.36); 
		rmAddTradeRouteWaypoint(tradeRouteID, rmRandFloat(0.43,0.46), rmRandFloat(0.43,0.46));
		rmAddTradeRouteWaypoint(tradeRouteID, 0.36, 0.50); 
		rmAddTradeRouteWaypoint(tradeRouteID, rmRandFloat(0.08,0.12), rmRandFloat(0.52,0.58)); 
		rmAddTradeRouteWaypoint(tradeRouteID, 0.01, rmRandFloat(0.51,0.54)); 
		
		bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
		if(placedTradeRoute == false)
		rmEchoError("Failed to place trade route");
		rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
		vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.05);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.35);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.65);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.96);
		rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
	}
	else
	{
		int tradeRoute2ID = rmCreateTradeRoute();
		int socket2ID=rmCreateObjectDef("sockets to dock Trade Posts 2");
		rmAddObjectDefItem(socket2ID, "SocketTradeRoute", 1, 0.0);
		rmSetObjectDefAllowOverlap(socket2ID, true);
		rmSetObjectDefMinDistance(socket2ID, 0.0);
		rmSetObjectDefMaxDistance(socket2ID, 6.0);

		if (randomfrozen >= 0.5)
		{
			rmSetObjectDefTradeRouteID(socket2ID, tradeRoute2ID);
			rmAddTradeRouteWaypoint(tradeRoute2ID, rmRandFloat(0.10,0.10), rmRandFloat(0.10,0.10)); 
			rmAddTradeRouteWaypoint(tradeRoute2ID, rmRandFloat(0.16,0.24), rmRandFloat(0.16,0.24)); 
			rmAddTradeRouteWaypoint(tradeRoute2ID, rmRandFloat(0.26,0.34), rmRandFloat(0.26,0.34));
			rmAddTradeRouteWaypoint(tradeRoute2ID, rmRandFloat(0.36,0.44), rmRandFloat(0.36,0.44)); 
			rmAddTradeRouteWaypoint(tradeRoute2ID, rmRandFloat(0.47,0.47), rmRandFloat(0.47,0.47)); 
		}
		else
		{
			rmSetObjectDefTradeRouteID(socket2ID, tradeRoute2ID);
			rmAddTradeRouteWaypoint(tradeRoute2ID, rmRandFloat(0.10,0.10), rmRandFloat(0.10,0.10)); 
			rmAddTradeRouteWaypoint(tradeRoute2ID, rmRandFloat(0.20,0.28), rmRandFloat(0.20,0.28)); 
			rmAddTradeRouteWaypoint(tradeRoute2ID, rmRandFloat(0.31,0.37), rmRandFloat(0.31,0.37));
			rmAddTradeRouteWaypoint(tradeRoute2ID, rmRandFloat(0.40,0.48), rmRandFloat(0.40,0.48)); 
			rmAddTradeRouteWaypoint(tradeRoute2ID, rmRandFloat(0.48,0.48), rmRandFloat(0.48,0.48)); 
		}
		
		bool placedTradeRoute2 = rmBuildTradeRoute(tradeRoute2ID, "dirt");
		if(placedTradeRoute2 == false)
		rmEchoError("Failed to place trade route 2");
		rmSetObjectDefTradeRouteID(socket2ID, tradeRoute2ID);
		vector socketLoc2 = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.25);
		rmPlaceObjectDefAtPoint(socket2ID, 0, socketLoc2);
		socketLoc2 = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.60);
		rmPlaceObjectDefAtPoint(socket2ID, 0, socketLoc2);
		socketLoc2 = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.95);
		rmPlaceObjectDefAtPoint(socket2ID, 0, socketLoc2);
	}
	
	// *************************************************************************************************************
		
	// Text
	rmSetStatusText("",0.45);
	
	// ******************************************** NATIVES *************************************************

	int nativeID0 = -1;
    int nativeID1 = -1;
	int nativeID2 = -1;
    int nativeID3 = -1;
		
	nativeID0 = rmCreateGrouping("Cree village", "native cree village "+4);
    rmSetGroupingMinDistance(nativeID0, 0.00);
    rmSetGroupingMaxDistance(nativeID0, 0.00);
//	rmAddGroupingConstraint(nativeID0, avoidImpassableLand);
	rmAddGroupingToClass(nativeID0, rmClassID("natives"));
//  rmAddGroupingToClass(nativeID0, rmClassID("importantItem"));
//	rmAddGroupingConstraint(nativeID0, avoidNatives);
	if (TPvariation > 0.5)
		rmPlaceGroupingAtLoc(nativeID0, 0, 0.34, 0.86);
	else
		rmPlaceGroupingAtLoc(nativeID0, 0, 0.33, 0.85);
	
	nativeID2 = rmCreateGrouping("Cree village", "native cree village "+1);
    rmSetGroupingMinDistance(nativeID2, 0.00);
    rmSetGroupingMaxDistance(nativeID2, 0.00);
//	rmAddGroupingConstraint(nativeID2, avoidImpassableLand);
	rmAddGroupingToClass(nativeID2, rmClassID("natives"));
//  rmAddGroupingToClass(nativeID2, rmClassID("importantItem"));
//	rmAddGroupingConstraint(nativeID2, avoidNatives);
	if (TPvariation > 0.5)
		rmPlaceGroupingAtLoc(nativeID2, 0, 0.86, 0.34);
	else 
		rmPlaceGroupingAtLoc(nativeID2, 0, 0.85, 0.33);
	
	nativeID1 = rmCreateGrouping("huron4 village ", "native huron village "+5);
    rmSetGroupingMinDistance(nativeID1, 0.00);
    rmSetGroupingMaxDistance(nativeID1, 0.00);
//  rmAddGroupingConstraint(nativeID1, avoidImpassableLand);
	rmAddGroupingToClass(nativeID1, rmClassID("natives"));
//  rmAddGroupingToClass(nativeID1, rmClassID("importantItem"));
//	rmAddGroupingConstraint(nativeID1, avoidNatives);
	if (TPvariation > 0.5)
	{
	rmPlaceGroupingAtLoc(nativeID1, 0, 0.16, 0.38); // 
	}
	else
	{
	rmPlaceGroupingAtLoc(nativeID1, 0, 0.15, 0.44); // 
	}
	nativeID3 = rmCreateGrouping("huron4 village", "native huron village "+5);
    rmSetGroupingMinDistance(nativeID3, 0.00);
    rmSetGroupingMaxDistance(nativeID3, 0.00);
//  rmAddGroupingConstraint(nativeID3, avoidImpassableLand);
	rmAddGroupingToClass(nativeID3, rmClassID("natives"));
//  rmAddGroupingToClass(nativeID3, rmClassID("importantItem"));
//	rmAddGroupingConstraint(nativeID3, avoidNatives);
	if (TPvariation > 0.5)
	{
	rmPlaceGroupingAtLoc(nativeID3, 0, 0.38, 0.16); // 
	}
	else
	{
	rmPlaceGroupingAtLoc(nativeID3, 0, 0.44, 0.15); // 
	}
	
	// ******************************************************************************************************
	
	// Text
	rmSetStatusText("",0.50);
	
	// ************************************ PLAYER STARTING RESOURCES ***************************************

	// ******** Define ********

	// Town center & units
	int TCID = rmCreateObjectDef("player TC");
	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
	rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
	rmAddObjectDefToClass(TCID, classStartingResource);
	}
	rmSetObjectDefMinDistance(TCID, 0.0);
	rmSetObjectDefMaxDistance(TCID, 0.0);
	
	// Starting mines
	int playergoldID = rmCreateObjectDef("player mine");
	rmAddObjectDefItem(playergoldID, "mine", 1, 0);
	rmSetObjectDefMinDistance(playergoldID, 12.0);
	rmSetObjectDefMaxDistance(playergoldID, 14.0);
	rmAddObjectDefToClass(playergoldID, classStartingResource);
	rmAddObjectDefToClass(playergoldID, classGold);
	rmAddObjectDefConstraint(playergoldID, avoidTradeRoute);
	rmAddObjectDefConstraint(playergoldID, avoidImpassableLand);
	rmAddObjectDefConstraint(playergoldID, avoidNatives);
	rmAddObjectDefConstraint(playergoldID, avoidStartingResources);
	
	// 2nd mine
	int playergold2ID = rmCreateObjectDef("player second mine");
	rmAddObjectDefItem(playergold2ID, "mine", 1, 0);
	rmSetObjectDefMinDistance(playergold2ID, 38.0); //58
	rmSetObjectDefMaxDistance(playergold2ID, 40.0); //62
//	rmAddObjectDefToClass(playergold2ID, classStartingResource);
	rmAddObjectDefToClass(playergold2ID, classGold);
	rmAddObjectDefConstraint(playergold2ID, avoidTradeRoute);
	rmAddObjectDefConstraint(playergold2ID, avoidImpassableLandFar);
	rmAddObjectDefConstraint(playergold2ID, avoidNatives);
	rmAddObjectDefConstraint(playergold2ID, avoidGoldTypeFar);
	rmAddObjectDefConstraint(playergold2ID, avoidStartingResources);
	rmAddObjectDefConstraint(playergold2ID, avoidCenter);
	if (randomfrozen < 0.5)
	rmAddObjectDefConstraint(playergold2ID, avoidIceArea);
	rmAddObjectDefConstraint(playergold2ID, avoidEdge);
	
/*	// 3nd mine
	int playergold3ID = rmCreateObjectDef("player third mine");
	rmAddObjectDefItem(playergold3ID, "mine", 1, 0);
	rmSetObjectDefMinDistance(playergold3ID, 66.0); //58
	rmSetObjectDefMaxDistance(playergold3ID, 70.0); //62
//	rmAddObjectDefToClass(playergold3ID, classStartingResource);
	rmAddObjectDefToClass(playergold3ID, classGold);
	rmAddObjectDefConstraint(playergold3ID, avoidTradeRoute);
	rmAddObjectDefConstraint(playergold3ID, avoidImpassableLand);
	rmAddObjectDefConstraint(playergold3ID, avoidNatives);
	rmAddObjectDefConstraint(playergold3ID, avoidGoldTypeFar);
	rmAddObjectDefConstraint(playergold3ID, avoidStartingResources);
	rmAddObjectDefConstraint(playergold3ID, avoidCenter);
	rmAddObjectDefConstraint(playergold3ID, avoidIceArea);
	rmAddObjectDefConstraint(playergold3ID, avoidEdge);
*/
	
	// Starting trees
	int playerTreeID = rmCreateObjectDef("player trees");
	if (randomfrozen >= 0.5)
		rmAddObjectDefItem(playerTreeID, "TreeSaguenay", rmRandInt(2,2), 2.0);
	else
		rmAddObjectDefItem(playerTreeID, "TreeGreatLakesSnow", rmRandInt(2,2), 2.0);
    rmSetObjectDefMinDistance(playerTreeID, 12);
    rmSetObjectDefMaxDistance(playerTreeID, 16);
	rmAddObjectDefToClass(playerTreeID, classStartingResource);
//	rmAddObjectDefToClass(playerTreeID, classForest);
	rmAddObjectDefConstraint(playerTreeID, avoidForestShort);
	rmAddObjectDefConstraint(playerTreeID, avoidTradeRoute);
    rmAddObjectDefConstraint(playerTreeID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerTreeID, avoidStartingResources);
	
	// Starting herd
	int playermooseID = rmCreateObjectDef("starting moose");
	if (randomfrozen >= 0.5)
		rmAddObjectDefItem(playermooseID, "moose", rmRandInt(1,1), 5.0);
	else
		rmAddObjectDefItem(playermooseID, "muskOx", rmRandInt(1,1), 5.0);
	rmSetObjectDefMinDistance(playermooseID, 8.0);
	rmSetObjectDefMaxDistance(playermooseID, 9.0);
	rmSetObjectDefCreateHerd(playermooseID, false);
	rmAddObjectDefToClass(playermooseID, classStartingResource);
	rmAddObjectDefConstraint(playermooseID, avoidTradeRoute);
	rmAddObjectDefConstraint(playermooseID, avoidImpassableLand);
	rmAddObjectDefConstraint(playermooseID, avoidNatives);
//	rmAddObjectDefConstraint(playermooseID, avoidStartingResources);
		
	// 2nd herd
	int player2ndherdID = rmCreateObjectDef("player 2nd herd");
	if (randomfrozen >= 0.5)
		rmAddObjectDefItem(player2ndherdID, "elk", rmRandInt(9,9), 7.0);
	else
		rmAddObjectDefItem(player2ndherdID, "caribou", rmRandInt(10,10), 7.0);
    rmSetObjectDefMinDistance(player2ndherdID, 26);
    rmSetObjectDefMaxDistance(player2ndherdID, 30);
	rmAddObjectDefToClass(player2ndherdID, classStartingResource);
	rmSetObjectDefCreateHerd(player2ndherdID, true);
	rmAddObjectDefConstraint(player2ndherdID, avoidStartingResources);
	rmAddObjectDefConstraint(player2ndherdID, avoidMooseShort); 
//	rmAddObjectDefConstraint(player2ndherdID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(player2ndherdID, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(player2ndherdID, avoidImpassableLandFar);
	rmAddObjectDefConstraint(player2ndherdID, avoidNatives);
		
	// 3rd herd
	int player3rdherdID = rmCreateObjectDef("player 3rd herd");
	if (randomfrozen >= 0.5)
		rmAddObjectDefItem(player3rdherdID, "moose", rmRandInt(5,5), 6.0);
	else
		rmAddObjectDefItem(player3rdherdID, "muskOx", rmRandInt(6,6), 6.0);
    rmSetObjectDefMinDistance(player3rdherdID, 34);
    rmSetObjectDefMaxDistance(player3rdherdID, 36);
	rmAddObjectDefToClass(player3rdherdID, classStartingResource);
	rmSetObjectDefCreateHerd(player3rdherdID, true);
	rmAddObjectDefConstraint(player3rdherdID, avoidStartingResources);
	rmAddObjectDefConstraint(player3rdherdID, avoidGoldType);
	rmAddObjectDefConstraint(player3rdherdID, avoidCaribou);
	rmAddObjectDefConstraint(player3rdherdID, avoidElk);
	rmAddObjectDefConstraint(player3rdherdID, avoidMooseShort); 
//	rmAddObjectDefConstraint(player3rdherdID, avoidTradeRouteShort);
	rmAddObjectDefConstraint(player3rdherdID, avoidTradeRouteSocket);
	rmAddObjectDefConstraint(player3rdherdID, avoidImpassableLandFar);
	rmAddObjectDefConstraint(player3rdherdID, avoidNativesFar);
	rmAddObjectDefConstraint(player3rdherdID, avoidEdge);
	rmAddObjectDefConstraint(player3rdherdID, avoidCenter);
	
	// Starting treasures
	int playerNuggetID = rmCreateObjectDef("player nugget"); 
	rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
	rmSetNuggetDifficulty(1, 1);
	rmSetObjectDefMinDistance(playerNuggetID, 20.0);
	rmSetObjectDefMaxDistance(playerNuggetID, 30.0);
	rmAddObjectDefToClass(playerNuggetID, classStartingResource);
	rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerNuggetID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerNuggetID, avoidNatives);
	rmAddObjectDefConstraint(playerNuggetID, avoidStartingResources);
	rmAddObjectDefConstraint(playerNuggetID, avoidNugget); //Short
	rmAddObjectDefConstraint(playerNuggetID, avoidEdge);
	int nugget0count = rmRandInt (2,2); // 1,2
	
	int colonyShipID = 0;
   for(i=1; < numPlayer)
   {
		colonyShipID=rmCreateObjectDef("colony ship "+i);
	 	rmAddObjectDefItem(colonyShipID, "HomeCityWaterSpawnFlag", 1, 1.0);
		rmSetObjectDefMinDistance(colonyShipID, 0.0);
		rmSetObjectDefMaxDistance(colonyShipID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(colonyShipID, avoidColonyShip);
		rmAddObjectDefConstraint(colonyShipID, avoidLandFar);
		rmAddObjectDefConstraint(colonyShipID, avoidEdgeMore);
	//  vector colonyShipLocation=rmGetUnitPosition(rmGetUnitPlacedOfPlayer(colonyShipID, i));
	//  rmSetHomeCityWaterSpawnPoint(i, colonyShipLocation);
		if (randomfrozen < 0.5)	
			rmAddObjectDefConstraint(colonyShipID, avoidIceArea);
       	rmPlaceObjectDefAtLoc(colonyShipID, i, 0.75, 0.75);
	}   
		
	// ******** Place ********
	
	for(i=1; <numPlayer)
	{
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));

		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergoldID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergold2ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
//		rmPlaceObjectDefAtLoc(playergold3ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playermooseID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playermooseID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playermooseID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playermooseID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(player2ndherdID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(player3rdherdID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerNuggetID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		if (nugget0count == 2)
			rmPlaceObjectDefAtLoc(playerNuggetID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
				
		if(ypIsAsian(i) && rmGetNomadStart() == false)
			rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i, 1), i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
	}

	// ************************************************************************************************
	
	// Text
	rmSetStatusText("",0.60);
	
	// ************************************** COMMON RESOURCES ****************************************
  
   
	// ************* Mines **************
	
		int goldCount = rmRandInt(7,7);  // 3,3 
//		int northgoldCount = rmRandInt(3,3);  // 3,3 
	
	//Mines
	for(i=0; < goldCount)
	{
		int commongoldID = rmCreateObjectDef("common mines"+i);
		rmAddObjectDefItem(commongoldID, "Mine", 1, 0.0);
		rmSetObjectDefMinDistance(commongoldID, rmXFractionToMeters(0.0));
		rmSetObjectDefMaxDistance(commongoldID, rmXFractionToMeters(0.7));
		rmAddObjectDefToClass(commongoldID, classGold);
		rmAddObjectDefConstraint(commongoldID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(commongoldID, avoidImpassableLand);
		rmAddObjectDefConstraint(commongoldID, avoidNatives);
		rmAddObjectDefConstraint(commongoldID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(commongoldID, avoidGoldFar);
		rmAddObjectDefConstraint(commongoldID, avoidTownCenterFar);
		rmAddObjectDefConstraint(commongoldID, avoidEdge);
		if (randomfrozen < 0.5)
			rmAddObjectDefConstraint(commongoldID, avoidIceAreaFar);
		else
		{
			rmAddObjectDefConstraint(commongoldID, avoidIsland1);
			rmAddObjectDefConstraint(commongoldID, avoidIsland2);
		}
		rmPlaceObjectDefAtLoc(commongoldID, 0, 0.32, 0.32);
	}
		
	// *********************************
	
	// Text
	rmSetStatusText("",0.70);
	
	// ************ Forest *************
	
	// Main forest
	int forestcount = 16;
	
	for (i=0; < forestcount)
	{
		int forestID = rmCreateArea("forest"+i);
		rmSetAreaWarnFailure(forestID, false);
		rmSetAreaSize(forestID, rmAreaTilesToFraction(240), rmAreaTilesToFraction(260));
		if (randomfrozen >= 0.5)
			rmSetAreaForestType(forestID, "saguenay forest");
		else
			rmSetAreaForestType(forestID, "great lakes forest snow");
//		rmSetAreaObeyWorldCircleConstraint(forestID, false);
		rmSetAreaForestDensity(forestID, 1.0);
		rmSetAreaForestClumpiness(forestID, 1.0);
		rmSetAreaForestUnderbrush(forestID, 0.0);
		rmSetAreaMinBlobs(forestID, 1);
		rmSetAreaMaxBlobs(forestID, 5);
		rmSetAreaMinBlobDistance(forestID, 10.0);
		rmSetAreaMaxBlobDistance(forestID, 30.0);
		rmSetAreaCoherence(forestID, 1.0);
		rmSetAreaSmoothDistance(forestID, 6);
		rmAddAreaToClass(forestID, classForest);
		rmAddAreaConstraint(forestID, avoidForest);
		rmAddAreaConstraint(forestID, avoidGoldType);
		rmAddAreaConstraint(forestID, avoidElkMin); 
		rmAddAreaConstraint(forestID, avoidMooseMin); 
		rmAddAreaConstraint(forestID, avoidCaribouMin); 
		rmAddAreaConstraint(forestID, avoidMuskOxMin); 
		rmAddAreaConstraint(forestID, avoidTownCenter);
		rmAddAreaConstraint(forestID, avoidNatives);
		rmAddAreaConstraint(forestID, avoidTradeRouteShort);
		rmAddAreaConstraint(forestID, avoidTradeRouteSocket);
		rmAddAreaConstraint(forestID, avoidImpassableLandShort);
//		rmAddAreaConstraint(forestID, avoidEdge);
		if (randomfrozen >= 0.5)
		{
			rmAddAreaConstraint(forestID, avoidIsland1);
			rmAddAreaConstraint(forestID, avoidIsland2);
		}
		else
			rmAddAreaConstraint(forestID, avoidIceArea);
			rmBuildArea(forestID);
	}
	
	// Random tree clumps to fill blank spots
	int randomtreecount = 6; 
	
	for (i=0; < randomtreecount)
	{	
		int randomtreenorthID = rmCreateObjectDef("random trees north"+i);
		if (randomfrozen >= 0.5)
			rmAddObjectDefItem(randomtreenorthID, "TreeSaguenay", rmRandInt(5,5), 5.0); 
		else
			rmAddObjectDefItem(randomtreenorthID, "TreeGreatLakesSnow", rmRandInt(5,5), 5.0); 
		rmSetObjectDefMinDistance(randomtreenorthID, 0);
		rmSetObjectDefMaxDistance(randomtreenorthID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(randomtreenorthID, classForest);
		rmAddObjectDefConstraint(randomtreenorthID, avoidForestShort);
		rmAddObjectDefConstraint(randomtreenorthID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(randomtreenorthID, avoidImpassableLand);
		rmAddObjectDefConstraint(randomtreenorthID, avoidNatives);
		rmAddObjectDefConstraint(randomtreenorthID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(randomtreenorthID, avoidGoldType);
		rmAddObjectDefConstraint(randomtreenorthID, avoidTownCenterShort);
		rmAddObjectDefConstraint(randomtreenorthID, avoidStartingResources);
		rmAddObjectDefConstraint(randomtreenorthID, avoidElkMin); 
		rmAddObjectDefConstraint(randomtreenorthID, avoidMooseMin); 
		rmAddObjectDefConstraint(randomtreenorthID, avoidCaribouMin); 
		rmAddObjectDefConstraint(randomtreenorthID, avoidMuskOxMin); 
		if (randomfrozen >= 0.5)
		{
			rmAddObjectDefConstraint(randomtreenorthID, avoidIsland1);
			rmAddObjectDefConstraint(randomtreenorthID, avoidIsland2);
		}
		else
			rmAddObjectDefConstraint(randomtreenorthID, avoidIceArea);	
		rmPlaceObjectDefAtLoc(randomtreenorthID, 0, 0.50, 0.50);
	}	
	
	// Island trees
	if (randomfrozen >= 0.5)
	{
		int island1treeID = rmCreateObjectDef("island1 trees");
		rmAddObjectDefItem(island1treeID, "TreeSaguenay", rmRandInt(1,2), 4.0); 
		rmSetObjectDefMaxDistance(island1treeID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(island1treeID, stayInIsland1);
		rmAddObjectDefConstraint(island1treeID, avoidImpassableLandShort);
		rmPlaceObjectDefAtLoc(island1treeID, 0, 0.50, 0.50);
		rmPlaceObjectDefAtLoc(island1treeID, 0, 0.50, 0.50);
		rmPlaceObjectDefAtLoc(island1treeID, 0, 0.50, 0.50);
		
		int island2treeID = rmCreateObjectDef("island2 trees");
		rmAddObjectDefItem(island2treeID, "TreeSaguenay", rmRandInt(1,2), 4.0); 
		rmSetObjectDefMaxDistance(island2treeID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(island2treeID, stayInIsland2);
		rmAddObjectDefConstraint(island2treeID, avoidImpassableLandShort);
		rmPlaceObjectDefAtLoc(island2treeID, 0, 0.50, 0.50);
		rmPlaceObjectDefAtLoc(island2treeID, 0, 0.50, 0.50);
		rmPlaceObjectDefAtLoc(island2treeID, 0, 0.50, 0.50);
	}
	
	
	// ************ Herds *************
	
	int northherdcount = 4;
	int middleherdcount = 3;
	int southherdcount = 3;
		
	//North herds
	for (i=0; < northherdcount)
	{
		int northerdID = rmCreateObjectDef("north herd"+i);
		if (randomfrozen >= 0.5)
			rmAddObjectDefItem(northerdID, "moose", rmRandInt(6,6), 7.0);
		else
			rmAddObjectDefItem(northerdID, "muskOx", rmRandInt(6,6), 7.0);
		rmSetObjectDefMinDistance(northerdID, 0.0);
		rmSetObjectDefMaxDistance(northerdID, rmXFractionToMeters(0.6));
		rmSetObjectDefCreateHerd(northerdID, true);
		rmAddObjectDefConstraint(northerdID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(northerdID, avoidNatives);
//		rmAddObjectDefConstraint(northerdID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(northerdID, avoidForestMin);
		rmAddObjectDefConstraint(northerdID, avoidGoldTypeShort);
		rmAddObjectDefConstraint(northerdID, avoidMooseFar);
		rmAddObjectDefConstraint(northerdID, avoidElk);
		rmAddObjectDefConstraint(northerdID, avoidMuskOxFar);
		rmAddObjectDefConstraint(northerdID, avoidTownCenterFar);
		if (randomfrozen >= 0.5)
		{
			rmAddObjectDefConstraint(northerdID, stayCloseToBayWater); //stayNearBayWater
			rmAddObjectDefConstraint(northerdID, avoidIsland1);
			rmAddObjectDefConstraint(northerdID, avoidIsland2);
		}
		else
		{
			rmAddObjectDefConstraint(northerdID, stayNearBayWaterIce);
			rmAddObjectDefConstraint(northerdID, avoidEdge);
		}
		rmPlaceObjectDefAtLoc(northerdID, 0, 0.50, 0.50);
		
	}
	
	//Middle herds
	for (i=0; < middleherdcount)
	{
		int middleherdID = rmCreateObjectDef("middle herd"+i);
		if (randomfrozen >= 0.5)
			rmAddObjectDefItem(middleherdID, "elk", rmRandInt(8,8), 8.0);
		else
			rmAddObjectDefItem(middleherdID, "caribou", rmRandInt(9,9), 8.0);
		rmSetObjectDefMinDistance(middleherdID, rmXFractionToMeters(0.0));
		rmSetObjectDefMaxDistance(middleherdID, rmXFractionToMeters(0.6));
		rmSetObjectDefCreateHerd(middleherdID, true);
		rmAddObjectDefConstraint(middleherdID, avoidImpassableLandFar);
		rmAddObjectDefConstraint(middleherdID, avoidNatives);
		rmAddObjectDefConstraint(middleherdID, avoidTradeRouteSocketShort);
		rmAddObjectDefConstraint(middleherdID, avoidForestMin);
		rmAddObjectDefConstraint(middleherdID, avoidGoldTypeShort);
		rmAddObjectDefConstraint(middleherdID, avoidMoose);
		rmAddObjectDefConstraint(middleherdID, avoidElk);
		rmAddObjectDefConstraint(middleherdID, avoidMuskOx);
		rmAddObjectDefConstraint(middleherdID, avoidCaribou);
		rmAddObjectDefConstraint(middleherdID, avoidTownCenterFar);
		if (randomfrozen >= 0.5)
			rmAddObjectDefConstraint(middleherdID, stayCenterMore);
		else
			rmAddObjectDefConstraint(middleherdID, stayCenter);
		if (randomfrozen >= 0.5)
		{
//			rmAddObjectDefConstraint(middleherdID, avoidBayWaterFar);
			rmAddObjectDefConstraint(middleherdID, avoidIsland1);
			rmAddObjectDefConstraint(middleherdID, avoidIsland2);	
		}
		else
			rmAddObjectDefConstraint(middleherdID, avoidIceArea);	
		rmPlaceObjectDefAtLoc(middleherdID, 0, 0.40, 0.40);
	}
	
	//South herds
	int mooseorelk = rmRandInt (0,1);
	for (i=0; < southherdcount)
	{
		int southherdID = rmCreateObjectDef("south herd"+i);
		if (randomfrozen >= 0.5)
		{
			if (mooseorelk == 0)
				rmAddObjectDefItem(southherdID, "moose", rmRandInt(6,6), 7.0);
			else
				rmAddObjectDefItem(southherdID, "elk", rmRandInt(8,8), 8.0);
		}
		else
		{
			if (mooseorelk == 0)
				rmAddObjectDefItem(southherdID, "muskOx", rmRandInt(6,6), 7.0);
			else
				rmAddObjectDefItem(southherdID, "caribou", rmRandInt(9,9), 8.0);
		}
		rmSetObjectDefMinDistance(southherdID, rmXFractionToMeters(0.0));
		rmSetObjectDefMaxDistance(southherdID, rmXFractionToMeters(0.4));
		rmSetObjectDefCreateHerd(southherdID, true);
		rmAddObjectDefConstraint(southherdID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(southherdID, avoidNatives);
		rmAddObjectDefConstraint(southherdID, avoidTradeRouteSocketShort);
		rmAddObjectDefConstraint(southherdID, avoidForestMin);
		rmAddObjectDefConstraint(southherdID, avoidGoldTypeShort);
		rmAddObjectDefConstraint(southherdID, avoidMoose);
		rmAddObjectDefConstraint(southherdID, avoidElk);
		rmAddObjectDefConstraint(southherdID, avoidMuskOx);
		rmAddObjectDefConstraint(southherdID, avoidCaribou);
		rmAddObjectDefConstraint(southherdID, avoidTownCenterFar);
		rmAddObjectDefConstraint(southherdID, staySouth);
//		rmAddObjectDefConstraint(southherdID, avoidEdge);
		if (randomfrozen >= 0.5)
		{
			rmAddObjectDefConstraint(southherdID, avoidIsland1);
			rmAddObjectDefConstraint(southherdID, avoidIsland2);
			rmAddObjectDefConstraint(southherdID, avoidBayWaterFar);
		}
		else
		{
			rmAddObjectDefConstraint(southherdID, avoidIceArea);
			rmAddObjectDefConstraint(southherdID, avoidBayWaterIceFar);
		}
		rmPlaceObjectDefAtLoc(southherdID, 0, 0.25, 0.25);
	}
	// ************************************
	
	// Text
	rmSetStatusText("",0.80);
	
	
	
	// ****************************************
	
	// Text
	rmSetStatusText("",0.95);
	
	// ************** Treasures ***************
	
	int treasurecount = -1;
	if (randomfrozen >= 0.5)
		treasurecount = 10;
	else
		treasurecount = 8;
		
	// Treasures lvl 2	
	for (i=0; < treasurecount)
	{
		int Nugget2ID = rmCreateObjectDef("nugget lvl2 "+i); 
		rmAddObjectDefItem(Nugget2ID, "Nugget", 1, 0.0);
		rmSetObjectDefMinDistance(Nugget2ID, 0);
		rmSetObjectDefMaxDistance(Nugget2ID, rmXFractionToMeters(0.6));
		rmSetNuggetDifficulty(2,2);
		if (randomfrozen >= 0.5)
			rmAddObjectDefConstraint(Nugget2ID, avoidNugget);
		else
			rmAddObjectDefConstraint(Nugget2ID, avoidNuggetFar);
		rmAddObjectDefConstraint(Nugget2ID, avoidNatives);
		rmAddObjectDefConstraint(Nugget2ID, avoidTradeRouteShort);
		rmAddObjectDefConstraint(Nugget2ID, avoidTradeRouteSocket);
		rmAddObjectDefConstraint(Nugget2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(Nugget2ID, avoidGoldTypeShort);
		rmAddObjectDefConstraint(Nugget2ID, avoidTownCenterFar);
		rmAddObjectDefConstraint(Nugget2ID, avoidCaribouMin); 
		rmAddObjectDefConstraint(Nugget2ID, avoidElkMin);
		rmAddObjectDefConstraint(Nugget2ID, avoidMooseMin);
		rmAddObjectDefConstraint(Nugget2ID, avoidMuskOxMin);
		rmAddObjectDefConstraint(Nugget2ID, avoidForestMin);	
		rmAddObjectDefConstraint(Nugget2ID, avoidEdge); 
		if (randomfrozen >= 0.5)
		{
			rmAddObjectDefConstraint(Nugget2ID, avoidIsland1);
			rmAddObjectDefConstraint(Nugget2ID, avoidIsland2);
		}
		else
			rmAddObjectDefConstraint(Nugget2ID, avoidIceArea);
		rmPlaceObjectDefAtLoc(Nugget2ID, 0, 0.50, 0.50);
	}
	
	// ****************************************
	
	// **************** Sheeps *****************
	
	if (randomfrozen >= 0.5)
	{
		for (i=0; <8)
		{
			int sheepID=rmCreateObjectDef("sheep"+i);
			rmAddObjectDefItem(sheepID, "sheep", 1, 1.0);
			rmSetObjectDefMinDistance(sheepID, 0.0);
			rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.5));
			rmAddObjectDefConstraint(sheepID, avoidSheep);
			rmAddObjectDefConstraint(sheepID, avoidForestMin);
			rmAddObjectDefConstraint(sheepID, avoidTownCenterFar);
			rmAddObjectDefConstraint(sheepID, avoidIsland1);
			rmAddObjectDefConstraint(sheepID, avoidIsland2);
			rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
			rmAddObjectDefConstraint(sheepID, avoidEdge);
			rmPlaceObjectDefAtLoc(sheepID, 0, 0.50, 0.50);
		}
	}
	// ****************************************
	
	// ************ Sea resources *************
	
	//Fish
	int fishcount = -1;
	if (randomfrozen >= 0.5)
	fishcount = 12;
	else
	fishcount = 9;
	int whalecount = 4;
	
	for (i=0; < whalecount)
	{
	int whaleID=rmCreateObjectDef("whale"+i);
	rmAddObjectDefItem(whaleID, "beluga", 1, 2.0);
	rmSetObjectDefMinDistance(whaleID, 0.0);
	rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(whaleID, avoidWhale);
	rmAddObjectDefConstraint(whaleID, avoidLandFar);
	rmAddObjectDefConstraint(whaleID, avoidColonyShipShort);
	if (randomfrozen < 0.5)	
		rmAddObjectDefConstraint(whaleID, avoidIceArea);
	rmPlaceObjectDefAtLoc(whaleID, 0, 0.75, 0.75);
	}
	
	for (i=0; < fishcount)
	{
		int fishID = rmCreateObjectDef("fish"+i);
		rmAddObjectDefItem(fishID, "FishSalmon", rmRandInt(2,2), 5.0);
		rmSetObjectDefMinDistance(fishID, 0.0);
		rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(fishID, avoidFish);
		rmAddObjectDefConstraint(fishID, avoidLand);
		rmAddObjectDefConstraint(fishID, avoidColonyShipShort);
		if (randomfrozen < 0.5)	
			rmAddObjectDefConstraint(fishID, avoidIceArea);
		rmPlaceObjectDefAtLoc(fishID, 0, 0.75, 0.75);
	}
	
	
	// ************ EMBELLISHMENTS ************
		
/*	// Underbrush grass
	if (randomfrozen >= 0.5)
	{
		for (i=0; < 50)
		{
			int UnderbrushgrassID = rmCreateObjectDef("underbrush grass "+i);
			rmAddObjectDefItem(UnderbrushgrassID, "GroundPropsSag", rmRandInt(1,1), 2.0); 
			rmAddObjectDefItem(UnderbrushgrassID, "UnderbrushCoastalJapan", rmRandInt(4,5), 5.0);
			rmSetObjectDefMinDistance(UnderbrushgrassID, 0);
			rmSetObjectDefMaxDistance(UnderbrushgrassID, rmXFractionToMeters(0.7));
			rmAddObjectDefToClass(UnderbrushgrassID, rmClassID("grass"));
			rmAddObjectDefConstraint(UnderbrushgrassID, avoidGrass);
			rmAddObjectDefConstraint(UnderbrushgrassID, avoidImpassableLand);
			rmAddObjectDefConstraint(UnderbrushgrassID, avoidTradeRouteShort);
			rmAddObjectDefConstraint(UnderbrushgrassID, avoidTradeRouteSocket);
			rmAddObjectDefConstraint(UnderbrushgrassID, avoidNatives);
			rmAddObjectDefConstraint(UnderbrushgrassID, avoidGoldTypeShort);
			rmAddObjectDefConstraint(UnderbrushgrassID, avoidTownCenter);
			rmAddObjectDefConstraint(UnderbrushgrassID, avoidIsland1);
			rmAddObjectDefConstraint(UnderbrushgrassID, avoidIsland2);
			rmPlaceObjectDefAtLoc(UnderbrushgrassID, 0, 0.45, 0.45);
		}
	}
	else
	{
	}
*/	
	// Underbrush snow
	if (randomfrozen >= 0.5)
	{
	}
	else
	{
		for (i=0; < 50)
		{
			int UnderbrushsnowID = rmCreateObjectDef("underbrush snow "+i);
			rmAddObjectDefItem(UnderbrushsnowID, "Underbrushyukon", rmRandInt(1,2), 3.0); 
			rmSetObjectDefMinDistance(UnderbrushsnowID, 0);
			rmSetObjectDefMaxDistance(UnderbrushsnowID, rmXFractionToMeters(0.7));
			rmAddObjectDefToClass(UnderbrushsnowID, rmClassID("grass"));
			rmAddObjectDefConstraint(UnderbrushsnowID, avoidGrass);
			rmAddObjectDefConstraint(UnderbrushsnowID, avoidImpassableLandShort);
			rmAddObjectDefConstraint(UnderbrushsnowID, avoidTradeRouteShort);
			rmAddObjectDefConstraint(UnderbrushsnowID, avoidTradeRouteSocket);
			rmAddObjectDefConstraint(UnderbrushsnowID, avoidNatives);
			rmAddObjectDefConstraint(UnderbrushsnowID, avoidGoldTypeShort);
			rmAddObjectDefConstraint(UnderbrushsnowID, avoidTownCenter);
			rmAddObjectDefConstraint(UnderbrushsnowID, avoidIceArea);
			rmPlaceObjectDefAtLoc(UnderbrushsnowID, 0, 0.45, 0.45);
		}
/*		for (i=0; < 10) //10
		{
			int WaterRockbig2ID = rmCreateObjectDef(" rock2 big"+i);
			rmAddObjectDefItem(WaterRockbig2ID, "GroundPropsYuk", rmRandInt(1,1), 5.0); //GroundPropsYuk
			rmSetObjectDefMinDistance(WaterRockbig2ID, 0);
			rmSetObjectDefMaxDistance(WaterRockbig2ID, rmXFractionToMeters(0.50));
			rmAddObjectDefToClass(WaterRockbig2ID, rmClassID("rocks"));
			rmAddObjectDefConstraint(WaterRockbig2ID, avoidRockFar);
			rmAddObjectDefConstraint(WaterRockbig2ID, avoidImpassableLandShort);
			rmAddObjectDefConstraint(WaterRockbig2ID, avoidIceArea);
			rmAddObjectDefConstraint(WaterRockbig2ID, avoidTradeRouteSocket);
			rmAddObjectDefConstraint(WaterRockbig2ID, avoidTradeRouteShort);
			rmAddObjectDefConstraint(WaterRockbig2ID, avoidPlayerArea1);
			rmAddObjectDefConstraint(WaterRockbig2ID, avoidPlayerArea2);
			rmAddObjectDefConstraint(WaterRockbig2ID, avoidNatives);
			rmAddObjectDefConstraint(WaterRockbig2ID, avoidForestMin);
			rmAddObjectDefConstraint(WaterRockbig2ID, avoidGoldTypeShort);
			rmPlaceObjectDefAtLoc(WaterRockbig2ID, 0, 0.50, 0.50); //0.50, 0.50
		}
*/		
	}
	
	// Rocks
	if (randomfrozen >= 0.5)
	{
		for (i=0; < 20)
		{
			int RockcoastID = rmCreateObjectDef("rockcoast"+i);
			if (randomfrozen >= 0.5)
				rmAddObjectDefItem(RockcoastID, "CoastalRocksSaguenay", rmRandInt(1,1), 5.0); 
			else
				rmAddObjectDefItem(RockcoastID, "RiverPropsYuk", rmRandInt(1,1), 5.0); 
			rmSetObjectDefMinDistance(RockcoastID, 0);
			rmSetObjectDefMaxDistance(RockcoastID, rmXFractionToMeters(0.24));
			rmAddObjectDefToClass(RockcoastID, rmClassID("rocks"));
			rmAddObjectDefConstraint(RockcoastID, avoidRock);
			rmAddObjectDefConstraint(RockcoastID, avoidForestMin);
			rmAddObjectDefConstraint(RockcoastID, avoidGoldTypeShort);
			rmAddObjectDefConstraint(RockcoastID, rockVsLand);
			rmAddObjectDefConstraint(RockcoastID, rockVsWater);
			rmAddObjectDefConstraint(RockcoastID, avoidIsland1);
			rmAddObjectDefConstraint(RockcoastID, avoidIsland2);
			rmPlaceObjectDefAtLoc(RockcoastID, 0, 0.65, 0.65);
		}
		
		for (i=0; < 5)
		{
			int RockIsland1ID = rmCreateObjectDef("rock island1"+i);
			if (randomfrozen >= 0.5)
				rmAddObjectDefItem(RockIsland1ID, "CoastalRocksSaguenay", rmRandInt(1,1), 5.0); 
			else
				rmAddObjectDefItem(RockIsland1ID, "RiverPropsYuk", rmRandInt(1,1), 5.0); 
			rmSetObjectDefMinDistance(RockIsland1ID, 0);
			rmSetObjectDefMaxDistance(RockIsland1ID, rmXFractionToMeters(0.24));
			rmAddObjectDefToClass(RockIsland1ID, rmClassID("rocks"));
			rmAddObjectDefConstraint(RockIsland1ID, avoidRock);
			rmAddObjectDefConstraint(RockIsland1ID, avoidIsland1);
			rmAddObjectDefConstraint(RockIsland1ID, stayNearIsland1);
			rmPlaceObjectDefAtLoc(RockIsland1ID, 0, 0.65, 0.65);
		}
		
		for (i=0; < 5)
		{
			int RockIsland2ID = rmCreateObjectDef("rock island2"+i);
			if (randomfrozen >= 0.5)
				rmAddObjectDefItem(RockIsland2ID, "CoastalRocksSaguenay", rmRandInt(1,1), 5.0); 
			else
				rmAddObjectDefItem(RockIsland2ID, "RiverPropsYuk", rmRandInt(1,1), 5.0); 
			rmSetObjectDefMinDistance(RockIsland2ID, 0);
			rmSetObjectDefMaxDistance(RockIsland2ID, rmXFractionToMeters(0.24));
			rmAddObjectDefToClass(RockIsland2ID, rmClassID("rocks"));
			rmAddObjectDefConstraint(RockIsland2ID, avoidRock);
			rmAddObjectDefConstraint(RockIsland2ID, avoidIsland2);
			rmAddObjectDefConstraint(RockIsland2ID, stayNearIsland2);

			rmPlaceObjectDefAtLoc(RockIsland2ID, 0, 0.65, 0.65);
		}
	}
	// ****************************************************

	// Text
	rmSetStatusText("",1.00);

	
} //END
	
	