// ESOC PAMPAS SIERRAS
// designed by Garja

int PlayerNum=2;
int numPlayer=3;

include "mercenaries.xs";
include "ypAsianInclude.xs";
include "ypKOTHInclude.xs";



// Main entry point for random map script
void main(void)
{
		
	// Text
	// These status text lines are used to manually animate the map generation progress bar
	rmSetStatusText("",0.01); 
	
	// ************************************** GENERAL FEATURES *****************************************
	
	// Picks the map size
	int playerTiles=11500; //12000
	int size=2.0*sqrt(PlayerNum*playerTiles); //2.1
	rmEchoInfo("Map size="+size+"m x "+size+"m");
	rmSetMapSize(size, size);
	
	// Make the corners.
	rmSetWorldCircleConstraint(true);
		
	// Picks a default water height
	rmSetSeaLevel(4.0);	// this is height of river surface compared to surrounding land. River depth is in the river XML.

	rmSetMapElevationParameters(cElevTurbulence, 0.05, 3, 0.5, 4.0); // type, frequency, octaves, persistence, variation 
//	rmSetMapElevationHeightBlend(1);
	
	// Picks default terrain and water
	rmSetSeaType("pampas river");
	rmSetBaseTerrainMix("pampas_grass"); //
	rmTerrainInitialize("pampas\ground1_pam", 4.0); // 
	rmSetMapType("pampas"); 
	rmSetMapType("grass");
	rmSetMapType("land");
	rmSetLightingSet("saguenay"); //
	

	// Choose Mercs
	chooseMercs();
	
	// Text
	rmSetStatusText("",0.10);
	
	// Set up Natives
	int subCiv0 = -1;
	int subCiv1 = -1;
	subCiv0 = rmGetCivID("Incas");
	subCiv1 = rmGetCivID("Mapuche");
	rmSetSubCiv(0, "Incas");
	rmSetSubCiv(1, "Mapuche");

	

	//Define some classes. These are used later for constraints.
	int classPlayer = rmDefineClass("Players");
	int classHill = rmDefineClass("Hills");
	int classPatch = rmDefineClass("patch");
	int classPatch2 = rmDefineClass("patch2");
	int classPatch3 = rmDefineClass("patch3");
	int classPatch4 = rmDefineClass("patch4");
	int classGrass = rmDefineClass("grass");
	rmDefineClass("starting settlement");
	rmDefineClass("startingUnit");
	int classForest = rmDefineClass("Forest");
	int importantItem = rmDefineClass("importantItem");
	int classNative = rmDefineClass("natives");
	int classCliff = rmDefineClass("Cliffs");
	int classGold = rmDefineClass("Gold");
	int classStartingResource = rmDefineClass("startingResource");
	
	// ******************************************************************************************
	
	// Text
	rmSetStatusText("",0.20);
	
	// ************************************* CONTRAINTS *****************************************
	// These are used to have objects and areas avoid each other
   
   
	// Cardinal Directions & Map placement
	int avoidEdge = rmCreatePieConstraint("Avoid Edge",0.5,0.5, rmXFractionToMeters(0.0),rmXFractionToMeters(0.47), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int avoidEdgeMore = rmCreatePieConstraint("Avoid Edge More",0.5,0.5, rmXFractionToMeters(0.0),rmXFractionToMeters(0.45), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int avoidCenter = rmCreatePieConstraint("Avoid Center",0.4,0.4,rmXFractionToMeters(0.24), rmXFractionToMeters(0.5), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int stayCenter = rmCreatePieConstraint("Stay Center",0.5,0.5,rmXFractionToMeters(0.0), rmXFractionToMeters(0.25), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int stayEdge = rmCreatePieConstraint("Stay Edge",0.5,0.5,rmXFractionToMeters(0.42), rmXFractionToMeters(0.5), rmDegreesToRadians(0),rmDegreesToRadians(360));
	int northEdge = rmCreatePieConstraint("North Edge",0.70,0.70,rmXFractionToMeters(0.2), rmXFractionToMeters(0.30), rmDegreesToRadians(0),rmDegreesToRadians(90)); 
//	int avoidWesthalf = rmCreateAreaDistanceConstraint("avoid west", WestID, 185.0); 
	int stayTop = rmCreatePieConstraint("SouthHalfConstraint", 0.36, 0.36, 0.0, rmZFractionToMeters(0.50), rmDegreesToRadians(135), rmDegreesToRadians(315));
	int stayBottom = rmCreatePieConstraint("NorthHalfConstraint", 0.64, 0.64, 0.0, rmZFractionToMeters(0.50), rmDegreesToRadians(315), rmDegreesToRadians(135));
		
	
	// Resource avoidance
	int avoidForestFar=rmCreateClassDistanceConstraint("avoid forest far", rmClassID("Forest"), 40.0); //
	int avoidForest=rmCreateClassDistanceConstraint("avoid forest", rmClassID("Forest"), 30.0); //29.0 
	int avoidForestShort=rmCreateClassDistanceConstraint("avoid forest short", rmClassID("Forest"), 20.0); //
	int avoidForestMin=rmCreateClassDistanceConstraint("avoid forest min", rmClassID("Forest"), 4.0);
	int avoidGuanacoFar = rmCreateTypeDistanceConstraint("avoid guanaco far", "guanaco", 50.0);
	int avoidGuanaco = rmCreateTypeDistanceConstraint("avoid guanaco", "guanaco", 45.0);
	int avoidGuanacoShort = rmCreateTypeDistanceConstraint("avoid guanaco short", "guanaco", 28.0);
	int avoidGuanacoMin = rmCreateTypeDistanceConstraint("avoid guanaco min", "guanaco", 4.0);
	int avoidRheaFar = rmCreateTypeDistanceConstraint("avoid rhea far", "rhea", 52.0);
	int avoidRhea = rmCreateTypeDistanceConstraint("avoid  rhea", "rhea", 40.0);
	int avoidRheaShort = rmCreateTypeDistanceConstraint("avoid  rhea short", "rhea", 30.0);
	int avoidRheaMin = rmCreateTypeDistanceConstraint("avoid rha min", "rhea", 10.0);
	int avoidGoldTypeMin = rmCreateTypeDistanceConstraint("coin avoids coin min ", "gold", 10.0);
	int avoidGoldTypeShort = rmCreateTypeDistanceConstraint("coin avoids coin short", "gold", 12.0);
	int avoidGoldType = rmCreateTypeDistanceConstraint("coin avoids coin ", "gold", 26.0);
	int avoidGoldTypeFar = rmCreateTypeDistanceConstraint("coin avoids coin far ", "gold", 36.0);
	int avoidGoldMin=rmCreateClassDistanceConstraint("min distance vs gold", rmClassID("Gold"), 10.0);
	int avoidGold = rmCreateClassDistanceConstraint ("gold avoid gold med", rmClassID("Gold"), 30.0);
	int avoidGoldFar = rmCreateClassDistanceConstraint ("gold avoid gold far", rmClassID("Gold"), 60.0);
	int avoidGoldVeryFar = rmCreateClassDistanceConstraint ("gold avoid gold very far", rmClassID("Gold"), 72.0);
	int avoidNuggetShort = rmCreateTypeDistanceConstraint("nugget avoid nugget short", "AbstractNugget", 30.0);
	int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 50.0);
	
	int avoidTownCenterVeryFar=rmCreateTypeDistanceConstraint("avoid Town Center Very Far", "townCenter", 82.0);
	int avoidTownCenterFar=rmCreateTypeDistanceConstraint("avoid Town Center Far", "townCenter", 55.0);
	int avoidTownCenter=rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 50.0);
	int avoidTownCenterMed=rmCreateTypeDistanceConstraint(" avoid Town Center med", "townCenter", 24.0);
	int avoidTownCenterShort=rmCreateTypeDistanceConstraint(" avoid Town Center short", "townCenter", 20.0);
	int avoidTownCenterResources=rmCreateTypeDistanceConstraint(" avoid Town Center", "townCenter", 40.0);
	int avoidNatives = rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 8.0);
	int avoidNativesFar = rmCreateClassDistanceConstraint("stuff avoids natives far", rmClassID("natives"), 18.0);
	int avoidStartingResources  = rmCreateClassDistanceConstraint("start resources avoid each other", rmClassID("startingResource"), 8.0);
	int avoidStartingResourcesShort  = rmCreateClassDistanceConstraint("start resources avoid each other short", rmClassID("startingResource"), 5.0);
	int avoidLama = rmCreateTypeDistanceConstraint("lama avoid lama", "llama", 35.0);
	

	// Avoid impassable land
	int avoidImpassableLand = rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 6.0);
	int avoidImpassableLandFar=rmCreateTerrainDistanceConstraint("far avoid impassable land", "Land", false, 10.0);
	int avoidImpassableLandShort = rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
	int avoidImpassableLandMin = rmCreateTerrainDistanceConstraint("min avoid impassable land", "Land", false, 0.5);
	int avoidImpassableLandMed=rmCreateTerrainDistanceConstraint("medium avoid impassable land", "Land", false, 15.0);
	int avoidWater = rmCreateTerrainDistanceConstraint("avoid water ", "water", true, 20);
	int stayNearWater = rmCreateTerrainMaxDistanceConstraint("stay near water ", "land", false, 10.0);
	int stayInWater = rmCreateTerrainMaxDistanceConstraint("stay in water ", "water", true, 0.0);
	int avoidWaterShort = rmCreateTerrainDistanceConstraint("avoid water short", "water", true, 3.0);
	int avoidPatch = rmCreateClassDistanceConstraint("patch avoid patch", rmClassID("patch"), 10.0);
	int avoidPatch2 = rmCreateClassDistanceConstraint("patch avoid patch 2", rmClassID("patch2"), 10.0);
	int avoidPatch3 = rmCreateClassDistanceConstraint("patch avoid patch 3", rmClassID("patch3"), 20.0);
	int avoidPatch4 = rmCreateClassDistanceConstraint("patch avoid patch 4", rmClassID("patch4"), 24.0);
	int avoidStone = rmCreateClassDistanceConstraint("stone avoid stone", rmClassID("stonewater"), 5.0);
	int avoidGrass = rmCreateClassDistanceConstraint("grass avoid grass", rmClassID("grass"), 10.0);
	int avoidCliff = rmCreateClassDistanceConstraint("avoid cliff", rmClassID("Cliffs"), 4.0);
	int avoidCliffMed = rmCreateClassDistanceConstraint("avoid cliff medium", rmClassID("Cliffs"), 8.0);
	int avoidCliffFar = rmCreateClassDistanceConstraint("avoid cliff far", rmClassID("Cliffs"), 14.0);
	

	// Unit avoidance
	int avoidStartingUnits = rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 35.0);
		
	
	// VP avoidance
	int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
	int avoidTradeRouteShort = rmCreateTradeRouteDistanceConstraint("trade route short", 5.0);
	int avoidTradeRouteSocket = rmCreateTypeDistanceConstraint("avoid trade route socket", "socketTradeRoute", 8.0);
	int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 10.0);
   
	
	
	
	// ***********************************************************************************************
	
	// **************************************** PLACE PLAYERS ****************************************

	int teamZeroCount = rmGetNumberPlayersOnTeam(0);
	int teamOneCount = rmGetNumberPlayersOnTeam(1);
	
	// 2 team and FFA support
	float OneVOnePlacement=rmRandFloat(0.0, 0.9);
	if (PlayerNum == 2)
	{

		if ( OneVOnePlacement < 0.5)
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.26, 0.26, 0.4, 0.20, 0, 0.0); // disregard line end

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.74, 0.74, 0.4, 0.8, 0, 0.0); // disregard line end
		}
		else
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.74, 0.74, 0.4, 0.8, 0, 0.0);

			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.26, 0.26, 0.4, 0.20, 0, 0.0);
		}
		
	}
	
/*	// Team placement
	else if ( PlayerNum == 2 && teamZeroCount == teamOneCount)
	{

		rmSetPlacementTeam(0);
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersLine(0.2, 0.2, 0.5, 0.2, 0, 0.0);

		rmSetPlacementTeam(1);
		rmSetTeamSpacingModifier(0.25);
		rmPlacePlayersLine(0.8, 0.8, 0.5, 0.8, 0, 0.0);
	
	}
	// FFA support
	else if (PlayerNum > 2)
	{
      bool southSide = true;

      float spacingIncrement = (0.35 / (PlayerNum / 2));
      float spacingSouth = 0;
      float spacingNorth = 0;
      
      float southStart = 0.45;
      float southEnd = 0.82;
      float northStart = 0.95;
      float northEnd = 0.32;

      for (i = 0; < PlayerNum)
      {
         rmEchoInfo("i = "+i);
         if (southSide == true)
         {
            rmSetPlacementTeam(i);
            rmSetPlacementSection((southStart + spacingSouth), southEnd);
	         rmSetTeamSpacingModifier(0.25);
	         rmPlacePlayersCircular(0.4, 0.4, 0);
            spacingSouth = spacingSouth + spacingIncrement;
         }
         else
         {
            rmSetPlacementTeam(i);
            rmSetPlacementSection((northStart + spacingNorth), northEnd);
	         rmSetTeamSpacingModifier(0.25);
	         rmPlacePlayersCircular(0.4, 0.4, 0);
            spacingNorth = spacingNorth + spacingIncrement;
         }
         if (southSide == true)
         {
            southSide = false;
         }
         else
         {
            southSide = true;
         }
      }
   }
   else 
   {
      if (teamZeroCount < teamOneCount)
      {
         rmSetPlacementTeam(0);
         rmSetPlacementSection(0.55, 0.75);
		   rmSetTeamSpacingModifier(0.35 / teamZeroCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);

		   rmSetPlacementTeam(1);
         rmSetPlacementSection(0.95, 0.32);
		   rmSetTeamSpacingModifier(0.35 / teamOneCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);
      }
      else 
      {
         rmSetPlacementTeam(0);
         rmSetPlacementSection(0.45, 0.82);
		   rmSetTeamSpacingModifier(0.35 / teamZeroCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);

		   rmSetPlacementTeam(1);
         rmSetPlacementSection(0.0, 0.2);
		   rmSetTeamSpacingModifier(0.35 / teamOneCount);
		   rmPlacePlayersCircular(0.4, 0.4, 0);
      }
   }
*/
	// **************************************************************************************************
   
	// Text
	rmSetStatusText("",0.30);
	
	// ******************************************** MAP LAYOUT AND LANDSCAPE DESIGN **************************************************

	// Plateau template
	int TemplateID = rmCreateArea("plateau template");
	rmSetAreaSize(TemplateID, 0.18, 0.18);
	rmSetAreaWarnFailure(TemplateID, false);
//	rmSetAreaMix(TemplateID, "rockies_snow");
	rmSetAreaCoherence(TemplateID, 0.75);
	rmSetAreaSmoothDistance(TemplateID, 14);
	rmSetAreaLocation(TemplateID, 0.5, 0.5);
	rmBuildArea(TemplateID);
	
	int avoidTemplate = rmCreateAreaDistanceConstraint("avoid template", TemplateID, 1.5);
	
	// Border template
	int Template2ID = rmCreateArea("border template");
	rmSetAreaSize(Template2ID, 0.62, 0.62);
	rmSetAreaWarnFailure(Template2ID, false);
//	rmSetAreaMix(Template2ID, "rockies_snow");
	rmSetAreaCoherence(Template2ID, 0.8);
	rmSetAreaSmoothDistance(Template2ID, 14);
	rmSetAreaLocation(Template2ID, 0.5, 0.5);
	rmBuildArea(Template2ID);

	int avoidTemplate2 = rmCreateAreaDistanceConstraint("avoid template2", Template2ID, 1.5);
	
	// Plateau
	int plateauID = rmCreateArea("plateau");
	rmSetAreaSize(plateauID, 0.22, 0.22); //0.23, 0.23
	rmSetAreaWarnFailure(plateauID, false);
	rmSetAreaObeyWorldCircleConstraint(plateauID, false);
	rmSetAreaCliffType(plateauID, "araucania north coast"); // araucania north coast
//	rmSetAreaCliffPainting(plateauID, false, true, true, 0.5 , true); //  paintGround,  paintOutsideEdge,  paintSide,  minSideHeight,  paintInsideEdge
	rmSetAreaTerrainType(plateauID, "texas\cliff_edge_tex");
	rmSetAreaCliffHeight(plateauID, 5, 0.0, 0.8); 
	rmSetAreaCliffEdge(plateauID, 5, 0.083, 0.0, 0.30, 1); 
	rmSetAreaCoherence(plateauID, 0.75);
	rmSetAreaSmoothDistance(plateauID, 16);
//	rmAddAreaToClass(plateauID, rmClassID("Cliffs"));
	rmSetAreaLocation(plateauID, 0.0, 1.0);
	rmAddAreaConstraint(plateauID, avoidTemplate);
	rmBuildArea(plateauID);
	
	int avoidPlateau = rmCreateAreaDistanceConstraint("avoid plateau", plateauID, 3);
	int avoidPlateauFar = rmCreateAreaDistanceConstraint("avoid plateau far", plateauID, 30);
	int stayInPlateau = rmCreateAreaMaxDistanceConstraint("stay in plateau", plateauID, 0);
	int avoidRamp = rmCreateCliffRampDistanceConstraint("avoid plateau ramp", plateauID, 10);
	
	// Rocky border
	int cliffID = rmCreateArea("cliff");
	rmSetAreaSize(cliffID, 0.075, 0.075); //0.08, 0.08
	rmSetAreaWarnFailure(cliffID, false);
	rmSetAreaObeyWorldCircleConstraint(cliffID, false);
	rmSetAreaCliffType(cliffID, "araucania north coast"); // araucania north coast
//	rmSetAreaCliffPainting(cliffID, false, true, true, 0.5 , true); //  paintGround,  paintOutsideEdge,  paintSide,  minSideHeight,  paintInsideEdge
	rmSetAreaTerrainType(cliffID, "texas\cliff_top_tex");
	rmSetAreaCliffHeight(cliffID, 6, 0.0, 0.2); 
	rmSetAreaCliffEdge(cliffID, 1, 1.0, 0.0, 0.0, 1); 
	rmSetAreaCoherence(cliffID, 1.0);
	rmAddAreaToClass(cliffID, rmClassID("Cliffs"));
	rmSetAreaLocation(cliffID, 0.0, 1.0);
	rmAddAreaConstraint(cliffID, avoidTemplate2);
	rmBuildArea(cliffID);

	int avoidBorder = rmCreateAreaDistanceConstraint("avoid border", cliffID, 8.0);
	
	// Cliff1
	int cliff1ID = rmCreateArea("cliff1");
	rmSetAreaSize(cliff1ID, 0.0046, 0.0046);
	rmSetAreaWarnFailure(cliff1ID, false);
	rmSetAreaObeyWorldCircleConstraint(cliff1ID, false);
	rmSetAreaCliffType(cliff1ID, "araucania north coast"); // araucania north coast
//	rmSetAreaCliffPainting(cliff1ID, false, true, true, 0.5 , true); //  paintGround,  paintOutsideEdge,  paintSide,  minSideHeight,  paintInsideEdge
	rmSetAreaTerrainType(cliff1ID, "texas\cliff_top_tex");
	rmSetAreaCliffHeight(cliff1ID, 5, 0.0, 0.4); 
	rmSetAreaCliffEdge(cliff1ID, 1, 1.0, 0.0, 0.0, 1); 
	rmAddAreaToClass(cliff1ID, rmClassID("Cliffs"));
//	rmAddAreaInfluencePoint(cliff1ID, 0.4, 0.86);
	rmSetAreaMinBlobs(cliff1ID, 3);
	rmSetAreaMaxBlobs(cliff1ID, 5);
	rmSetAreaMinBlobDistance(cliff1ID, 4.0);
	rmSetAreaMaxBlobDistance(cliff1ID, 6.0);
	rmSetAreaCoherence(cliff1ID, 0.4);
	rmSetAreaSmoothDistance(cliff1ID, 8);
	rmSetAreaLocation(cliff1ID, rmRandFloat(0.37, 0.38), rmRandFloat(0.83, 0.85));
	rmAddAreaConstraint(cliff1ID, avoidBorder);
	rmBuildArea(cliff1ID);
	
	// Cliff2
	int cliff2ID = rmCreateArea("cliff2");
	rmSetAreaSize(cliff2ID, 0.0046, 0.0046);
	rmSetAreaWarnFailure(cliff2ID, false);
	rmSetAreaObeyWorldCircleConstraint(cliff2ID, false);
	rmSetAreaCliffType(cliff2ID, "araucania north coast"); // araucania north coast
//	rmSetAreaCliffPainting(cliff2ID, false, true, true, 0.5 , true); //  paintGround,  paintOutsideEdge,  paintSide,  minSideHeight,  paintInsideEdge
	rmSetAreaTerrainType(cliff2ID, "texas\cliff_top_tex");
	rmSetAreaCliffHeight(cliff2ID, 5, 0.0, 0.4); 
	rmSetAreaCliffEdge(cliff2ID, 1, 1.0, 0.0, 0.0, 1); 
	rmAddAreaToClass(cliff2ID, rmClassID("Cliffs"));
//	rmAddAreaInfluencePoint(cliff2ID, 0.4, 0.86);
	rmSetAreaMinBlobs(cliff2ID, 3);
	rmSetAreaMaxBlobs(cliff2ID, 5);
	rmSetAreaMinBlobDistance(cliff2ID, 4.0);
	rmSetAreaMaxBlobDistance(cliff2ID, 6.0);
	rmSetAreaCoherence(cliff2ID, 0.4);
	rmSetAreaSmoothDistance(cliff2ID, 8);
	rmSetAreaLocation(cliff2ID, rmRandFloat(0.17, 0.15), rmRandFloat(0.63, 0.62));
	rmAddAreaConstraint(cliff2ID, avoidBorder);
	rmBuildArea(cliff2ID);

	//River
	int riverID = rmRiverCreate(-1, "pampas river", 8, 8, 4.5, 4.5); //  
	rmRiverAddWaypoint(riverID, 1.00, 0.58); 
//	rmRiverAddWaypoint(riverID, 0.70, 0.40); 
	rmRiverAddWaypoint(riverID, 0.64, 0.36); 
//	rmRiverAddWaypoint(riverID, 0.40, 0.30);
	rmRiverAddWaypoint(riverID, 0.42, 0.00);
//	rmRiverSetBankNoiseParams(riverID, 0.00, 0, 0.0, 0.0, 0.0, 0.0);
	rmRiverSetShallowRadius(riverID, 8);
	rmRiverAddShallow(riverID, 0.20);
	rmRiverAddShallow(riverID, 0.50);
	rmRiverAddShallow(riverID, 0.80);
	rmRiverBuild(riverID);
	
	// Grass zone
	int grasszoneID = rmCreateArea("grass zone");
	rmSetAreaSize(grasszoneID, 0.60, 0.60); // rmAreaTilesToFraction(5000), rmAreaTilesToFraction(5000));  
	rmSetAreaWarnFailure(grasszoneID, false);
	rmSetAreaObeyWorldCircleConstraint(grasszoneID, false);
	rmSetAreaMix(grasszoneID, "texas_grass");
	rmAddAreaTerrainLayer(grasszoneID, "pampas\ground6_pam", 0, 1);
	rmSetAreaCoherence(grasszoneID, 1.0);
	rmSetAreaLocation (grasszoneID, 0.9, 0.1);
	rmSetAreaBaseHeight(grasszoneID, 4.0);
	rmSetAreaElevationType(grasszoneID, cElevTurbulence);
	rmSetAreaElevationVariation(grasszoneID, 3.5);
	rmSetAreaElevationMinFrequency(grasszoneID, 0.05);
	rmSetAreaElevationOctaves(grasszoneID, 3);
	rmSetAreaElevationPersistence(grasszoneID, 0.45);
	rmAddAreaConstraint (grasszoneID, avoidImpassableLand);
	rmBuildArea(grasszoneID);
	
	int avoidGrasszone = rmCreateAreaDistanceConstraint("avoid grass zone", grasszoneID, 6);
	int avoidGrasszoneFar = rmCreateAreaDistanceConstraint("avoid grass zone far", grasszoneID, 10);
	int stayInGrasszone = rmCreateAreaMaxDistanceConstraint("stay in grass zone", grasszoneID, 0);
	
	// Patches in the plateau
	for (i=0; < 10)
    {
        int patch1ID = rmCreateArea("plateau patch"+i);
        rmSetAreaWarnFailure(patch1ID, false);
		rmSetAreaObeyWorldCircleConstraint(patch1ID, false);
        rmSetAreaSize(patch1ID, rmAreaTilesToFraction(60), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(patch1ID, "texas\ground5_tex");
		rmPaintAreaTerrain(patch1ID);
        rmAddAreaToClass(patch1ID, rmClassID("patch"));
        rmSetAreaMinBlobs(patch1ID, 1);
        rmSetAreaMaxBlobs(patch1ID, 5);
        rmSetAreaMinBlobDistance(patch1ID, 16.0);
        rmSetAreaMaxBlobDistance(patch1ID, 40.0);
        rmSetAreaCoherence(patch1ID, 0.0);
		rmAddAreaConstraint(patch1ID, avoidImpassableLandShort);
		rmAddAreaConstraint(patch1ID, avoidPatch);
		rmAddAreaConstraint(patch1ID, stayInPlateau);
		rmAddAreaConstraint(patch1ID, avoidCliff);
        rmBuildArea(patch1ID); 
    }
	
	// Patches in the grasszone
	for (i=0; < 8)
    {
        int patch2ID = rmCreateArea("grasszone patch"+i);
        rmSetAreaWarnFailure(patch2ID, false);
		rmSetAreaObeyWorldCircleConstraint(patch2ID, false);
        rmSetAreaSize(patch2ID, rmAreaTilesToFraction(60), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(patch2ID, "texas\ground2_tex");
		rmPaintAreaTerrain(patch2ID);
        rmAddAreaToClass(patch2ID, rmClassID("patch2"));
        rmSetAreaMinBlobs(patch2ID, 1);
        rmSetAreaMaxBlobs(patch2ID, 5);
        rmSetAreaMinBlobDistance(patch2ID, 16.0);
        rmSetAreaMaxBlobDistance(patch2ID, 40.0);
        rmSetAreaCoherence(patch2ID, 0.0);
		rmAddAreaConstraint(patch2ID, avoidImpassableLand);
		rmAddAreaConstraint(patch2ID, avoidPatch2);
		rmAddAreaConstraint(patch2ID, stayInGrasszone);
        rmBuildArea(patch2ID); 
    }
	
	// Patches in the main area
	for (i=0; < 10)
    {
        int patch3ID = rmCreateArea("main area patch"+i);
        rmSetAreaWarnFailure(patch3ID, false);
		rmSetAreaObeyWorldCircleConstraint(patch3ID, false);
        rmSetAreaSize(patch3ID, rmAreaTilesToFraction(60), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(patch3ID, "pampas\ground6_pam");
		rmPaintAreaTerrain(patch3ID);
        rmAddAreaToClass(patch3ID, rmClassID("patch3"));
        rmSetAreaMinBlobs(patch3ID, 1);
        rmSetAreaMaxBlobs(patch3ID, 5);
        rmSetAreaMinBlobDistance(patch3ID, 16.0);
        rmSetAreaMaxBlobDistance(patch3ID, 40.0);
        rmSetAreaCoherence(patch3ID, 0.0);
		rmAddAreaConstraint(patch3ID, avoidImpassableLandShort);
		rmAddAreaConstraint(patch3ID, avoidPatch3);
		rmAddAreaConstraint(patch3ID, avoidPlateau);
		rmAddAreaConstraint(patch3ID, avoidGrasszone);
        rmBuildArea(patch3ID); 
    }
	
	// Players area
	for (i=1; < numPlayer)
	{
	int playerareaID = rmCreateArea("playerarea"+i);
	rmSetPlayerArea(i, playerareaID);
	rmSetAreaSize(playerareaID, 0.06, 0.06);
	rmSetAreaCoherence(playerareaID, 1.0);
	rmSetAreaWarnFailure(playerareaID, false);
//	rmSetAreaMix(playerareaID, "rockies_snow");
	rmSetAreaLocPlayer(playerareaID, i);
	rmBuildArea(playerareaID);
	int avoidPlayerArea = rmCreateAreaDistanceConstraint("avoid player area "+i, playerareaID, 2.0);
	int stayInPlayerArea = rmCreateAreaMaxDistanceConstraint("stay in player area "+i, playerareaID, 0.0);
	}

	// ******************************************************************************************************
	
	// Text
	rmSetStatusText("",0.40);
	
	// ******************************************** NATIVES *************************************************

	int nativeID0 = -1;
    int nativeID1 = -1;
	int nativeID2 = -1;
    int nativeID3 = -1;
		
	nativeID0 = rmCreateGrouping("Incan village 1", "native inca village 0"+3); //+5
    rmSetGroupingMinDistance(nativeID0, 0.00);
    rmSetGroupingMaxDistance(nativeID0, 0.00);
//	rmAddGroupingConstraint(nativeID0, avoidImpassableLand);
	rmAddGroupingToClass(nativeID0, rmClassID("natives"));
//  rmAddGroupingToClass(nativeID0, rmClassID("importantItem"));
//	rmAddGroupingConstraint(nativeID0, avoidNatives);
	rmPlaceGroupingAtLoc(nativeID0, 0, 0.38, 0.48);
	
	nativeID2 = rmCreateGrouping("Incan village 2", "native inca village 0"+2); //+1
    rmSetGroupingMinDistance(nativeID2, 0.00);
    rmSetGroupingMaxDistance(nativeID2, 0.00);
//	rmAddGroupingConstraint(nativeID2, avoidImpassableLand);
	rmAddGroupingToClass(nativeID2, rmClassID("natives"));
//  rmAddGroupingToClass(nativeID2, rmClassID("importantItem"));
//	rmAddGroupingConstraint(nativeID2, avoidNatives);
	rmPlaceGroupingAtLoc(nativeID2, 0, 0.52, 0.62);
	
	nativeID1 = rmCreateGrouping("Mapuche village 1", "native mapuche village "+2);
    rmSetGroupingMinDistance(nativeID1, 0.00);
    rmSetGroupingMaxDistance(nativeID1, 0.00);
//  rmAddGroupingConstraint(nativeID1, avoidImpassableLand);
	rmAddGroupingToClass(nativeID1, rmClassID("natives"));
//  rmAddGroupingToClass(nativeID1, rmClassID("importantItem"));
//	rmAddGroupingConstraint(nativeID1, avoidNatives);
	rmPlaceGroupingAtLoc(nativeID1, 0, 0.68, 0.16); // 0.28, 0.25
	
	nativeID3 = rmCreateGrouping("Mapuche village 2", "native mapuche village "+5);
    rmSetGroupingMinDistance(nativeID3, 0.00);
    rmSetGroupingMaxDistance(nativeID3, 0.00);
//  rmAddGroupingConstraint(nativeID3, avoidImpassableLand);
	rmAddGroupingToClass(nativeID3, rmClassID("natives"));
//  rmAddGroupingToClass(nativeID3, rmClassID("importantItem"));
//	rmAddGroupingConstraint(nativeID3, avoidNatives);
	rmPlaceGroupingAtLoc(nativeID3, 0, 0.84, 0.32); // 0.28, 0.75
	
	// ******************************************************************************************************
	
	// Text
	rmSetStatusText("",0.50);
	
	// ************************************ PLAYER STARTING RESOURCES ***************************************

	// ******** Define ********

	// Town center & units
	int TCID = rmCreateObjectDef("player TC");
	int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	else
	{
	rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
	rmAddObjectDefToClass(TCID, classStartingResource);
	}
	rmSetObjectDefMinDistance(TCID, 0.0);
	rmSetObjectDefMaxDistance(TCID, 0.0);
	
	// Starting mines
	int playergoldID = rmCreateObjectDef("player mine");
	rmAddObjectDefItem(playergoldID, "mine", 1, 0);
	rmSetObjectDefMinDistance(playergoldID, 12.0);
	rmSetObjectDefMaxDistance(playergoldID, 14.0);
	rmAddObjectDefToClass(playergoldID, classStartingResource);
	rmAddObjectDefToClass(playergoldID, classGold);
	rmAddObjectDefConstraint(playergoldID, avoidImpassableLand);
	rmAddObjectDefConstraint(playergoldID, avoidNatives);
	rmAddObjectDefConstraint(playergoldID, avoidStartingResources);
	
	// 2nd mine
	int playergold2ID = rmCreateObjectDef("player second mine");
	rmAddObjectDefItem(playergold2ID, "mine", 1, 0);
	rmSetObjectDefMinDistance(playergold2ID, 20.0); //58
	rmSetObjectDefMaxDistance(playergold2ID, 22.0); //62
//	rmAddObjectDefToClass(playergold2ID, classStartingResource);
	rmAddObjectDefToClass(playergold2ID, classGold);
	rmAddObjectDefConstraint(playergold2ID, avoidImpassableLand);
	rmAddObjectDefConstraint(playergold2ID, avoidNatives);
	rmAddObjectDefConstraint(playergold2ID, avoidGoldType);
	rmAddObjectDefConstraint(playergold2ID, avoidStartingResources);
//	rmAddObjectDefConstraint(playergold2ID, avoidCenter);
	
/*	// Starting berries
	int playerberriesID = rmCreateObjectDef("player berries");
	rmAddObjectDefItem(playerberriesID, "berrybush", 3, 3.0);
	rmSetObjectDefMinDistance(playerberriesID, 12.0);
	rmSetObjectDefMaxDistance(playerberriesID, 14.0);
	rmAddObjectDefToClass(playerberriesID, classStartingResource);
	rmAddObjectDefConstraint(playerberriesID, avoidTradeRoute);
	rmAddObjectDefConstraint(playerberriesID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerberriesID, avoidNatives);
	rmAddObjectDefConstraint(playerberriesID, avoidStartingResources);
*/	
	// Starting trees
	int playerTreeID = rmCreateObjectDef("player trees");
	rmAddObjectDefItem(playerTreeID, "TreePolyepis", rmRandInt(1,2), 1.0);
    rmSetObjectDefMinDistance(playerTreeID, 10);
    rmSetObjectDefMaxDistance(playerTreeID, 16);
	rmAddObjectDefToClass(playerTreeID, classStartingResource);
//	rmAddObjectDefToClass(playerTreeID, classForest);
//	rmAddObjectDefConstraint(playerTreeID, avoidForestShort);
    rmAddObjectDefConstraint(playerTreeID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerTreeID, avoidStartingResourcesShort);
	
	// Starting herd
	int playerherdID = rmCreateObjectDef("starting herd");
	rmAddObjectDefItem(playerherdID, "rhea", rmRandInt(6,6), 4.0);
	rmSetObjectDefMinDistance(playerherdID, 14.0);
	rmSetObjectDefMaxDistance(playerherdID, 16.0);
	rmSetObjectDefCreateHerd(playerherdID, true);
	rmAddObjectDefToClass(playerherdID, classStartingResource);
	rmAddObjectDefConstraint(playerherdID, avoidImpassableLand);
	rmAddObjectDefConstraint(playerherdID, avoidNatives);
	rmAddObjectDefConstraint(playerherdID, avoidStartingResources);
		
	// 2nd herd
	int playerherd2ID = rmCreateObjectDef("2nd herd");
    rmAddObjectDefItem(playerherd2ID, "guanaco", rmRandInt(9,9), 6.0);
    rmSetObjectDefMinDistance(playerherd2ID, 24);
    rmSetObjectDefMaxDistance(playerherd2ID, 26);
	rmAddObjectDefToClass(playerherd2ID, classStartingResource);
	rmSetObjectDefCreateHerd(playerherd2ID, true);
	rmAddObjectDefConstraint(playerherd2ID, avoidRhea); //Short
	rmAddObjectDefConstraint(playerherd2ID, avoidImpassableLandShort);
	rmAddObjectDefConstraint(playerherd2ID, avoidNatives);
	rmAddObjectDefConstraint(playerherd2ID, avoidStartingResources);
	
/*	// 3nd herd
	int playerherd3ID = rmCreateObjectDef("3nd herd");
    rmAddObjectDefItem(playerherd3ID, "guanaco", rmRandInt(7,7), 5.0);
    rmSetObjectDefMinDistance(playerherd3ID, 45);
    rmSetObjectDefMaxDistance(playerherd3ID, 48);
	rmAddObjectDefToClass(playerherd3ID, classStartingResource);
	rmSetObjectDefCreateHerd(playerherd3ID, true);
	rmAddObjectDefConstraint(playerherd3ID, avoidRhea); //Short
	rmAddObjectDefConstraint(playerherd3ID, avoidGuanaco);
	rmAddObjectDefConstraint(playerherd3ID, avoidImpassableLandShort);
	rmAddObjectDefConstraint(playerherd3ID, avoidNatives);
	rmAddObjectDefConstraint(playerherd3ID, avoidStartingResources);
*/
	
	// Starting treasures
	int playerNuggetID = rmCreateObjectDef("player nugget"); 
	rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
	rmSetNuggetDifficulty(1, 1);
	rmSetObjectDefMinDistance(playerNuggetID, 22.0);
	rmSetObjectDefMaxDistance(playerNuggetID, 28.0);
	rmAddObjectDefToClass(playerNuggetID, classStartingResource);
	rmAddAreaConstraint(playerNuggetID, avoidGoldTypeMin);
	rmAddObjectDefConstraint(playerNuggetID, avoidImpassableLandShort);
	rmAddObjectDefConstraint(playerNuggetID, avoidNatives);
	rmAddObjectDefConstraint(playerNuggetID, avoidStartingResources);
	rmAddObjectDefConstraint(playerNuggetID, avoidNuggetShort);
	rmAddObjectDefConstraint(playerNuggetID, avoidEdge);
		
	// ******** Place ********
	
	for(i=1; <numPlayer)
	{
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));

		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergoldID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playergold2ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
//		rmPlaceObjectDefAtLoc(playerberriesID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerherdID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerherd2ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
//		rmPlaceObjectDefAtLoc(playerherd3ID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerNuggetID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerNuggetID, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
				
		if(ypIsAsian(i) && rmGetNomadStart() == false)
		rmPlaceObjectDefAtLoc(ypMonasteryBuilder(i, 1), i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
	}

	// ************************************************************************************************
	
	// Text
	rmSetStatusText("",0.60);
	
	// ************************************** COMMON RESOURCES ****************************************
  
   
	// ********** Mines ***********
	
		int westgoldcount = rmRandInt(3,3);  // 3,3 
		int eastgoldcount = rmRandInt(2,2);  // 3,3 
		int centralgoldcount = rmRandInt(2,2);
	
	//West mines
	for(i=0; < westgoldcount)
	{
		int westgoldID = rmCreateObjectDef("gold west plateau"+i);
		rmAddObjectDefItem(westgoldID, "Mine", 1, 0.0);
		rmSetObjectDefMinDistance(westgoldID, rmXFractionToMeters(0.0));
		rmSetObjectDefMaxDistance(westgoldID, rmXFractionToMeters(0.4));
		rmAddObjectDefToClass(westgoldID, classGold);
		rmAddObjectDefConstraint(westgoldID, avoidImpassableLandFar);
		rmAddObjectDefConstraint(westgoldID, avoidNatives);
		rmAddObjectDefConstraint(westgoldID, avoidGoldFar);
		rmAddObjectDefConstraint(westgoldID, avoidTownCenterFar);
		rmAddObjectDefConstraint(westgoldID, avoidEdge);
		rmAddObjectDefConstraint(westgoldID, avoidCliffFar);
		rmAddObjectDefConstraint(westgoldID, avoidRamp);
		rmAddObjectDefConstraint(westgoldID, stayInPlateau);
		rmPlaceObjectDefAtLoc(westgoldID, 0, 0.10, 0.90);
	}
	
	//East mines
	for(i=0; < eastgoldcount)
	{
		int eastgoldID = rmCreateObjectDef("gold east grasszone"+i);
		rmAddObjectDefItem(eastgoldID, "Mine", 1, 0.0);
		rmSetObjectDefMinDistance(eastgoldID, rmXFractionToMeters(0.20));
		rmSetObjectDefMaxDistance(eastgoldID, rmXFractionToMeters(0.4));
		rmAddObjectDefToClass(eastgoldID, classGold);
		rmAddObjectDefConstraint(eastgoldID, avoidImpassableLandFar);
		rmAddObjectDefConstraint(eastgoldID, avoidNativesFar);
		rmAddObjectDefConstraint(eastgoldID, avoidGoldVeryFar);
		rmAddObjectDefConstraint(eastgoldID, avoidTownCenterFar);
		rmAddObjectDefConstraint(eastgoldID, avoidEdge);
		rmAddObjectDefConstraint(eastgoldID, avoidWater);
		rmAddObjectDefConstraint(eastgoldID, stayInGrasszone);
		rmPlaceObjectDefAtLoc(eastgoldID, 0, 0.85, 0.15);
	}
	
	//Central mines
	for(i=0; < centralgoldcount)
	{
		int centralgoldID = rmCreateObjectDef("gold center"+i);
		rmAddObjectDefItem(centralgoldID, "Mine", 1, 0.0);
		rmSetObjectDefMinDistance(centralgoldID, rmXFractionToMeters(0.0));
		rmSetObjectDefMaxDistance(centralgoldID, rmXFractionToMeters(0.4));
		rmAddObjectDefToClass(centralgoldID, classGold);
		rmAddObjectDefConstraint(centralgoldID, avoidImpassableLand);
		rmAddObjectDefConstraint(centralgoldID, avoidNatives);
		rmAddObjectDefConstraint(centralgoldID, avoidGoldFar);
		rmAddObjectDefConstraint(centralgoldID, avoidTownCenterVeryFar);
		rmAddObjectDefConstraint(centralgoldID, avoidEdge);
		rmAddObjectDefConstraint(centralgoldID, avoidGrasszone);
		rmAddObjectDefConstraint(centralgoldID, avoidRamp);
		rmAddObjectDefConstraint(centralgoldID, avoidPlateau);
		rmPlaceObjectDefAtLoc(centralgoldID, 0, 0.48, 0.52);
	}
		
	// ****************************
	
	// Text
	rmSetStatusText("",0.70);
	
	// ********** Forest **********
	
	// River forest
	int riverforestcount = 10;
	int stayInRiverForest = -1;
	
	for (i=0; < riverforestcount)
	{
		int riverforestID = rmCreateArea("river forest"+i);
		rmSetAreaWarnFailure(riverforestID, false);
		rmSetAreaSize(riverforestID, rmAreaTilesToFraction(60), rmAreaTilesToFraction(80));
		rmSetAreaTerrainType(riverforestID, "pampas\groundforest_pam");
		rmSetAreaObeyWorldCircleConstraint(riverforestID, false);
		rmSetAreaMinBlobs(riverforestID, 1);
		rmSetAreaMaxBlobs(riverforestID, 5);
		rmSetAreaMinBlobDistance(riverforestID, 16.0);
		rmSetAreaMaxBlobDistance(riverforestID, 40.0);
		rmSetAreaCoherence(riverforestID, 0.0);
		rmSetAreaSmoothDistance(riverforestID, 5);
		rmAddAreaToClass(riverforestID, classForest);
		rmAddAreaConstraint(riverforestID, avoidForestShort);
		rmAddAreaConstraint(riverforestID, avoidGoldTypeMin);
		rmAddAreaConstraint(riverforestID, avoidNatives);
		rmAddAreaConstraint(riverforestID, avoidImpassableLandMin);
		rmAddAreaConstraint(riverforestID, stayNearWater);
		rmAddAreaConstraint(riverforestID, avoidPlateauFar);
		rmBuildArea(riverforestID);
		
		stayInRiverForest = rmCreateAreaMaxDistanceConstraint("stay in river forest"+i, riverforestID, 0);
		
		for (j=0; < rmRandInt(10,11))
		{
			int riverforesttreeID = rmCreateObjectDef("river forest trees"+i+j);
			rmAddObjectDefItem(riverforesttreeID, "TreePolyepis", rmRandInt(1,2), 2.0);
			rmSetObjectDefMinDistance(riverforesttreeID,  rmXFractionToMeters(0.0));
			rmSetObjectDefMaxDistance(riverforesttreeID,  rmXFractionToMeters(0.5));
			rmAddObjectDefToClass(riverforesttreeID, classForest);
		//	rmAddObjectDefConstraint(riverforesttreeID, avoidForestShort);
			rmAddObjectDefConstraint(riverforesttreeID, avoidImpassableLandShort);
			rmAddObjectDefConstraint(riverforesttreeID, stayInRiverForest);	
			rmPlaceObjectDefAtLoc(riverforesttreeID, 0, 0.50, 0.50);
		}
	}
	
	// Tree clumps on grass zone
	int grasszonetreecount = 8;
	
	for (i=0; < grasszonetreecount)
	{
		int grasszonetreeID = rmCreateArea("grasszone tree"+i);
		rmSetAreaWarnFailure(grasszonetreeID, false);
		rmSetAreaSize(grasszonetreeID, rmAreaTilesToFraction(25), rmAreaTilesToFraction(45));
		rmSetAreaForestType(grasszonetreeID, "pampas forest");
		rmSetAreaObeyWorldCircleConstraint(grasszonetreeID, false);
		rmSetAreaForestDensity(grasszonetreeID, 0.80);
		rmSetAreaForestClumpiness(grasszonetreeID, 0.60);
		rmSetAreaForestUnderbrush(grasszonetreeID, 0.4);
		rmSetAreaMinBlobs(grasszonetreeID, 1);
		rmSetAreaMaxBlobs(grasszonetreeID, 5);
		rmSetAreaMinBlobDistance(grasszonetreeID, 10.0);
		rmSetAreaMaxBlobDistance(grasszonetreeID, 30.0);
		rmSetAreaCoherence(grasszonetreeID, 0.1);
		rmSetAreaSmoothDistance(grasszonetreeID, 4);
		rmAddAreaToClass(grasszonetreeID, classForest);
		rmAddAreaConstraint(grasszonetreeID, avoidForestShort);
		rmAddAreaConstraint(grasszonetreeID, avoidGoldTypeMin);
		rmAddAreaConstraint(grasszonetreeID, avoidNatives);
		rmAddAreaConstraint(grasszonetreeID, avoidImpassableLand);
		rmAddAreaConstraint(grasszonetreeID, stayInGrasszone);
		rmBuildArea(grasszonetreeID);
	}
	
	// Main forest patches
	int mainforestcount = 13;
	int stayInForestPatch = -1;
	
	for (i=0; < mainforestcount)
    {
        int forestpatchID = rmCreateArea("main forest patch"+i);
        rmSetAreaWarnFailure(forestpatchID, false);
		rmSetAreaObeyWorldCircleConstraint(forestpatchID, false);
        rmSetAreaSize(forestpatchID, rmAreaTilesToFraction(60), rmAreaTilesToFraction(90));
		rmSetAreaTerrainType(forestpatchID, "pampas\groundforest_pam");
		rmPaintAreaTerrain(forestpatchID);
//        rmAddAreaToClass(forestpatchID, rmClassID("patch4"));
		rmAddAreaToClass(forestpatchID, classForest);
        rmSetAreaMinBlobs(forestpatchID, 2);
        rmSetAreaMaxBlobs(forestpatchID, 5);
        rmSetAreaMinBlobDistance(forestpatchID, 16.0);
        rmSetAreaMaxBlobDistance(forestpatchID, 40.0);
        rmSetAreaCoherence(forestpatchID, 0.0);
		rmSetAreaSmoothDistance(forestpatchID, 5);
		rmAddAreaConstraint(forestpatchID, avoidImpassableLandShort);
		rmAddAreaConstraint(forestpatchID, avoidNatives);
//		rmAddAreaConstraint(forestpatchID, avoidPatch4);
		rmAddAreaConstraint(forestpatchID, avoidPlateau);
		rmAddAreaConstraint(forestpatchID, avoidGrasszone);
		rmAddAreaConstraint(forestpatchID, avoidForest);
		rmAddAreaConstraint(forestpatchID, avoidTownCenterMed);
		rmAddAreaConstraint(forestpatchID, avoidRamp);
		rmAddAreaConstraint(forestpatchID, avoidGoldTypeMin);
        rmBuildArea(forestpatchID); 
		
		stayInForestPatch = rmCreateAreaMaxDistanceConstraint("stay in forest patch"+i, forestpatchID, 0.0);
		
		for (j=0; < rmRandInt(12,13))
		{
			int foresttreeID = rmCreateObjectDef("forest trees"+i+j);
			rmAddObjectDefItem(foresttreeID, "TreePolyepis", rmRandInt(1,2), 2.0);
			rmSetObjectDefMinDistance(foresttreeID,  rmXFractionToMeters(0.0));
			rmSetObjectDefMaxDistance(foresttreeID,  rmXFractionToMeters(0.5));
		//	rmAddObjectDefToClass(foresttreeID, classForest);
		//	rmAddObjectDefConstraint(foresttreeID, avoidForestShort);
			rmAddObjectDefConstraint(foresttreeID, avoidImpassableLandShort);
			rmAddObjectDefConstraint(foresttreeID, stayInForestPatch);	
			rmPlaceObjectDefAtLoc(foresttreeID, 0, 0.50, 0.50);
		}
    }
	
	// Isolated trees on plateau
	for (i=0; < 10)
		{
			int plateautreeID = rmCreateObjectDef("plateau trees"+i+j);
			rmAddObjectDefItem(plateautreeID, "TreePolyepis", rmRandInt(2,5), 4.0);
			rmSetObjectDefMinDistance(plateautreeID,  rmXFractionToMeters(0.0));
			rmSetObjectDefMaxDistance(plateautreeID,  rmXFractionToMeters(0.5));
			rmAddObjectDefToClass(plateautreeID, classForest);
			rmAddObjectDefConstraint(plateautreeID, avoidForestShort);
			rmAddObjectDefConstraint(plateautreeID, avoidGoldTypeMin);
			rmAddObjectDefConstraint(plateautreeID, avoidImpassableLandShort);
			rmAddObjectDefConstraint(plateautreeID, avoidRamp);
			rmAddObjectDefConstraint(plateautreeID, avoidCliffMed);
			rmAddObjectDefConstraint(plateautreeID, stayInPlateau);	
			rmPlaceObjectDefAtLoc(plateautreeID, 0, 0.50, 0.50);
		}
	
	// ********************************
	
	// Text
	rmSetStatusText("",0.80);
	
	// ************ Herds *************

	//Central herds
	int centralherdcount = 7;
	
	for(i=0; < centralherdcount)
	{
		int centralguanacoID = rmCreateObjectDef("central herd"+i);
		rmAddObjectDefItem(centralguanacoID, "guanaco", rmRandInt(7,7), 5.0);
		rmSetObjectDefMinDistance(centralguanacoID, rmXFractionToMeters(0.0));
		rmSetObjectDefMaxDistance(centralguanacoID, rmXFractionToMeters(0.5));
		rmSetObjectDefCreateHerd(centralguanacoID, true);
		rmAddObjectDefConstraint(centralguanacoID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(centralguanacoID, avoidNatives);
		rmAddObjectDefConstraint(centralguanacoID, avoidGoldTypeShort);
		rmAddObjectDefConstraint(centralguanacoID, avoidForestMin);
		rmAddObjectDefConstraint(centralguanacoID, avoidPlateau);
		rmAddObjectDefConstraint(centralguanacoID, avoidRamp);
		rmAddObjectDefConstraint(centralguanacoID, avoidGrasszoneFar);
		rmAddObjectDefConstraint(centralguanacoID, avoidTownCenter);
		rmAddObjectDefConstraint(centralguanacoID, avoidGuanacoFar); 
	//	rmAddObjectDefConstraint(centralguanacoID, avoidEdge);
		if (i < 2)
			rmAddObjectDefConstraint(centralguanacoID, stayTop); 
		else if (i < 4)
			rmAddObjectDefConstraint(centralguanacoID, stayBottom); 
		else
			rmAddObjectDefConstraint(centralguanacoID, stayCenter);
		rmPlaceObjectDefAtLoc(centralguanacoID, 0, 0.50, 0.50);
	}
	
	//Plateau herds
	int plateauherdcount = 3;
	
	for(i=0; < plateauherdcount)
	{
		int westguanacoID = rmCreateObjectDef("plateau herd"+i);
		rmAddObjectDefItem(westguanacoID, "guanaco", rmRandInt(7,7), 5.0);
		rmSetObjectDefMinDistance(westguanacoID, rmXFractionToMeters(0.0));
		rmSetObjectDefMaxDistance(westguanacoID, rmXFractionToMeters(0.5));
		rmSetObjectDefCreateHerd(westguanacoID, true);
		rmSetObjectDefMaxDistance(westguanacoID, rmXFractionToMeters(0.5));
		if (i < 1)
			rmAddObjectDefConstraint(westguanacoID, stayTop);
		else if (i < 2)
			rmAddObjectDefConstraint(westguanacoID, stayBottom);
		rmAddObjectDefConstraint(westguanacoID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(westguanacoID, avoidNatives);
		rmAddObjectDefConstraint(westguanacoID, avoidGoldTypeShort);
		rmAddObjectDefConstraint(westguanacoID, avoidForestMin);
		rmAddObjectDefConstraint(westguanacoID, stayInPlateau);
		rmAddObjectDefConstraint(westguanacoID, avoidRamp);
		rmAddObjectDefConstraint(westguanacoID, avoidCliff);
		rmAddObjectDefConstraint(westguanacoID, avoidTownCenterFar);
		rmAddObjectDefConstraint(westguanacoID, avoidGuanacoFar); 
	//	rmAddObjectDefConstraint(westguanacoID, avoidEdge);
		rmPlaceObjectDefAtLoc(westguanacoID, 0, 0.2, 0.8);
	}
	
	//Grasszone herds
	int grasszoneherdcount = 3;
	
	for(i=0; < grasszoneherdcount)
	{
		int eastrheaID = rmCreateObjectDef("grasszone herd"+i);
		rmAddObjectDefItem(eastrheaID, "rhea", rmRandInt(8,8), 5.0);
		rmSetObjectDefMinDistance(eastrheaID, rmXFractionToMeters(0.0));
		rmSetObjectDefMaxDistance(eastrheaID, rmXFractionToMeters(0.5));
		rmSetObjectDefCreateHerd(eastrheaID, true);
		if (i < 1)
			rmAddObjectDefConstraint(eastrheaID, stayTop);
		else if (i < 2)
			rmAddObjectDefConstraint(eastrheaID, stayBottom);
		rmAddObjectDefConstraint(eastrheaID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(eastrheaID, avoidNatives);
		rmAddObjectDefConstraint(eastrheaID, avoidGoldTypeShort);
		rmAddObjectDefConstraint(eastrheaID, avoidForestMin);
		rmAddObjectDefConstraint(eastrheaID, stayInGrasszone);
		rmAddObjectDefConstraint(eastrheaID, avoidTownCenterFar);
		rmAddObjectDefConstraint(eastrheaID, avoidGuanaco); 
		rmAddObjectDefConstraint(eastrheaID, avoidRheaFar);
	//	rmAddObjectDefConstraint(eastrheaID, avoidEdge);
		rmPlaceObjectDefAtLoc(eastrheaID, 0, 0.90, 0.10);
	}
	

	// ********************************
		
	// Text
	rmSetStatusText("",0.90);
	
	// ********** Random trees to fill **********
	
	// Random trees in the middle
	for (i=0; < 10)
		{
			int randomtreeID = rmCreateObjectDef("random trees"+i);
			rmAddObjectDefItem(randomtreeID, "TreePolyepis", rmRandInt(1,3), 5.0);
			rmSetObjectDefMinDistance(randomtreeID,  rmXFractionToMeters(0.0));
			rmSetObjectDefMaxDistance(randomtreeID,  rmXFractionToMeters(0.5));
			rmAddObjectDefToClass(randomtreeID, classForest);
			rmAddObjectDefConstraint(randomtreeID, avoidNatives);
			rmAddObjectDefConstraint(randomtreeID, avoidForestShort);
			rmAddObjectDefConstraint(randomtreeID, avoidImpassableLandShort);
			rmAddObjectDefConstraint(randomtreeID, avoidRamp);
			rmAddObjectDefConstraint(randomtreeID, avoidPlateau);	
			rmAddObjectDefConstraint(randomtreeID, avoidGrasszone);
			rmAddObjectDefConstraint(randomtreeID, avoidTownCenterShort);
			rmAddObjectDefConstraint(randomtreeID, avoidGoldTypeMin);
			rmAddObjectDefConstraint(randomtreeID, avoidGuanacoMin);
			rmAddObjectDefConstraint(randomtreeID, avoidStartingResources);
			rmPlaceObjectDefAtLoc(randomtreeID, 0, 0.50, 0.50);
		}
	
	// ********************************

	// ********** Treasures ***********
	
	// Treasures 	
	int NuggetID = rmCreateObjectDef("Nugget"); 
	rmAddObjectDefItem(NuggetID, "Nugget", 1, 0.0);
	rmSetObjectDefMinDistance(NuggetID, 0);
    rmSetObjectDefMaxDistance(NuggetID, rmXFractionToMeters(0.5));
	rmSetNuggetDifficulty(2,2);
	rmAddObjectDefConstraint(NuggetID, avoidNugget);
	rmAddObjectDefConstraint(NuggetID, avoidNatives);
	rmAddObjectDefConstraint(NuggetID, avoidPlateau);
	rmAddObjectDefConstraint(NuggetID, avoidRamp); 
	rmAddObjectDefConstraint(NuggetID, avoidImpassableLand);
	rmAddObjectDefConstraint(NuggetID, avoidGoldTypeMin);
	rmAddObjectDefConstraint(NuggetID, avoidGuanacoMin);
	rmAddObjectDefConstraint(NuggetID, avoidTownCenterFar);
	rmAddObjectDefConstraint(NuggetID, avoidForestMin);	
	rmAddObjectDefConstraint(NuggetID, avoidEdge); 
	
	int nuggetcount = 8;
	
	for (i=0; < nuggetcount)
	{
		rmPlaceObjectDefAtLoc(NuggetID, 0, 0.50, 0.50);
	}
		
	// ********************************
	
	// Text
	rmSetStatusText("",0.95);
	
	// ************ Lamas *************
	
	int LamaID = rmCreateObjectDef("llama");
	rmAddObjectDefItem(LamaID, "llama", 1, 1.0);
	rmSetObjectDefMinDistance(LamaID, 0.0);
	rmSetObjectDefMaxDistance(LamaID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(LamaID, avoidCliff);
	rmAddObjectDefConstraint(LamaID, avoidRamp);
	rmAddObjectDefConstraint(LamaID, avoidImpassableLandShort);
	rmAddObjectDefConstraint(LamaID, stayInPlateau);
	rmAddObjectDefConstraint(LamaID, avoidEdge);
	rmAddObjectDefConstraint(LamaID, avoidLama);
	rmAddObjectDefConstraint(LamaID, avoidTownCenterFar);
	rmAddObjectDefConstraint(LamaID, avoidForestMin);
	
	int lamacount = 8;
	
	for (i=0; <lamacount)
	{
		rmPlaceObjectDefAtLoc(LamaID, 0, 0.5, 0.5);
	}

	// ********************************
	
	// ******** Embellishments ********
	
	// Grasszone underbrush
	for (i=0; < 20)
	{
		int GrasszoneunderbrushID = rmCreateObjectDef("grasszone underbrush"+i);
		rmAddObjectDefItem(GrasszoneunderbrushID, "UnderbrushPampas", rmRandInt(1,2), 2.0); 
		rmSetObjectDefMinDistance(GrasszoneunderbrushID, 0);
		rmSetObjectDefMaxDistance(GrasszoneunderbrushID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(GrasszoneunderbrushID, rmClassID("grass"));
		rmAddObjectDefConstraint(GrasszoneunderbrushID, avoidNatives);
		rmAddObjectDefConstraint(GrasszoneunderbrushID, avoidForestMin);
		rmAddObjectDefConstraint(GrasszoneunderbrushID, avoidGoldTypeMin);
		rmAddObjectDefConstraint(GrasszoneunderbrushID, avoidGrass);
		rmAddObjectDefConstraint(GrasszoneunderbrushID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(GrasszoneunderbrushID, stayInGrasszone);
		rmPlaceObjectDefAtLoc(GrasszoneunderbrushID, 0, 0.50, 0.50);
	}
	
	// Plateau underbrush
	for (i=0; < 50)
	{
		int PlateauunderbrushID = rmCreateObjectDef("plateau underbrush"+i);
		rmAddObjectDefItem(PlateauunderbrushID, "UnderbrushTexasGrass", rmRandInt(1,2), 2.0); 
		rmSetObjectDefMinDistance(PlateauunderbrushID, 0);
		rmSetObjectDefMaxDistance(PlateauunderbrushID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(PlateauunderbrushID, rmClassID("grass"));
		rmAddObjectDefConstraint(PlateauunderbrushID, avoidNatives);
		rmAddObjectDefConstraint(PlateauunderbrushID, avoidForestMin);
		rmAddObjectDefConstraint(PlateauunderbrushID, avoidGoldTypeMin);
		rmAddObjectDefConstraint(PlateauunderbrushID, avoidGrass);
		rmAddObjectDefConstraint(PlateauunderbrushID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(PlateauunderbrushID, stayInPlateau);
		rmAddObjectDefConstraint(PlateauunderbrushID, avoidCliff);
		rmPlaceObjectDefAtLoc(PlateauunderbrushID, 0, 0.50, 0.50);
	}
	
/*	// Central underbrush
	for (i=0; < 40)
	{
		int CentralundebrushID = rmCreateObjectDef("central underbrush"+i);
		rmAddObjectDefItem(CentralundebrushID, "DuneGrass", rmRandInt(1,2), 2.0); 
		rmSetObjectDefMinDistance(CentralundebrushID, 0);
		rmSetObjectDefMaxDistance(CentralundebrushID, rmXFractionToMeters(0.5));
		rmAddObjectDefToClass(CentralundebrushID, rmClassID("grass"));
		rmAddObjectDefConstraint(CentralundebrushID, avoidNatives);
		rmAddObjectDefConstraint(CentralundebrushID, avoidForestMin);
		rmAddObjectDefConstraint(CentralundebrushID, avoidGoldTypeMin);
		rmAddObjectDefConstraint(CentralundebrushID, avoidGrass);
		rmAddObjectDefConstraint(CentralundebrushID, avoidImpassableLandShort);
		rmAddObjectDefConstraint(CentralundebrushID, avoidPlateau);
		rmAddObjectDefConstraint(CentralundebrushID, avoidGrasszone);
		rmPlaceObjectDefAtLoc(CentralundebrushID, 0, 0.50, 0.50);
	}
	// ********************************
*/	
	// Text
	rmSetStatusText("",1.00);
	

	
} //END
	
	